(self.webpackChunk_N_E=self.webpackChunk_N_E||[]).push([[4370],{77745:function(e,t,n){(window.__NEXT_P=window.__NEXT_P||[]).push(["/archive/classic-updates/configuring-updates",function(){return n(28199)}])},28199:function(e,t,n){"use strict";n.r(t),n.d(t,{__N_SSG:function(){return i},headings:function(){return d},meta:function(){return s}});var a=n(85893),o=n(11151),i=!0;let s={title:"Configuring Updates"},d=[{depth:2,type:"text",title:"Automatic Updates"},{depth:2,type:"text",title:"Manual Updates"},{depth:2,type:"text",title:"Disabling Updates"}];function r(e){let t=Object.assign({blockquote:"blockquote",p:"p",a:"a",code:"code",strong:"strong",h2:"h2",pre:"pre"},(0,o.ah)(),e.components);return(0,a.jsxs)(a.Fragment,{children:[(0,a.jsxs)(t.blockquote,{children:["\n",(0,a.jsxs)(t.p,{children:["This doc was archived in August 2022 and will not receive any further updates. Please use EAS Update instead. ",(0,a.jsx)(t.a,{href:"/../../../../../../../eas-update/introduction",children:"Learn more"})]}),"\n"]}),"\n",(0,a.jsxs)(t.p,{children:["Expo provides various settings to configure how your app receives updates. Updates allow you to publish a new version of your app JavaScript and assets without building a new version of your app and re-submitting to app stores. (",(0,a.jsx)(t.a,{href:"/../../../../../../../archive/publishing/",children:"Read more about the limitations"}),")."]}),"\n",(0,a.jsxs)(t.p,{children:["To create an update of your app, run ",(0,a.jsx)(t.code,{children:"expo publish"}),". If you're using release channels, specify one with ",(0,a.jsx)(t.code,{children:"--release-channel <channel-name>"})," option. ",(0,a.jsx)(t.strong,{children:"Please note"}),"- if you wish to update the SDK version of your app, or make ",(0,a.jsx)(t.a,{href:"/../../../../../../../archive/publishing/#some-native-configuration-cant-be-updated-by",children:"any of these changes"}),", you'll need to rebuild your app with ",(0,a.jsx)(t.code,{children:"eas build"})," and upload the binary file to the appropriate app store (",(0,a.jsx)(t.a,{href:"/../../../../../../../build/setup/",children:"see the docs here"}),")."]}),"\n",(0,a.jsxs)(t.p,{children:["Updates are controlled by the ",(0,a.jsx)(t.code,{children:"updates"})," settings in app.json, which handle the initial app load, and the Updates SDK module, which allows you to fetch updates asynchronously from your JS."]}),"\n",(0,a.jsx)(t.h2,{id:"automatic-updates",children:"Automatic Updates"}),"\n",(0,a.jsxs)(t.p,{children:["If your ",(0,a.jsx)(t.strong,{children:"app.json"})," does not contain an ",(0,a.jsx)(t.code,{children:"updates.fallbackToCacheTimeout"})," field it will default to ",(0,a.jsx)(t.code,{children:"0"})," and ",(0,a.jsx)(t.code,{children:"expo-updates"})," will attempt to start your app immediately with a cached bundle while downloading a newer one in the background for future use. When using this configuration, users that download the app from a store and launch it for the first time will always see the version of the app that the binary was built against. ",(0,a.jsx)(t.code,{children:"Updates.addListener"})," provides a hook to let you respond when the new bundle is finished downloading. You can use this to notify users that they should restart the app, and you can also restart it programmatically with ",(0,a.jsx)(t.code,{children:"Updates.reloadAsync()"}),", eg: in response to a prompt to the user."]}),"\n",(0,a.jsx)(t.p,{children:"You can also set a nonzero timeout, in which case Expo will attempt to download a new update before launching the app. If there is no network connection available, or it has not finished downloading in the allotted time, Expo will fall back to loading a cached version of your app, and continue trying to fetch the update in the background (at which point it will be saved into the cache for the next app load). We strongly advise against blocking app loading on fetching an update because it can leave users with the perception that the app is not working if it takes a while to download the update, and every launch will be slower because a network request has to be made to check for an update before proceeding to the app."}),"\n",(0,a.jsxs)(t.p,{children:["In Expo Go, the latest published bundle of your app will always be launched (unless the request times out or network connection is unavailable), regardless of the ",(0,a.jsx)(t.code,{children:"updates"})," settings in your app config."]}),"\n",(0,a.jsx)(t.h2,{id:"manual-updates",children:"Manual Updates"}),"\n",(0,a.jsx)(t.p,{children:"In standalone apps, it is also possible to turn off automatic updates, and to instead control updates entirely within your JS code. This is desirable if you want some custom logic around fetching updates (e.g. only over Wi-Fi)."}),"\n",(0,a.jsxs)(t.p,{children:["Setting ",(0,a.jsx)(t.code,{children:"updates.checkAutomatically"})," to ",(0,a.jsx)(t.code,{children:'"ON_ERROR_RECOVERY"'})," in app.json will prevent Expo from automatically fetching the latest update every time your app is launched. Only the most recent cached version of your bundle will be loaded. It will only automatically fetch an update if the last run of the cached bundle produced a fatal JS error."]}),"\n",(0,a.jsxs)(t.p,{children:["You can then use the ",(0,a.jsx)(t.code,{children:"expo-updates"})," module to download new updates and, if appropriate, notify the user to reload their app."]}),"\n",(0,a.jsx)(t.pre,{children:(0,a.jsx)(t.code,{className:"language-javascript",children:"import * as Updates from 'expo-updates';\n\ntry {\n  const update = await Updates.checkForUpdateAsync();\n  if (update.isAvailable) {\n    await Updates.fetchUpdateAsync();\n    // ... notify user of update ...\n    await Updates.reloadAsync();\n  }\n} catch (e) {\n  // handle or log error\n}\n"})}),"\n",(0,a.jsx)(t.p,{children:"Checking for an update uses a device's bandwidth and battery life like any network call. Additionally, updates served by Expo may be rate limited. A good rule of thumb to check for updates judiciously is to use check when the user launches or foregrounds the app. Avoid polling for updates in a frequent loop."}),"\n",(0,a.jsxs)(t.p,{children:["Note that ",(0,a.jsx)(t.code,{children:'checkAutomatically: "ON_ERROR_RECOVERY"'})," will be ignored in Expo Go, although the imperative Updates methods will still function normally."]}),"\n",(0,a.jsx)(t.h2,{id:"disabling-updates",children:"Disabling Updates"}),"\n",(0,a.jsxs)(t.p,{children:["It is possible to entirely disable updates in an app, by setting ",(0,a.jsx)(t.code,{children:"updates.enabled"})," to ",(0,a.jsx)(t.code,{children:"false"})," in ",(0,a.jsx)(t.strong,{children:"app.json"}),". This will ignore all code paths that fetch app bundles from Expo's servers. In this case, all updates to your app will need to be routed through the iOS App Store and/or Google Play Store."]}),"\n",(0,a.jsx)(t.p,{children:"This setting is ignored in the Expo Go app."})]})}t.default=function(){let e=arguments.length>0&&void 0!==arguments[0]?arguments[0]:{},{wrapper:t}=Object.assign({},(0,o.ah)(),e.components);return t?(0,a.jsx)(t,Object.assign({},e,{children:(0,a.jsx)(r,e)})):r(e)}}},function(e){e.O(0,[49774,92888,40179],function(){return e(e.s=77745)}),_N_E=e.O()}]);