(self.webpackChunk_N_E=self.webpackChunk_N_E||[]).push([[93279],{61235:function(e,n,i){(window.__NEXT_P=window.__NEXT_P||[]).push(["/archive/classic-updates/offline-support",function(){return i(3630)}])},3630:function(e,n,i){"use strict";i.r(n),i.d(n,{__N_SSG:function(){return a},headings:function(){return r},meta:function(){return o}});var t=i(85893),s=i(11151),a=!0;let o={title:"Offline Support"},r=[{depth:2,type:"text",title:"Load JS updates in the background"},{depth:2,type:"text",title:"Cache your assets after downloading"},{depth:2,type:"text",title:"Bundle your assets inside your standalone binary"},{depth:3,type:"text",title:"EAS Build"},{depth:3,type:"text",title:"Classic builds"},{depth:2,type:"text",title:"Listen for changes in network availability"}];function d(e){let n=Object.assign({p:"p",h2:"h2",a:"a",code:"code",strong:"strong",ul:"ul",li:"li",h3:"h3",pre:"pre"},(0,s.ah)(),e.components);return(0,t.jsxs)(t.Fragment,{children:[(0,t.jsx)(n.p,{children:"Your app will encounter circumstances where the internet connection is sub-par or totally unavailable and it still needs to work reasonably well. This guide offers more information and best practices for providing a great experience while the device is offline."}),"\n",(0,t.jsx)(n.h2,{id:"load-js-updates-in-the-background",children:"Load JS updates in the background"}),"\n",(0,t.jsxs)(n.p,{children:["When you ",(0,t.jsx)(n.a,{href:"/../../../../../../../archive/classic-updates/publishing/",children:"publish"})," an update to your app, your users will receive the new version of your code in an update. The new version will download either next time the app starts, or next time you call ",(0,t.jsx)(n.a,{href:"/archive/versions/latest/sdk/updates/",children:"Updates.reload()"}),". This behavior also applies the very first time the user opens your app."]}),"\n",(0,t.jsxs)(n.p,{children:["Expo offers multiple behaviors for how it should download your JS. It can either block the UI with a ",(0,t.jsx)(n.a,{href:"/archive/classic-updates/splash-screens/",children:"splash screen"})," or ",(0,t.jsx)(n.a,{href:"/archive/versions/latest/sdk/app-loading/",children:"AppLoading component"})," until the new JS is downloaded, or it can immediately show an old version of your JS and download the update in the background. The former option is better if your users must have the latest version at all times; the latter option is better if you have a bad internet connection and need to show something right away."]}),"\n",(0,t.jsxs)(n.p,{children:["To force JS updates to run in the background (rather than synchronously checking and downloading on app start), set ",(0,t.jsx)(n.code,{children:"updates.fallbackToCacheTimeout"})," to ",(0,t.jsx)(n.code,{children:"0"})," in ",(0,t.jsx)(n.strong,{children:"app.json"}),". You can also listen to see when a new version has finished downloading. For more information, see ",(0,t.jsx)(n.a,{href:"/archive/classic-updates/configuring-updates/",children:"configuring updates"}),"."]}),"\n",(0,t.jsx)(n.h2,{id:"cache-your-assets-after-downloading",children:"Cache your assets after downloading"}),"\n",(0,t.jsxs)(n.p,{children:["By default, all of your assets (images, fonts, etc.) are ",(0,t.jsx)(n.a,{href:"/archive/classic-updates/assets/",children:"uploaded to Expo's CDN"})," when you publish updates to your app. Once they're downloaded, you can ",(0,t.jsx)(n.a,{href:"/../../../../../../../archive/classic-updates/preloading-and-caching-assets/",children:"cache them"})," so you don't need to download them a second time. If you publish changes, the cache will be invalidated and the changed version will be downloaded."]}),"\n",(0,t.jsx)(n.h2,{id:"bundle-your-assets-inside-your-standalone-binary",children:"Bundle your assets inside your standalone binary"}),"\n",(0,t.jsx)(n.p,{children:"Expo can bundle assets into your standalone binary during the build process so that they will be available immediately, even if the user has never run your app before. This is important if:"}),"\n",(0,t.jsxs)(n.ul,{children:["\n",(0,t.jsx)(n.li,{children:"Your users may not have internet the first time they open your app, or"}),"\n",(0,t.jsx)(n.li,{children:"If your app relies on a nontrivial amount of assets for the very first screen to function properly."}),"\n"]}),"\n",(0,t.jsx)(n.h3,{id:"eas-build",children:"EAS Build"}),"\n",(0,t.jsxs)(n.p,{children:["When using ",(0,t.jsx)(n.code,{children:"eas build"}),", ",(0,t.jsx)(n.code,{children:"expo publish"})," is ",(0,t.jsx)(n.strong,{children:"not"})," run as part of the build process, so the ",(0,t.jsx)(n.code,{children:"assetBundlePatterns"})," key doesn't apply in this case. Instead, any assets that are explicitly ",(0,t.jsx)(n.code,{children:"require()"}),"'d anywhere in your codebase (including in your dependencies) are bundled into your binary. This is the same behavior as with regular React Native apps built directly with Xcode or Android Studio."]}),"\n",(0,t.jsx)(n.h3,{id:"classic-builds",children:"Classic builds"}),"\n",(0,t.jsxs)(n.p,{children:["To bundle assets in your binary, use the ",(0,t.jsx)(n.a,{href:"/archive/workflow/configuration/",children:"assetBundlePatterns"})," key in ",(0,t.jsx)(n.strong,{children:"app.json"})," to provide a list of paths in your project directory:"]}),"\n",(0,t.jsx)(n.pre,{children:(0,t.jsx)(n.code,{children:'"assetBundlePatterns": [\n  "assets/images/*"\n],\n'})}),"\n",(0,t.jsxs)(n.p,{children:["Images with paths matching the given patterns will be bundled into your native binaries next time you run ",(0,t.jsx)(n.code,{children:"expo build"}),"."]}),"\n",(0,t.jsx)(n.h2,{id:"listen-for-changes-in-network-availability",children:"Listen for changes in network availability"}),"\n",(0,t.jsxs)(n.p,{children:["The React Native community created the ",(0,t.jsx)(n.a,{href:"https://github.com/react-native-netinfo/react-native-netinfo",children:(0,t.jsx)(n.code,{children:"@react-native-community/netinfo"})})," package, which informs you if your device's reachability changes. You may want to change your UI (e.g. show a banner, or disable some functions) if you notice that there's no connection available."]})]})}n.default=function(){let e=arguments.length>0&&void 0!==arguments[0]?arguments[0]:{},{wrapper:n}=Object.assign({},(0,s.ah)(),e.components);return n?(0,t.jsx)(n,Object.assign({},e,{children:(0,t.jsx)(d,e)})):d(e)}}},function(e){e.O(0,[49774,92888,40179],function(){return e(e.s=61235)}),_N_E=e.O()}]);