(self.webpackChunk_N_E=self.webpackChunk_N_E||[]).push([[41580],{69721:function(e,t,n){(window.__NEXT_P=window.__NEXT_P||[]).push(["/archive/classic-updates/updating-your-app",function(){return n(87094)}])},87094:function(e,t,n){"use strict";n.r(t),n.d(t,{__N_SSG:function(){return d},headings:function(){return r},meta:function(){return a}});var s=n(85893),i=n(11151),d=!0;let a={title:"Updating your App",sidebar_title:"Updating your App"},r=[{depth:2,type:"text",title:"Setup"},{depth:2,type:"text",title:"Served Update Requirements"},{depth:2,type:"text",title:"Update Compatibility"},{depth:3,type:"text",title:"Runtime Version"},{depth:3,type:"text",title:"Release Channels"},{depth:3,type:"text",title:"Statically Hosted Updates"},{depth:2,type:"text",title:"Embedding Assets"},{depth:2,type:"text",title:"Including Assets in Updates"},{depth:2,type:"text",title:"Configuration Options"},{depth:3,type:"text",title:"Automatic Updates"},{depth:3,type:"text",title:"Manual Updates"}];function o(e){let t=Object.assign({blockquote:"blockquote",p:"p",a:"a",code:"code",strong:"strong",h2:"h2",pre:"pre",table:"table",thead:"thead",tr:"tr",th:"th",tbody:"tbody",td:"td",h3:"h3",em:"em"},(0,i.ah)(),e.components);return(0,s.jsxs)(s.Fragment,{children:[(0,s.jsxs)(t.blockquote,{children:["\n",(0,s.jsxs)(t.p,{children:["This doc was archived in August 2022 and will not receive any further updates. Please use EAS Update instead. ",(0,s.jsx)(t.a,{href:"/../../../../../../../eas-update/introduction",children:"Learn more"})]}),"\n"]}),"\n",(0,s.jsxs)(t.p,{children:["The ",(0,s.jsx)(t.code,{children:"expo-updates"})," module provides a client-side implementation for loading updates in React Native apps. Updates allow you to deploy new JavaScript and assets to existing builds of your app without building a new binary."]}),"\n",(0,s.jsxs)(t.p,{children:["In this guide, an ",(0,s.jsx)(t.strong,{children:"update"})," refers to a single, atomic update, which may consist of a JavaScript bundle, other assets (such as images or fonts), and metadata about the update."]}),"\n",(0,s.jsx)(t.h2,{id:"setup",children:"Setup"}),"\n",(0,s.jsxs)(t.p,{children:["If possible, we highly recommend starting with a boilerplate project that has the ",(0,s.jsx)(t.code,{children:"expo-updates"})," library already installed, for example, by running: ",(0,s.jsx)(t.code,{children:"npx create-expo-app -t bare-minimum"}),"."]}),"\n",(0,s.jsxs)(t.p,{children:["To install the ",(0,s.jsx)(t.code,{children:"expo-updates"})," module in an existing bare workflow app, follow the ",(0,s.jsx)(t.a,{href:"https://github.com/expo/expo/tree/main/packages/expo-updates/README.mdx#installation",children:"installation instructions in the package README"}),"."]}),"\n",(0,s.jsxs)(t.p,{children:["Additionally, you'll need to host your updates and their respective assets (JavaScript bundles, images, fonts, etc.) on a server somewhere that deployed client apps can access. ",(0,s.jsx)(t.code,{children:"expo-cli"})," provides a couple of easy options for this: (1) ",(0,s.jsx)(t.code,{children:"expo export"})," creates prebuilt update packages that you can upload to any static hosting site (e.g. GitHub Pages), and (2) ",(0,s.jsx)(t.code,{children:"expo publish"})," packages and deploys your updates to Expo's updates service, which is part of the services we offer."]}),"\n",(0,s.jsxs)(t.p,{children:["You can also run your own server to host your updates, provided it conforms to the protocol ",(0,s.jsx)(t.code,{children:"expo-updates"})," expects. You can read more about these requirements below."]}),"\n",(0,s.jsx)(t.h2,{id:"served-update-requirements",children:"Served Update Requirements"}),"\n",(0,s.jsxs)(t.blockquote,{children:["\n",(0,s.jsxs)(t.p,{children:["If you're using ",(0,s.jsx)(t.code,{children:"expo export"})," or ",(0,s.jsx)(t.code,{children:"expo publish"}),", you're welcome to skip this section as it will be taken care of for you!"]}),"\n"]}),"\n",(0,s.jsxs)(t.p,{children:["The ",(0,s.jsx)(t.code,{children:"expo-updates"})," implementation requires a single URL (provided at build-time) to which it will make requests for new updates. These requests may happen when users launch your app in production (depending on your app's configuration settings) and when your app calls ",(0,s.jsx)(t.code,{children:"Updates.fetchUpdateAsync()"}),". Requests will be sent with the following headers:"]}),"\n",(0,s.jsx)(t.pre,{children:(0,s.jsx)(t.code,{children:"'Accept': 'application/expo+json,application/json',\n'Expo-Platform': // either 'ios' or 'android',\n'Expo-Release-Channel': // Release Channel value, if configured,\n'Expo-Runtime-Version': // Runtime Version value, if configured,\n'Expo-SDK-Version': // SDK Version value, if configured,\n"})}),"\n",(0,s.jsx)(t.p,{children:"The response to these requests should be a manifest JSON object with metadata about the latest update that's compatible with the requesting app binary. (More on compatibility below.) The manifest should have at least the following fields:"}),"\n",(0,s.jsxs)(t.table,{children:[(0,s.jsx)(t.thead,{children:(0,s.jsxs)(t.tr,{children:[(0,s.jsx)(t.th,{children:"Key"}),(0,s.jsx)(t.th,{children:"Type"}),(0,s.jsx)(t.th,{children:"Description"})]})}),(0,s.jsxs)(t.tbody,{children:[(0,s.jsxs)(t.tr,{children:[(0,s.jsx)(t.td,{children:(0,s.jsx)(t.code,{children:"releaseId"})}),(0,s.jsx)(t.td,{children:"string"}),(0,s.jsx)(t.td,{children:"A UUID uniquely identifying this update."})]}),(0,s.jsxs)(t.tr,{children:[(0,s.jsx)(t.td,{children:(0,s.jsx)(t.code,{children:"commitTime"})}),(0,s.jsx)(t.td,{children:"string"}),(0,s.jsx)(t.td,{children:"A JavaScript Date string representing the time this update was committed/published. This is used to compare two updates to determine which is newest."})]}),(0,s.jsxs)(t.tr,{children:[(0,s.jsx)(t.td,{children:(0,s.jsx)(t.code,{children:"runtimeVersion"})}),(0,s.jsx)(t.td,{children:"object"}),(0,s.jsxs)(t.td,{children:["An object with keys ",(0,s.jsx)(t.code,{children:"ios"})," and ",(0,s.jsx)(t.code,{children:"android"})," whose corresponding values are the ",(0,s.jsx)(t.a,{href:"/archive/classic-updates/updating-your-app/#runtime-version",children:"Runtime Version"})," this update is compatible with. Required only if ",(0,s.jsx)(t.code,{children:"sdkVersion"})," is not provided."]})]}),(0,s.jsxs)(t.tr,{children:[(0,s.jsx)(t.td,{children:(0,s.jsx)(t.code,{children:"sdkVersion"})}),(0,s.jsx)(t.td,{children:"string"}),(0,s.jsxs)(t.td,{children:["The Expo SDK version this update uses. Required only if ",(0,s.jsx)(t.code,{children:"runtimeVersion"})," is not provided."]})]}),(0,s.jsxs)(t.tr,{children:[(0,s.jsx)(t.td,{children:(0,s.jsx)(t.code,{children:"bundleUrl"})}),(0,s.jsx)(t.td,{children:"string"}),(0,s.jsx)(t.td,{children:"A URL pointing to the JavaScript bundle this metadata represents."})]}),(0,s.jsxs)(t.tr,{children:[(0,s.jsx)(t.td,{children:(0,s.jsx)(t.code,{children:"bundledAssets"})}),(0,s.jsx)(t.td,{children:"array"}),(0,s.jsx)(t.td,{children:"An array of asset filenames to download as part of this update."})]}),(0,s.jsxs)(t.tr,{children:[(0,s.jsx)(t.td,{children:(0,s.jsx)(t.code,{children:"assetUrlOverride"})}),(0,s.jsx)(t.td,{children:"string"}),(0,s.jsxs)(t.td,{children:["Base URL from which to resolve all of the filenames listed in ",(0,s.jsx)(t.code,{children:"bundledAssets"}),"."]})]})]})]}),"\n",(0,s.jsxs)(t.p,{children:[(0,s.jsx)(t.code,{children:"expo-updates"})," assumes that URLs for assets and JavaScript bundles are immutable; that is, if it has already downloaded an asset or bundle at a given URL, it will not attempt to re-download. Therefore, if you change any assets in your updates, you ",(0,s.jsx)(t.strong,{children:"must"})," host them at a different URL."]}),"\n",(0,s.jsxs)(t.p,{children:["If you use ",(0,s.jsx)(t.code,{children:"expo export"})," to create a prebuilt package of your update, the manifests in ",(0,s.jsx)(t.code,{children:"ios-index.json"})," and ",(0,s.jsx)(t.code,{children:"android-index.json"})," satisfy these requirements. Expo's update service, which you publish to if you use ",(0,s.jsx)(t.code,{children:"expo publish"}),", dynamically creates these manifest objects upon each update request."]}),"\n",(0,s.jsx)(t.h2,{id:"update-compatibility",children:"Update Compatibility"}),"\n",(0,s.jsx)(t.p,{children:"A critical consideration with updates is compatibility between the JavaScript bundle and the native runtime (i.e. the native modules present in a given binary and the methods they export). To illustrate, consider the following example:"}),"\n",(0,s.jsxs)(t.p,{children:["Say you have an existing build, build A, of your app running in production. Build A runs JavaScript bundle version 1 and everything works smoothly. In the next version of your app, you need some new functionality, so in development you install a new native module like ",(0,s.jsx)(t.code,{children:"expo-media-library"}),", and use some of its functions. You create build B of your app which includes the ",(0,s.jsx)(t.code,{children:"MediaLibrary"})," native module. Build B runs JavaScript bundle version 2 which calls ",(0,s.jsx)(t.code,{children:"MediaLibrary.getAlbumsAsync()"}),", and this works."]}),"\n",(0,s.jsxs)(t.p,{children:["However, if build A of your app fetches JavaScript version 2 as an update and tries to run it, it will error on the ",(0,s.jsx)(t.code,{children:"MediaLibrary.getAlbumsAsync()"})," method call because the ",(0,s.jsx)(t.code,{children:"MediaLibrary"})," native module is not present in build A. If your JavaScript doesn't catch this error, it will propagate and your app will crash, rendering JavaScript version 2 unusable on build A of your app."]}),"\n",(0,s.jsxs)(t.p,{children:["We need some way, therefore, of preventing JavaScript version 2 from being deployed to build A - or, in general, controlling which updates are deployed to specific builds of your app. ",(0,s.jsx)(t.code,{children:"expo-updates"})," provides two ways to control this: Runtime Version and Release Channels."]}),"\n",(0,s.jsx)(t.h3,{id:"runtime-version",children:"Runtime Version"}),"\n",(0,s.jsx)(t.p,{children:"Updates hosted on your own server can make use of a concept called Runtime Version. Runtime Version represents a versioning scheme for the native-JavaScript interface, or the native modules and the methods they export. In other words, anytime you make a change to your native module layer, such as adding, removing, or updating a native module, you would increment the Runtime Version number."}),"\n",(0,s.jsxs)(t.p,{children:["The Runtime Version of a particular binary should be configured at build time (see ",(0,s.jsx)(t.a,{href:"/archive/classic-updates/updating-your-app/#configuration-options",children:"Configuration Options"})," below). The configured Runtime Version will be included in the header of every update request sent from that binary. The server should use this header to select an appropriate update to serve in response."]}),"\n",(0,s.jsxs)(t.p,{children:["The Runtime Version expected by a given update must also be provided as a field (",(0,s.jsx)(t.code,{children:"runtimeVersion"}),") in the manifest returned to ",(0,s.jsx)(t.code,{children:"expo-updates"}),". ",(0,s.jsx)(t.code,{children:"expo-updates"})," keeps track of the Runtime Version of all updates it has downloaded; this way, if a user updates their app binary through the App Store, it will not attempt to run a previously downloaded and newly incompatible update."]}),"\n",(0,s.jsx)(t.h3,{id:"release-channels",children:"Release Channels"}),"\n",(0,s.jsxs)(t.p,{children:["Because the current implementation of the Expo updates service relies heavily on SDK version (a managed-workflow concept), if you're using ",(0,s.jsx)(t.code,{children:"expo publish"})," you cannot yet use Runtime Version to manage compatibility of your updates and binaries. Instead, you can use ",(0,s.jsx)(t.a,{href:"/archive/classic-updates/release-channels",children:"release channels"}),". A typical workflow would be to create a new release channel for each new binary you build (or at least every new binary with an incompatible change in the native-JavaScript interface) by publishing to that new release channel with ",(0,s.jsx)(t.code,{children:"expo publish --release-channel <channel-name>"}),". After creating a build with this release channel name configured, you can continue to publish future updates to this same release channel as long as they remain compatible with that build. Only builds that were configured to use that release channel will receive those updates."]}),"\n",(0,s.jsx)(t.h3,{id:"statically-hosted-updates",children:"Statically Hosted Updates"}),"\n",(0,s.jsxs)(t.p,{children:["Since headers sent in requests by ",(0,s.jsx)(t.code,{children:"expo-updates"})," do not affect statically hosted updates (such as update packages created by ",(0,s.jsx)(t.code,{children:"expo export"}),"), you must host incompatible updates at different static URLs in order to control compatibility."]}),"\n",(0,s.jsx)(t.h2,{id:"embedding-assets",children:"Embedding Assets"}),"\n",(0,s.jsxs)(t.p,{children:["In addition to loading updates from remote servers, apps with ",(0,s.jsx)(t.code,{children:"expo-updates"})," installed also include the necessary capability to load updates embedded in the app binary. This is critical to ensure that your app can launch offline for all users immediately upon installation, without needing an internet connection."]}),"\n",(0,s.jsxs)(t.p,{children:["When you make a release build of your app, the build process will bundle your JavaScript source code into a minified bundle and embed this in the binary, along with any other assets your app imports (with ",(0,s.jsx)(t.code,{children:"require"})," or ",(0,s.jsx)(t.code,{children:"import"})," or used in ",(0,s.jsx)(t.strong,{children:"app.json"}),"). ",(0,s.jsx)(t.code,{children:"expo-updates"})," includes an extra script on each platform to embed some additional metadata about the embedded assets -- namely, a minimal manifest JSON object for the update."]}),"\n",(0,s.jsx)(t.h2,{id:"including-assets-in-updates",children:"Including Assets in Updates"}),"\n",(0,s.jsxs)(t.p,{children:["Assets that you import in your JavaScript source can also be atomically downloaded as part of a published update. ",(0,s.jsx)(t.code,{children:"expo-updates"}),' will not consider an update "ready" and will not launch the update unless it has downloaded all required assets.']}),"\n",(0,s.jsxs)(t.p,{children:["If you use ",(0,s.jsx)(t.code,{children:"expo-asset"})," in your project (included by default if you have the ",(0,s.jsx)(t.code,{children:"expo"})," package installed), you can control which imported assets will be included as part of this atomic update by using the ",(0,s.jsx)(t.code,{children:"assetBundlePatterns"})," key in ",(0,s.jsx)(t.strong,{children:"app.json"})," to provide a list of paths in your project directory:"]}),"\n",(0,s.jsx)(t.pre,{children:(0,s.jsx)(t.code,{children:'"assetBundlePatterns": [\n  "**/*" // or "assets/images/*", etc.\n],\n'})}),"\n",(0,s.jsxs)(t.p,{children:["Assets with paths matching the given patterns will be pre-downloaded by clients before the update that uses them will launch. If you have an asset that should be lazily downloaded at runtime rather than before your JavaScript is evaluated, you can use ",(0,s.jsx)(t.code,{children:"assetBundlePatterns"})," to exclude it while still importing it in your JavaScript source."]}),"\n",(0,s.jsxs)(t.p,{children:["Note that in order to use ",(0,s.jsx)(t.code,{children:"expo-asset"})," successfully, you must use the ",(0,s.jsx)(t.code,{children:"--assetPlugins"})," option to provide the Metro bundler with the ",(0,s.jsx)(t.code,{children:"node_modules/expo-asset/tools/hashAssetFiles"})," plugin when you create your JavaScript bundle. If you use ",(0,s.jsx)(t.code,{children:"expo export"})," or ",(0,s.jsx)(t.code,{children:"expo publish"})," to create your update, this will be done automatically for you."]}),"\n",(0,s.jsx)(t.h2,{id:"configuration-options",children:"Configuration Options"}),"\n",(0,s.jsxs)(t.p,{children:["Some build-time configuration options are available to control various behaviors of the ",(0,s.jsx)(t.code,{children:"expo-updates"})," library. You can set the URL where your app is hosted, set compatibility/version information, and choose whether your app should update automatically on launch."]}),"\n",(0,s.jsxs)(t.p,{children:["On iOS, these properties are set as keys in ",(0,s.jsx)(t.strong,{children:"Expo.plist"})," and on Android as ",(0,s.jsx)(t.code,{children:"meta-data"})," tags in ",(0,s.jsx)(t.strong,{children:"AndroidManifest.xml"}),", adjacent to the tags added during installation."]}),"\n",(0,s.jsxs)(t.p,{children:["On Android, you may also define these properties at runtime by passing a ",(0,s.jsx)(t.code,{children:"Map"})," as the second parameter of ",(0,s.jsx)(t.code,{children:"UpdatesController.initialize()"}),". If provided, the values in this Map will override any values specified in ",(0,s.jsx)(t.strong,{children:"AndroidManifest.xml"}),". On iOS, you may set these properties at runtime by calling ",(0,s.jsx)(t.code,{children:"[UpdatesController.sharedInstance setConfiguration:]"})," at any point ",(0,s.jsx)(t.em,{children:"before"})," calling ",(0,s.jsx)(t.code,{children:"start"})," or ",(0,s.jsx)(t.code,{children:"startAndShowLaunchScreen"}),", and the values in this dictionary will override Expo.plist."]}),"\n",(0,s.jsxs)(t.table,{children:[(0,s.jsx)(t.thead,{children:(0,s.jsxs)(t.tr,{children:[(0,s.jsx)(t.th,{children:"iOS plist/dictionary key"}),(0,s.jsx)(t.th,{children:"Android Map key"}),(0,s.jsx)(t.th,{children:"Android meta-data name"}),(0,s.jsx)(t.th,{children:"Default"}),(0,s.jsx)(t.th,{children:"Required?"})]})}),(0,s.jsx)(t.tbody,{children:(0,s.jsxs)(t.tr,{children:[(0,s.jsx)(t.td,{children:(0,s.jsx)(t.code,{children:"EXUpdatesEnabled"})}),(0,s.jsx)(t.td,{children:(0,s.jsx)(t.code,{children:"enabled"})}),(0,s.jsx)(t.td,{children:(0,s.jsx)(t.code,{children:"expo.modules.updates.ENABLED"})}),(0,s.jsx)(t.td,{children:(0,s.jsx)(t.code,{children:"true"})}),(0,s.jsx)(t.td,{children:"❌"})]})})]}),"\n",(0,s.jsxs)(t.p,{children:["Whether updates are enabled. Setting this to ",(0,s.jsx)(t.code,{children:"false"})," disables all update functionality, all module methods, and forces the app to load with the manifest and assets bundled into the app binary."]}),"\n",(0,s.jsxs)(t.table,{children:[(0,s.jsx)(t.thead,{children:(0,s.jsxs)(t.tr,{children:[(0,s.jsx)(t.th,{children:"iOS plist/dictionary key"}),(0,s.jsx)(t.th,{children:"Android Map key"}),(0,s.jsx)(t.th,{children:"Android meta-data name"}),(0,s.jsx)(t.th,{children:"Default"}),(0,s.jsx)(t.th,{children:"Required?"})]})}),(0,s.jsx)(t.tbody,{children:(0,s.jsxs)(t.tr,{children:[(0,s.jsx)(t.td,{children:(0,s.jsx)(t.code,{children:"EXUpdatesURL"})}),(0,s.jsx)(t.td,{children:(0,s.jsx)(t.code,{children:"updateUrl"})}),(0,s.jsx)(t.td,{children:(0,s.jsx)(t.code,{children:"expo.modules.updates.EXPO_UPDATE_URL"})}),(0,s.jsx)(t.td,{children:"(none)"}),(0,s.jsx)(t.td,{children:"✅"})]})})]}),"\n",(0,s.jsxs)(t.p,{children:["The URL to the remote server where the app should check for updates. A request to this URL should return a valid manifest object for the latest available update that tells expo-updates how to fetch the JS bundle and other assets that comprise an update. (Example: for apps published with ",(0,s.jsx)(t.code,{children:"expo publish"}),", this URL would be ",(0,s.jsx)(t.code,{children:"https://exp.host/@username/slug"}),".)"]}),"\n",(0,s.jsxs)(t.table,{children:[(0,s.jsx)(t.thead,{children:(0,s.jsxs)(t.tr,{children:[(0,s.jsx)(t.th,{children:"iOS plist/dictionary key"}),(0,s.jsx)(t.th,{children:"Android Map key"}),(0,s.jsx)(t.th,{children:"Android meta-data name"}),(0,s.jsx)(t.th,{children:"Default"}),(0,s.jsx)(t.th,{children:"Required?"})]})}),(0,s.jsx)(t.tbody,{children:(0,s.jsxs)(t.tr,{children:[(0,s.jsx)(t.td,{children:(0,s.jsx)(t.code,{children:"EXUpdatesSDKVersion"})}),(0,s.jsx)(t.td,{children:(0,s.jsx)(t.code,{children:"sdkVersion"})}),(0,s.jsx)(t.td,{children:(0,s.jsx)(t.code,{children:"expo.modules.updates.EXPO_SDK_VERSION"})}),(0,s.jsx)(t.td,{children:"(none)"}),(0,s.jsxs)(t.td,{children:["(exactly one of ",(0,s.jsx)(t.code,{children:"sdkVersion"})," or ",(0,s.jsx)(t.code,{children:"runtimeVersion"})," is required)"]})]})})]}),"\n",(0,s.jsxs)(t.p,{children:["The SDK version string to send under the ",(0,s.jsx)(t.code,{children:"Expo-SDK-Version"})," header in the manifest request. Required for apps hosted on Expo's server."]}),"\n",(0,s.jsxs)(t.table,{children:[(0,s.jsx)(t.thead,{children:(0,s.jsxs)(t.tr,{children:[(0,s.jsx)(t.th,{children:"iOS plist/dictionary key"}),(0,s.jsx)(t.th,{children:"Android Map key"}),(0,s.jsx)(t.th,{children:"Android meta-data name"}),(0,s.jsx)(t.th,{children:"Default"}),(0,s.jsx)(t.th,{children:"Required?"})]})}),(0,s.jsx)(t.tbody,{children:(0,s.jsxs)(t.tr,{children:[(0,s.jsx)(t.td,{children:(0,s.jsx)(t.code,{children:"EXUpdatesRuntimeVersion"})}),(0,s.jsx)(t.td,{children:(0,s.jsx)(t.code,{children:"runtimeVersion"})}),(0,s.jsx)(t.td,{children:(0,s.jsx)(t.code,{children:"expo.modules.updates.EXPO_RUNTIME_VERSION"})}),(0,s.jsx)(t.td,{children:"(none)"}),(0,s.jsxs)(t.td,{children:["(exactly one of ",(0,s.jsx)(t.code,{children:"sdkVersion"})," or ",(0,s.jsx)(t.code,{children:"runtimeVersion"})," is required)"]})]})})]}),"\n",(0,s.jsxs)(t.p,{children:["The Runtime Version string to send under the ",(0,s.jsx)(t.code,{children:"Expo-Runtime-Version"})," header in the manifest request."]}),"\n",(0,s.jsxs)(t.table,{children:[(0,s.jsx)(t.thead,{children:(0,s.jsxs)(t.tr,{children:[(0,s.jsx)(t.th,{children:"iOS plist/dictionary key"}),(0,s.jsx)(t.th,{children:"Android Map key"}),(0,s.jsx)(t.th,{children:"Android meta-data name"}),(0,s.jsx)(t.th,{children:"Default"}),(0,s.jsx)(t.th,{children:"Required?"})]})}),(0,s.jsx)(t.tbody,{children:(0,s.jsxs)(t.tr,{children:[(0,s.jsx)(t.td,{children:(0,s.jsx)(t.code,{children:"EXUpdatesReleaseChannel"})}),(0,s.jsx)(t.td,{children:(0,s.jsx)(t.code,{children:"releaseChannel"})}),(0,s.jsx)(t.td,{children:(0,s.jsx)(t.code,{children:"expo.modules.updates.EXPO_RELEASE_CHANNEL"})}),(0,s.jsx)(t.td,{children:(0,s.jsx)(t.code,{children:"default"})}),(0,s.jsx)(t.td,{children:"❌"})]})})]}),"\n",(0,s.jsxs)(t.p,{children:["The release channel string to send under the ",(0,s.jsx)(t.code,{children:"Expo-Release-Channel"})," header in the manifest request."]}),"\n",(0,s.jsxs)(t.table,{children:[(0,s.jsx)(t.thead,{children:(0,s.jsxs)(t.tr,{children:[(0,s.jsx)(t.th,{children:"iOS plist/dictionary key"}),(0,s.jsx)(t.th,{children:"Android Map key"}),(0,s.jsx)(t.th,{children:"Android meta-data name"}),(0,s.jsx)(t.th,{children:"Default"}),(0,s.jsx)(t.th,{children:"Required?"})]})}),(0,s.jsx)(t.tbody,{children:(0,s.jsxs)(t.tr,{children:[(0,s.jsx)(t.td,{children:(0,s.jsx)(t.code,{children:"EXUpdatesCheckOnLaunch"})}),(0,s.jsx)(t.td,{children:(0,s.jsx)(t.code,{children:"checkOnLaunch"})}),(0,s.jsx)(t.td,{children:(0,s.jsx)(t.code,{children:"expo.modules.updates.EXPO_UPDATES_CHECK_ON_LAUNCH"})}),(0,s.jsx)(t.td,{children:(0,s.jsx)(t.code,{children:"ALWAYS"})}),(0,s.jsx)(t.td,{children:"❌"})]})})]}),"\n",(0,s.jsxs)(t.p,{children:["The condition under which ",(0,s.jsx)(t.code,{children:"expo-updates"})," should automatically check for (and download, if one exists) an update upon app launch. Possible values are ",(0,s.jsx)(t.code,{children:"ALWAYS"}),", ",(0,s.jsx)(t.code,{children:"NEVER"})," (if you want to exclusively control updates via this module's JS API), ",(0,s.jsx)(t.code,{children:"WIFI_ONLY"})," (if you want the app to automatically download updates only if the device is on an unmetered Wi-Fi connection when it launches), or ",(0,s.jsx)(t.code,{children:"ERROR_RECOVERY_ONLY"})," (if you want the app to automatically download updates only if it encounters a fatal error when launching)."]}),"\n",(0,s.jsx)(t.p,{children:"Regardless of the value of this setting, as long as updates are enabled, your app can always use the JS API to manually check for and download updates in the background while your app is running."}),"\n",(0,s.jsxs)(t.table,{children:[(0,s.jsx)(t.thead,{children:(0,s.jsxs)(t.tr,{children:[(0,s.jsx)(t.th,{children:"iOS plist/dictionary key"}),(0,s.jsx)(t.th,{children:"Android Map key"}),(0,s.jsx)(t.th,{children:"Android meta-data name"}),(0,s.jsx)(t.th,{children:"Default"}),(0,s.jsx)(t.th,{children:"Required?"})]})}),(0,s.jsx)(t.tbody,{children:(0,s.jsxs)(t.tr,{children:[(0,s.jsx)(t.td,{children:(0,s.jsx)(t.code,{children:"EXUpdatesLaunchWaitMs"})}),(0,s.jsx)(t.td,{children:(0,s.jsx)(t.code,{children:"launchWaitMs"})}),(0,s.jsx)(t.td,{children:(0,s.jsx)(t.code,{children:"expo.modules.updates.EXPO_UPDATES_LAUNCH_WAIT_MS"})}),(0,s.jsx)(t.td,{children:(0,s.jsx)(t.code,{children:"0"})}),(0,s.jsx)(t.td,{children:"❌"})]})})]}),"\n",(0,s.jsxs)(t.p,{children:["The number of milliseconds ",(0,s.jsx)(t.code,{children:"expo-updates"})," should delay the app launch and stay on the splash screen while trying to download an update, before falling back to a previously downloaded version. Setting this to ",(0,s.jsx)(t.code,{children:"0"})," will cause the app to always launch with a previously downloaded update and will result in the fastest app launch possible."]}),"\n",(0,s.jsx)(t.p,{children:"Some common configuration patterns are explained below:"}),"\n",(0,s.jsx)(t.h3,{id:"automatic-updates",children:"Automatic Updates"}),"\n",(0,s.jsxs)(t.p,{children:["By default, ",(0,s.jsx)(t.code,{children:"expo-updates"})," will immediately launch your app with a previously downloaded (or embedded) update when a user opens your app from being closed. It will additionally check for updates asynchronously in the background, and will try to fetch the latest published version. If a new update is available, ",(0,s.jsx)(t.code,{children:"expo-updates"})," will try to download it and notify the running JavaScript of its success or failure using ",(0,s.jsx)(t.a,{href:"/archive/versions/latest/sdk/updates/#updatesaddlistenereventlistener",children:"events"}),". A newly fetched update will be launched next time the user swipes closed and reopens the app; if you want to run it sooner, you can call ",(0,s.jsx)(t.a,{href:"/archive/versions/latest/sdk/updates/#updatesreloadasync",children:(0,s.jsx)(t.code,{children:"Updates.reloadAsync"})})," in your application code at an appropriate time."]}),"\n",(0,s.jsxs)(t.p,{children:["You may also configure ",(0,s.jsx)(t.code,{children:"expo-updates"})," to wait a specific amount of time to launch when a user opens the app by using the ",(0,s.jsx)(t.code,{children:"launchWaitMs"})," setting. If a new update can be downloaded within this time, the new update will be launched right away, rather than waiting for the user to swipe closed and reopen the app. (Note, however, that if users have a slow network connection, your app can be delayed on the launch screen for as many milliseconds as ",(0,s.jsx)(t.code,{children:"launchWaitMs"}),", so we recommend being conservative with this setting unless it's critically important for users to have the most recent update on each launch.) If no update is available, a previously downloaded update will be launched as soon as ",(0,s.jsx)(t.code,{children:"expo-updates"})," is able to determine this."]}),"\n",(0,s.jsxs)(t.p,{children:["If you want this automatic update behavior to occur only when your users are on a Wi-Fi connection, you can set the ",(0,s.jsx)(t.code,{children:"checkOnLaunch"})," setting to ",(0,s.jsx)(t.code,{children:"WIFI_ONLY"}),"."]}),"\n",(0,s.jsx)(t.h3,{id:"manual-updates",children:"Manual Updates"}),"\n",(0,s.jsx)(t.p,{children:"It's also possible to turn off these automatic updates, and to instead control updates entirely within your JS code. This is desirable if you want some custom logic around fetching updates (e.g. only when users take a specific action in your UI)."}),"\n",(0,s.jsxs)(t.p,{children:["Setting ",(0,s.jsx)(t.code,{children:"checkOnLaunch"})," to ",(0,s.jsx)(t.code,{children:"NEVER"})," will prevent ",(0,s.jsx)(t.code,{children:"expo-updates"})," from automatically fetching the latest update every time your app is launched. Only the most recent cached version of your bundle will be loaded."]}),"\n",(0,s.jsxs)(t.p,{children:["You can then use the ",(0,s.jsx)(t.a,{href:"/archive/versions/latest/sdk/updates/",children:(0,s.jsx)(t.code,{children:"expo-updates"})})," module included with this library to download new updates and, if appropriate, notify the user and reload the experience."]}),"\n",(0,s.jsx)(t.pre,{children:(0,s.jsx)(t.code,{className:"language-javascript",children:"try {\n  const update = await Updates.checkForUpdateAsync();\n  if (update.isAvailable) {\n    await Updates.fetchUpdateAsync();\n    // ... notify user of update ...\n    Updates.reloadAsync();\n  }\n} catch (e) {\n  // handle or log error\n}\n"})})]})}t.default=function(){let e=arguments.length>0&&void 0!==arguments[0]?arguments[0]:{},{wrapper:t}=Object.assign({},(0,i.ah)(),e.components);return t?(0,s.jsx)(t,Object.assign({},e,{children:(0,s.jsx)(o,e)})):o(e)}}},function(e){e.O(0,[49774,92888,40179],function(){return e(e.s=69721)}),_N_E=e.O()}]);