(self.webpackChunk_N_E=self.webpackChunk_N_E||[]).push([[3985],{71731:function(e,n,t){(window.__NEXT_P=window.__NEXT_P||[]).push(["/archive/notification-channels",function(){return t(98153)}])},98153:function(e,n,t){"use strict";t.r(n),t.d(n,{__N_SSG:function(){return a},headings:function(){return r},meta:function(){return s}});var i=t(85893),o=t(11151),a=!0;let s={title:"Notification Channels",hideFromSearch:!0},r=[{depth:2,type:"text",title:"Designing channels"},{depth:2,type:"text",title:"Creating and using channels"},{depth:2,type:"text",title:"Updating an existing app to use channels"},{depth:2,type:"text",title:"Send channel notification with Expo api service."}];function c(e){let n=Object.assign({blockquote:"blockquote",p:"p",strong:"strong",a:"a",h2:"h2",pre:"pre",code:"code"},(0,o.ah)(),e.components);return(0,i.jsxs)(i.Fragment,{children:[(0,i.jsxs)(n.blockquote,{children:["\n",(0,i.jsxs)(n.p,{children:[(0,i.jsx)(n.strong,{children:"warning"})," This page is archived. Please refer to the ",(0,i.jsx)(n.a,{href:"/../push-notifications/overview/",children:"Push Notifications guide"})," for up-to-date information."]}),"\n"]}),"\n",(0,i.jsx)(n.p,{children:"Notification channels are a new feature in Android Oreo that give users more control over the notifications they receive. Starting in Android Oreo, every local and push notification must be assigned to a single channel. Users can see all notification channels in their OS Settings, and they can customize the behavior of alerts on a per-channel basis."}),"\n",(0,i.jsx)(n.p,{children:"Notification channels have no effect and are ignored on all iOS devices."}),"\n",(0,i.jsx)(n.h2,{id:"designing-channels",children:"Designing channels"}),"\n",(0,i.jsx)(n.p,{children:"Channels give users more control over the various kinds of alerts they want to receive from your app. You should create a channel for each type of notification you might send, such as Alarms, Chat messages, Update notifications, or the like."}),"\n",(0,i.jsx)(n.p,{children:"According to the Android developer documentation:"}),"\n",(0,i.jsxs)(n.blockquote,{children:["\n",(0,i.jsx)(n.p,{children:"You should create a channel for each distinct type of notification you need to send. You can also create notification channels to reflect choices made by users of your app. For example, you can set up separate notification channels for each conversation group created by a user in a messaging app."}),"\n"]}),"\n",(0,i.jsx)(n.p,{children:"When you create a channel, you can specify various settings for its notifications, such as priority, sound, and vibration. After you create the channel, control switches entirely to the user, who can then customize these settings to their own liking for each channel. Your app can no longer change any of the settings. Although it is possible for your app to programmatically delete channels, Android does not recommend this and keeps a relic on the user's device."}),"\n",(0,i.jsxs)(n.p,{children:["You can read more about notification channels on the ",(0,i.jsx)(n.a,{href:"https://developer.android.com/training/notify-user/channels",children:"Android developer website"}),". It's a good idea to put some thought into designing channels that make sense and are useful customization tools for your users."]}),"\n",(0,i.jsx)(n.h2,{id:"creating-and-using-channels",children:"Creating and using channels"}),"\n",(0,i.jsx)(n.p,{children:"Creating a channel is easy -- before you create a local notification (or receive a push notification), simply call the following method:"}),"\n",(0,i.jsx)(n.pre,{children:(0,i.jsx)(n.code,{className:"language-javascript",children:"if (Platform.OS === 'android') {\n  Notifications.createChannelAndroidAsync('chat-messages', {\n    name: 'Chat messages',\n    sound: true,\n  });\n}\n"})}),"\n",(0,i.jsxs)(n.p,{children:["Creating a channel that already exists is essentially a no-op, so it's safe to call this each time your app starts up. For example, the ",(0,i.jsx)(n.code,{children:"componentDidMount"})," of your app's root component might be a good place for this. However, note that you cannot change any settings of a notification channel after it's been created -- only the user can do this. So be sure to plan your channels carefully."]}),"\n",(0,i.jsxs)(n.p,{children:["Then, when you want to send a notification for a chat message, either add the ",(0,i.jsx)(n.code,{children:"channelId: 'chat-messages'"})," field to your ",(0,i.jsx)(n.a,{href:"/push-notifications/#message-format",children:"push notification message"}),", or create a local notification like this:"]}),"\n",(0,i.jsx)(n.pre,{children:(0,i.jsx)(n.code,{className:"language-javascript",children:"Notifications.presentLocalNotificationAsync({\n  title: 'New Message',\n  body: 'Message!!!!',\n  android: {\n    channelId: 'chat-messages',\n  },\n});\n"})}),"\n",(0,i.jsxs)(n.p,{children:["Expo will then present your notification to the user through the ",(0,i.jsx)(n.code,{children:"chat-messages"})," channel, respecting all of the user's settings for that channel."]}),"\n",(0,i.jsxs)(n.p,{children:["If you create a notification and do not specify a ",(0,i.jsx)(n.code,{children:"channelId"}),", Expo will automatically create a 'Default' channel for you and present the notification through that channel. If, however, you specify a ",(0,i.jsx)(n.code,{children:"channelId"})," that has not yet been created on the device, ",(0,i.jsx)(n.strong,{children:"the notification will not be shown on Android 8+ devices."})," Therefore, it's important to plan ahead and make sure that you create all of the channels you may need before sending out notifications."]}),"\n",(0,i.jsxs)(n.p,{children:["On devices with Android 7 and below, which don't support notification channels, Expo will remember the relevant settings you created the channel with (in this case, ",(0,i.jsx)(n.code,{children:"sound: true"}),") and apply them directly to the individual notification before presenting it to the user."]}),"\n",(0,i.jsx)(n.h2,{id:"updating-an-existing-app-to-use-channels",children:"Updating an existing app to use channels"}),"\n",(0,i.jsxs)(n.p,{children:["If you have an existing Android app that relies on ",(0,i.jsx)(n.code,{children:"sound"}),", ",(0,i.jsx)(n.code,{children:"vibrate"}),", or ",(0,i.jsx)(n.code,{children:"priority"})," settings for notifications, you'll need to update it to take advantage of channels, as those settings no longer have any effect on individual notifications. If you do not rely on those settings, you may want to update it anyway in order to give users more control over the different types of notifications your app presents. (Note that the client-side ",(0,i.jsx)(n.code,{children:"priority"})," setting involved here only affects the notification's UI behavior and is distinct from ",(0,i.jsxs)(n.a,{href:"/push-notifications/#message-format",children:["the ",(0,i.jsx)(n.code,{children:"priority"})," of a push notification"]}),", which is not affected by notification channels.)"]}),"\n",(0,i.jsxs)(n.p,{children:["To do this, first make sure you are using the latest minor update of ",(0,i.jsx)(n.code,{children:"expo"})," for your SDK version. Notification channels are supported in SDKs 22 and above, so for example, if you're on SDK 27 you should ",(0,i.jsx)(n.code,{children:"npm install"}),"/",(0,i.jsx)(n.code,{children:"yarn add"})," ",(0,i.jsx)(n.code,{children:"expo@^27.1.0"}),"."]}),"\n",(0,i.jsxs)(n.p,{children:["Next, plan out the notification channels your app will need. These may correspond to the different permutations of the ",(0,i.jsx)(n.code,{children:"sound"}),", ",(0,i.jsx)(n.code,{children:"vibrate"})," and ",(0,i.jsx)(n.code,{children:"priority"})," settings you used on individual notifications."]}),"\n",(0,i.jsxs)(n.p,{children:["Once you've decided on a set of channels, you need to add logic to your app to create them. We recommend simply creating all channels in ",(0,i.jsx)(n.code,{children:"componentDidMount"})," of your app's root component; this way all users will be sure to get all channels and not miss any notifications."]}),"\n",(0,i.jsx)(n.p,{children:"For example, if this is your code before:"}),"\n",(0,i.jsx)(n.pre,{children:(0,i.jsx)(n.code,{className:"language-javascript",children:"_createNotificationAsync = () => {\n  Notifications.presentLocalNotificationAsync({\n    title: 'Reminder',\n    body: 'This is an important reminder!!!!',\n    android: {\n      priority: 'max',\n      vibrate: [0, 250, 250, 250],\n      color: '#FF0000',\n    },\n  });\n};\n"})}),"\n",(0,i.jsx)(n.p,{children:"You might change it to something like this:"}),"\n",(0,i.jsx)(n.pre,{children:(0,i.jsx)(n.code,{className:"language-javascript",children:"componentDidMount() {\n  // ...\n  if (Platform.OS === 'android') {\n    Notifications.createChannelAndroidAsync('reminders', {\n      name: 'Reminders',\n      priority: 'max',\n      vibrate: [0, 250, 250, 250],\n    });\n  }\n}\n\n// ...\n\n_createNotificationAsync = () => {\n  Notifications.presentLocalNotificationAsync({\n    title: 'Reminder',\n    body: 'This is an important reminder!!!!',\n    android: {\n      channelId: 'reminders',\n      color: '#FF0000',\n    },\n  });\n}\n"})}),"\n",(0,i.jsxs)(n.p,{children:['This will create a channel called "Reminders" with default settings of ',(0,i.jsx)(n.code,{children:"max"})," priority and the vibrate pattern ",(0,i.jsx)(n.code,{children:"[0, 250, 250, 250]"}),'. Android 8 users can change these settings whenever they want, or even turn off notifications completely for the "Reminders" channel. When ',(0,i.jsx)(n.code,{children:"presentLocalNotificationAsync"})," is called, the OS will read the channel's settings and present the notification accordingly."]}),"\n",(0,i.jsx)(n.h2,{id:"send-channel-notification-with-expo-api-service",children:"Send channel notification with Expo api service."}),"\n",(0,i.jsx)(n.pre,{children:(0,i.jsx)(n.code,{className:"language-javascript",children:"[\n  {\n    to: 'ExponentPushToken[xxxxxx]',\n    title: 'test',\n    priority: 'high',\n    body: 'test',\n    sound: 'default', // android 7.0 , 6, 5 , 4\n    channelId: 'chat-messages', // android 8.0 later\n  },\n];\n"})})]})}n.default=function(){let e=arguments.length>0&&void 0!==arguments[0]?arguments[0]:{},{wrapper:n}=Object.assign({},(0,o.ah)(),e.components);return n?(0,i.jsx)(n,Object.assign({},e,{children:(0,i.jsx)(c,e)})):c(e)}}},function(e){e.O(0,[49774,92888,40179],function(){return e(e.s=71731)}),_N_E=e.O()}]);