(self.webpackChunk_N_E=self.webpackChunk_N_E||[]).push([[2062],{65627:function(e,n,i){(window.__NEXT_P=window.__NEXT_P||[]).push(["/bare/updating-your-app",function(){return i(41871)}])},41871:function(e,n,i){"use strict";i.r(n),i.d(n,{__N_SSG:function(){return o},headings:function(){return d},meta:function(){return r}});var t=i(85893),s=i(11151),o=!0;let r={title:"Use EAS Update in an existing project",description:"Learn how to use EAS Update in an existing React Native project."},d=[{depth:2,type:"text",title:"App config"},{depth:2,type:"text",title:"EAS config and native files"},{depth:2,type:"text",title:"Configuring the channel manually"},{depth:2,type:"text",title:"What's next"},{depth:2,type:"text",title:"Set your own updates service"}];function a(e){let n=Object.assign({p:"p",code:"code",strong:"strong",h2:"h2",pre:"pre",a:"a"},(0,s.ah)(),e.components);return(0,t.jsxs)(t.Fragment,{children:[(0,t.jsxs)(n.p,{children:["EAS update works with bare React Native projects created with ",(0,t.jsx)(n.code,{children:"react-native init"}),". These projects have ",(0,t.jsx)(n.strong,{children:"android"})," and ",(0,t.jsx)(n.strong,{children:"ios"})," directories that you can modify native files directly."]}),"\n",(0,t.jsxs)(n.p,{children:["The steps for configuring a bare React Native project are identical to the steps for configuring an Expo project. However, you may need to edit some of the code ",(0,t.jsx)(n.code,{children:"eas update:configure"})," generates depending on how you build and run your project."]}),"\n",(0,t.jsx)(n.h2,{id:"app-config",children:"App config"}),"\n",(0,t.jsxs)(n.p,{children:["The ",(0,t.jsx)(n.code,{children:"eas update:configure"})," will add two values to your project's app config."]}),"\n",(0,t.jsx)(n.pre,{children:(0,t.jsx)(n.code,{className:"language-json",children:'@@@app.json@@@{\n  "expo": {\n    "runtimeVersion": "1.0.0",\n    "updates": {\n      "url": "https://u.expo.dev/..."\n      ...\n    }\n    ...\n  }\n}\n'})}),"\n",(0,t.jsxs)(n.p,{children:["The ",(0,t.jsx)(n.code,{children:"runtimeVersion"})," property guarantees compatibility between a build's native code and an update. It's necessary to set this value manually whenever you make a change to any native code in your project. Read ",(0,t.jsx)(n.a,{href:"/../../../../../../../eas-update/runtime-versions/#custom--runtimeversion",children:"our doc on runtime versions"})," and learn how to ",(0,t.jsx)(n.a,{href:"/../../../../../../../eas-update/runtime-versions/#avoiding-crashes-with-incompatible-updates",children:"avoid publishing bad updates"}),"."]}),"\n",(0,t.jsxs)(n.p,{children:["The ",(0,t.jsx)(n.code,{children:"updates.url"}),' property is the "',(0,t.jsx)(n.a,{href:"https://u.expo.dev",children:"https://u.expo.dev"}),"\" domain followed by your project's ID on EAS' servers. If you go to the URL directly, you'll see an error about missing a header. You can see a manifest by adding three query parameters to the URL: ",(0,t.jsx)(n.code,{children:"runtime-version"}),", ",(0,t.jsx)(n.code,{children:"channel-name"}),", and ",(0,t.jsx)(n.code,{children:"platform"}),". If we published an update with a runtime version of ",(0,t.jsx)(n.code,{children:"1.0.0"}),", a channel of ",(0,t.jsx)(n.code,{children:"production"}),", and a platform of ",(0,t.jsx)(n.code,{children:"android"}),", the full URL you could visit would be similar to this:"]}),"\n",(0,t.jsx)(n.pre,{children:(0,t.jsx)(n.code,{className:"language-sh",children:"https://u.expo.dev/your-project-id?runtime-version=1.0.0&channel-name=production&platform=android\n"})}),"\n",(0,t.jsx)(n.h2,{id:"eas-config-and-native-files",children:"EAS config and native files"}),"\n",(0,t.jsxs)(n.p,{children:["To generate the ",(0,t.jsx)(n.strong,{children:"eas.json"})," file, run ",(0,t.jsx)(n.code,{children:"eas build:configure"}),". This command will create the ",(0,t.jsx)(n.strong,{children:"eas.json"})," file and it will also modify the ",(0,t.jsx)(n.strong,{children:"AndroidManifest.xml"})," file inside the ",(0,t.jsx)(n.strong,{children:"android"})," directory and the ",(0,t.jsx)(n.strong,{children:"Expo.plist"})," file inside the ",(0,t.jsx)(n.strong,{children:"ios"})," directory."]}),"\n",(0,t.jsxs)(n.p,{children:["Inside ",(0,t.jsx)(n.strong,{children:"eas.json"}),", you'll want to add ",(0,t.jsx)(n.code,{children:"channel"})," properties to each build profile you'd like to send updates to. Assuming you're using the default ",(0,t.jsx)(n.strong,{children:"eas.json"})," configuration, we recommend adding ",(0,t.jsx)(n.code,{children:"channel"})," properties to the ",(0,t.jsx)(n.code,{children:"preview"})," and ",(0,t.jsx)(n.code,{children:"production"})," build profiles."]}),"\n",(0,t.jsx)(n.pre,{children:(0,t.jsx)(n.code,{className:"language-json",children:'@@@eas.json@@@{\n  "cli": {\n    "version": ">= 2.1.0"\n  },\n  "build": {\n    "development": {\n      "developmentClient": true,\n      "distribution": "internal"\n    },\n    "preview": {\n      "distribution": "internal",\n      "channel": "preview"\n    },\n    "production": {\n      "channel": "production"\n    }\n  },\n  "submit": {\n    "production": {}\n  }\n}\n'})}),"\n",(0,t.jsxs)(n.p,{children:["Inside ",(0,t.jsx)(n.strong,{children:"AndroidManifest.xml"}),", you'll see the following additions:"]}),"\n",(0,t.jsx)(n.pre,{children:(0,t.jsx)(n.code,{className:"language-xml",children:'<meta-data android:name="expo.modules.updates.EXPO_UPDATE_URL" android:value="https://u.expo.dev/your-project-id"/>\n<meta-data android:name="expo.modules.updates.EXPO_RUNTIME_VERSION" android:value="1.0.0"/>\n'})}),"\n",(0,t.jsxs)(n.p,{children:["The ",(0,t.jsx)(n.code,{children:"EXPO_UPDATE_URL"})," value should contain your project's ID."]}),"\n",(0,t.jsxs)(n.p,{children:["Inside ",(0,t.jsx)(n.strong,{children:"Expo.plist"}),", you'll see the following additions:"]}),"\n",(0,t.jsx)(n.pre,{children:(0,t.jsx)(n.code,{className:"language-xml",children:"<key>EXUpdatesRuntimeVersion</key>\n<string>1.0.0</string>\n<key>EXUpdatesURL</key>\n<string>https://u.expo.dev/your-project-id</string>\n"})}),"\n",(0,t.jsxs)(n.p,{children:["The ",(0,t.jsx)(n.code,{children:"EXUpdatesURL"})," value should contain your project's ID."]}),"\n",(0,t.jsxs)(n.p,{children:["Once you've built your project into a build, the ",(0,t.jsx)(n.code,{children:"expo-updates"})," library will make requests for manifests with the native configuration defined above, along with the channel specified in ",(0,t.jsx)(n.strong,{children:"eas.json"}),"."]}),"\n",(0,t.jsx)(n.h2,{id:"configuring-the-channel-manually",children:"Configuring the channel manually"}),"\n",(0,t.jsxs)(n.p,{children:["If you create a build with EAS Build, the channel name from ",(0,t.jsx)(n.strong,{children:"eas.json"})," will automatically be added to our build's ",(0,t.jsx)(n.strong,{children:"AndroidManifest.xml"})," and ",(0,t.jsx)(n.strong,{children:"Expo.plist"})," at build time. If you're using EAS Build, the following steps are not necessary."]}),"\n",(0,t.jsxs)(n.p,{children:["If your project is not using EAS Build or you are creating release builds with either ",(0,t.jsx)(n.code,{children:"expo run:ios --configuration Release"})," or ",(0,t.jsx)(n.code,{children:"expo run:android --variant release"}),", you'll need to set the channel configuration manually inside both ",(0,t.jsx)(n.strong,{children:"AndroidManifest.xml"})," and ",(0,t.jsx)(n.strong,{children:"Expo.plist"}),"."]}),"\n",(0,t.jsxs)(n.p,{children:["In ",(0,t.jsx)(n.strong,{children:"AndroidManifest.xml"}),", you'll need to add the following, replacing ",(0,t.jsx)(n.code,{children:"your-channel-name"})," with the channel that matches your project:"]}),"\n",(0,t.jsx)(n.pre,{children:(0,t.jsx)(n.code,{className:"language-xml",children:'<meta-data android:name="expo.modules.updates.UPDATES_CONFIGURATION_REQUEST_HEADERS_KEY" android:value="{&quot;expo-channel-name&quot;:&quot;your-channel-name&quot;}"/>\n'})}),"\n",(0,t.jsxs)(n.p,{children:["In ",(0,t.jsx)(n.strong,{children:"Expo.plist"}),", you'll need to add the following, replacing ",(0,t.jsx)(n.code,{children:"your-channel-name"})," with the channel that matches your project:"]}),"\n",(0,t.jsx)(n.pre,{children:(0,t.jsx)(n.code,{className:"language-xml",children:"<key>EXUpdatesRequestHeaders</key>\n<dict>\n  <key>expo-channel-name</key>\n  <string>your-channel-name</string>\n</dict>\n"})}),"\n",(0,t.jsxs)(n.p,{children:["This configuration is also generated by ",(0,t.jsx)(n.code,{children:"npx expo prebuild"})," if you set the ",(0,t.jsx)(n.code,{children:"requestHeaders"})," property in your ",(0,t.jsx)(n.strong,{children:"app.json"}),":"]}),"\n","\n",(0,t.jsx)(n.pre,{children:(0,t.jsx)(n.code,{className:"language-json",children:'@@@app.json@@@{\n  "expo": {\n    /* @hide ... your existing configuration */ /* @end */\n    "updates": {\n      /* @hide ... */ /* @end */\n      "requestHeaders": {\n        "expo-channel-name": "your-channel-name"\n      }\n      /* @hide ... */ /* @end */\n    }\n    /* @hide ... */ /* @end */\n  }\n}\n'})}),"\n",(0,t.jsx)(n.h2,{id:"whats-next",children:"What's next"}),"\n",(0,t.jsxs)(n.p,{children:["Once your project is set up with EAS Update, eventually you'll make native changes to your project. Whenever that happens, you'll need to update the ",(0,t.jsx)(n.code,{children:"runtimeVersion"})," in your project's app config. Once that's done, you'll need to make new builds, after which, you'll be able to send updates with ",(0,t.jsx)(n.code,{children:"eas update"}),"."]}),"\n",(0,t.jsx)(n.h2,{id:"set-your-own-updates-service",children:"Set your own updates service"}),"\n",(0,t.jsxs)(n.p,{children:["Some projects have unique requirements that require a self-hosted updates service. Since the expo-updates library is open source and follows the ",(0,t.jsx)(n.a,{href:"/../../../../../../../technical-specs/expo-updates-1",children:"Expo Updates protocol"}),", you can set up a ",(0,t.jsx)(n.a,{href:"/../../../../../../../distribution/custom-updates-server",children:"custom server to serve updates to your users"}),"."]})]})}n.default=function(){let e=arguments.length>0&&void 0!==arguments[0]?arguments[0]:{},{wrapper:n}=Object.assign({},(0,s.ah)(),e.components);return n?(0,t.jsx)(n,Object.assign({},e,{children:(0,t.jsx)(a,e)})):a(e)}}},function(e){e.O(0,[49774,92888,40179],function(){return e(e.s=65627)}),_N_E=e.O()}]);