(self.webpackChunk_N_E=self.webpackChunk_N_E||[]).push([[63632],{37654:function(e,n,i){(window.__NEXT_P=window.__NEXT_P||[]).push(["/build-reference/caching",function(){return i(91045)}])},91045:function(e,n,i){"use strict";i.r(n),i.d(n,{__N_SSG:function(){return r},headings:function(){return o},meta:function(){return c}});var s=i(85893),d=i(11151),r=!0;let c={title:"Caching dependencies",description:"Learn how to speed up your builds by caching dependencies."},o=[{depth:2,type:"text",title:"Custom caching"},{depth:2,type:"text",title:"JavaScript dependencies"},{depth:2,type:"text",title:"Android dependencies"},{depth:2,type:"text",title:"iOS dependencies"}];function t(e){let n=Object.assign({p:"p",blockquote:"blockquote",h2:"h2",code:"code",a:"a",strong:"strong",pre:"pre",ul:"ul",li:"li"},(0,d.ah)(),e.components);return(0,s.jsxs)(s.Fragment,{children:[(0,s.jsx)(n.p,{children:"Before a build job can begin compiling your project, all project dependencies need to be available on disk. The longer it takes to acquire the dependencies, the more you need to wait for your build to complete — so caching dependencies is an important part of speeding up your builds."}),"\n",(0,s.jsxs)(n.blockquote,{children:["\n",(0,s.jsx)(n.p,{children:"We're actively working on improving caching and other aspects of the build process to make builds reliably fast."}),"\n"]}),"\n",(0,s.jsx)(n.h2,{id:"custom-caching",children:"Custom caching"}),"\n",(0,s.jsxs)(n.p,{children:["The ",(0,s.jsx)(n.code,{children:"cache"})," field on build profiles in ",(0,s.jsx)(n.a,{href:"/../../../../../../../build/eas-json",children:"eas.json"})," can be used to configure caching for specific files and directories. Specified files will be saved to persistent storage after a successful build and restored on subsequent builds after the JavaScript dependencies are installed. Restoring does not overwrite existing files. Changing the ",(0,s.jsx)(n.code,{children:"cache.key"})," value will invalidate the cache. Changing any other property of the ",(0,s.jsx)(n.code,{children:"cache"})," object will also invalidate the cache."]}),"\n",(0,s.jsx)(n.h2,{id:"javascript-dependencies",children:"JavaScript dependencies"}),"\n",(0,s.jsxs)(n.p,{children:["EAS Build runs an npm cache server that can speed up downloading JavaScript dependencies for your build jobs. Projects that are using npm or yarn v2 will use the cache by default, but yarn v1 will require that you apply this ",(0,s.jsx)(n.a,{href:"/../../../../../../../build-reference/npm-cache-with-yarn",children:"workaround"}),"."]}),"\n",(0,s.jsxs)(n.p,{children:["To disable using our npm cache server for your builds set the ",(0,s.jsx)(n.code,{children:"EAS_BUILD_DISABLE_NPM_CACHE"})," env variable value to ",(0,s.jsx)(n.code,{children:'"1"'})," in ",(0,s.jsx)(n.strong,{children:"eas.json"}),"."]}),"\n","\n",(0,s.jsx)(n.pre,{children:(0,s.jsx)(n.code,{className:"language-json",children:'@@@eas.json@@@{\n  "build": {\n    "production": {\n      "env": {\n        "EAS_BUILD_DISABLE_NPM_CACHE": "1"\n        /* @hide ... */ /* @end */\n      }\n      /* @hide ... */ /* @end */\n    }\n    /* @hide ... */ /* @end */\n  }\n  /* @hide ... */ /* @end */\n}\n'})}),"\n",(0,s.jsx)(n.h2,{id:"android-dependencies",children:"Android dependencies"}),"\n",(0,s.jsx)(n.p,{children:"EAS Build runs a Maven cache server that can speed up downloading Android dependencies for your build jobs."}),"\n",(0,s.jsx)(n.p,{children:"Currently, we are caching:"}),"\n",(0,s.jsxs)(n.ul,{children:["\n",(0,s.jsxs)(n.li,{children:[(0,s.jsx)(n.code,{children:"maven-central"})," - ",(0,s.jsx)(n.a,{href:"https://repo1.maven.org/maven2/",children:"https://repo1.maven.org/maven2/"})]}),"\n",(0,s.jsxs)(n.li,{children:[(0,s.jsx)(n.code,{children:"google"})," - ",(0,s.jsx)(n.a,{href:"https://maven.google.com/",children:"https://maven.google.com/"})]}),"\n",(0,s.jsxs)(n.li,{children:[(0,s.jsx)(n.code,{children:"jcenter"})," - ",(0,s.jsx)(n.a,{href:"https://jcenter.bintray.com/",children:"https://jcenter.bintray.com/"})]}),"\n",(0,s.jsxs)(n.li,{children:[(0,s.jsx)(n.code,{children:"plugins"})," - ",(0,s.jsx)(n.a,{href:"https://plugins.gradle.org/m2/",children:"https://plugins.gradle.org/m2/"})]}),"\n"]}),"\n",(0,s.jsxs)(n.p,{children:["To disable using our Maven cache server for your builds set the ",(0,s.jsx)(n.code,{children:"EAS_BUILD_DISABLE_MAVEN_CACHE"})," env variable value to ",(0,s.jsx)(n.code,{children:'"1"'})," in ",(0,s.jsx)(n.strong,{children:"eas.json"}),"."]}),"\n","\n",(0,s.jsx)(n.pre,{children:(0,s.jsx)(n.code,{className:"language-json",children:'@@@eas.json@@@{\n  "build": {\n    "production": {\n      "env": {\n        "EAS_BUILD_DISABLE_MAVEN_CACHE": "1"\n        /* @hide ... */ /* @end */\n      }\n      /* @hide ... */ /* @end */\n    }\n    /* @hide ... */ /* @end */\n  }\n  /* @hide ... */ /* @end */\n}\n'})}),"\n",(0,s.jsx)(n.h2,{id:"ios-dependencies",children:"iOS dependencies"}),"\n",(0,s.jsxs)(n.p,{children:["EAS Build serves most CocoaPods artifacts from a cache server. This improves the consistency of ",(0,s.jsx)(n.code,{children:"pod install"})," times and generally improves speed. The cache will be bypassed automatically if you provide your own ",(0,s.jsx)(n.strong,{children:".netrc"})," or ",(0,s.jsx)(n.strong,{children:".curlrc"})," files."]}),"\n",(0,s.jsxs)(n.p,{children:["To use our CocoaPods cache server for your builds set the ",(0,s.jsx)(n.code,{children:"EAS_BUILD_DISABLE_COCOAPODS_CACHE"})," env variable value to ",(0,s.jsx)(n.code,{children:'"1"'})," in ",(0,s.jsx)(n.strong,{children:"eas.json"}),"."]}),"\n","\n",(0,s.jsx)(n.pre,{children:(0,s.jsx)(n.code,{className:"language-json",children:'@@@eas.json@@@{\n  "build": {\n    "production": {\n      "env": {\n        "EAS_BUILD_DISABLE_COCOAPODS_CACHE": "1"\n        /* @hide ... */ /* @end */\n      }\n      /* @hide ... */ /* @end */\n    }\n    /* @hide ... */ /* @end */\n  }\n  /* @hide ... */ /* @end */\n}\n'})}),"\n",(0,s.jsxs)(n.p,{children:["It is typical to not have your project ",(0,s.jsx)(n.strong,{children:"Podfile.lock"})," committed to source control when using ",(0,s.jsx)(n.a,{href:"/../../../../../../../workflow/prebuild",children:"prebuild"})," to generate your ",(0,s.jsx)(n.strong,{children:"ios"})," directory ",(0,s.jsx)(n.a,{href:"/../../../../../../../build-reference/ios-builds",children:"remotely at build time"}),".\nIt can be useful to cache your ",(0,s.jsx)(n.strong,{children:"Podfile.lock"})," in order to have deterministic builds, but the tradeoff in this case is that, because you don't use the lockfile during local development, your ability to determine when a change is needed and to update specific dependencies is limited.\nIf you cache this file, you may occasionally end up with build errors that require clearing the cache.\nTo cache ",(0,s.jsx)(n.strong,{children:"Podfile.lock"}),", add ",(0,s.jsx)(n.strong,{children:"./ios/Podfile.lock"})," to the ",(0,s.jsx)(n.code,{children:"cache.customPaths"})," list in your build profile in ",(0,s.jsx)(n.strong,{children:"eas.json"}),"."]}),"\n","\n",(0,s.jsx)(n.pre,{children:(0,s.jsx)(n.code,{className:"language-json",children:'@@@eas.json@@@{\n  "build": {\n    "production": {\n      "cache": {\n        "customPaths": ["./ios/Podfile.lock"]\n        /* @hide ... */ /* @end */\n      }\n      /* @hide ... */ /* @end */\n    }\n    /* @hide ... */ /* @end */\n  }\n  /* @hide ... */ /* @end */\n}\n'})})]})}n.default=function(){let e=arguments.length>0&&void 0!==arguments[0]?arguments[0]:{},{wrapper:n}=Object.assign({},(0,d.ah)(),e.components);return n?(0,s.jsx)(n,Object.assign({},e,{children:(0,s.jsx)(t,e)})):t(e)}}},function(e){e.O(0,[49774,92888,40179],function(){return e(e.s=37654)}),_N_E=e.O()}]);