(self.webpackChunk_N_E=self.webpackChunk_N_E||[]).push([[67529],{39660:function(e,i,n){(window.__NEXT_P=window.__NEXT_P||[]).push(["/build-reference/ios-builds",function(){return n(57840)}])},57840:function(e,i,n){"use strict";n.r(i),n.d(i,{__N_SSG:function(){return r},headings:function(){return o},meta:function(){return l}});var s=n(85893),t=n(11151),r=!0;let l={title:"iOS build process",description:"Learn how an iOS project is built on EAS Build."},o=[{depth:2,type:"text",title:"Build Process"},{depth:3,type:"text",title:"Local Steps"},{depth:3,type:"text",title:"Remote Steps"},{depth:2,type:"text",title:"Building iOS Projects With Fastlane"},{depth:3,type:"text",title:"Default Gymfile"}];function c(e){let i=Object.assign({p:"p",h2:"h2",h3:"h3",ol:"ol",li:"li",code:"code",strong:"strong",ul:"ul",a:"a",pre:"pre"},(0,t.ah)(),e.components);return(0,s.jsxs)(s.Fragment,{children:[(0,s.jsx)(i.p,{children:"This page describes the process of building iOS projects with EAS Build. You may want to read this if you are interested in the implementation details of the build service."}),"\n",(0,s.jsx)(i.h2,{id:"build-process",children:"Build Process"}),"\n",(0,s.jsx)(i.p,{children:"Let's take a closer look at the steps for building iOS projects with EAS Build. We'll first run some steps on your local machine to prepare the project and then we'll build the project on a remote service."}),"\n",(0,s.jsx)(i.h3,{id:"local-steps",children:"Local Steps"}),"\n",(0,s.jsx)(i.p,{children:"The first phase happens on your computer. EAS CLI is in charge of completing the following steps:"}),"\n",(0,s.jsxs)(i.ol,{children:["\n",(0,s.jsxs)(i.li,{children:["\n",(0,s.jsxs)(i.p,{children:["If ",(0,s.jsx)(i.code,{children:"cli.requireCommit"})," is set to ",(0,s.jsx)(i.code,{children:"true"})," in ",(0,s.jsx)(i.strong,{children:"eas.json"}),", check if the git index is clean - this means that there aren't any uncommitted changes. If it's not clean, EAS CLI will provide an option to commit local changes for you or abort the build process."]}),"\n"]}),"\n",(0,s.jsxs)(i.li,{children:["\n",(0,s.jsx)(i.p,{children:"Prepare the credentials needed for the build."}),"\n",(0,s.jsxs)(i.ul,{children:["\n",(0,s.jsxs)(i.li,{children:["Depending on the value of ",(0,s.jsx)(i.code,{children:"builds.ios.PROFILE_NAME.credentialsSource"}),", the credentials are obtained from either the local ",(0,s.jsx)(i.strong,{children:"credentials.json"})," file or from the EAS servers. If the ",(0,s.jsx)(i.code,{children:"remote"})," mode is selected but no credentials exist yet, you're offered to generate them."]}),"\n"]}),"\n"]}),"\n",(0,s.jsxs)(i.li,{children:["\n",(0,s.jsxs)(i.p,{children:[(0,s.jsx)(i.strong,{children:"Bare"})," projects require an additional step: check whether the Xcode project is configured to be buildable on the EAS servers (i.e. ensure the correct bundle identifier and Apple Team ID are set)."]}),"\n"]}),"\n",(0,s.jsxs)(i.li,{children:["\n",(0,s.jsxs)(i.p,{children:["Create the tarball containing a copy of the repository. Actual behavior depends on the ",(0,s.jsx)(i.a,{href:"https://expo.fyi/eas-vcs-workflow",children:"VCS workflow"})," you are using."]}),"\n"]}),"\n",(0,s.jsxs)(i.li,{children:["\n",(0,s.jsx)(i.p,{children:"Upload the project tarball to a private AWS S3 bucket and send the build request to EAS Build."}),"\n"]}),"\n"]}),"\n",(0,s.jsx)(i.h3,{id:"remote-steps",children:"Remote Steps"}),"\n",(0,s.jsx)(i.p,{children:"In this next phase, this is what happens when EAS Build picks up your request:"}),"\n",(0,s.jsxs)(i.ol,{children:["\n",(0,s.jsxs)(i.li,{children:["\n",(0,s.jsx)(i.p,{children:"Create a new macOS VM for the build."}),"\n",(0,s.jsxs)(i.ul,{children:["\n",(0,s.jsx)(i.li,{children:"Every build gets its own fresh macOS VM with all build tools installed there (Xcode, Fastlane, and so on)."}),"\n"]}),"\n"]}),"\n",(0,s.jsxs)(i.li,{children:["\n",(0,s.jsx)(i.p,{children:"Download the project tarball from a private AWS S3 bucket and unpack it."}),"\n"]}),"\n",(0,s.jsxs)(i.li,{children:["\n",(0,s.jsxs)(i.p,{children:[(0,s.jsxs)(i.a,{href:"/build-reference/build-reference/private-npm-packages",children:["Create ",(0,s.jsx)(i.strong,{children:".npmrc"})]})," if ",(0,s.jsx)(i.code,{children:"NPM_TOKEN"})," is set."]}),"\n"]}),"\n",(0,s.jsxs)(i.li,{children:["\n",(0,s.jsxs)(i.p,{children:["Run the ",(0,s.jsx)(i.code,{children:"eas-build-pre-install"})," script from ",(0,s.jsx)(i.strong,{children:"package.json"})," if defined."]}),"\n"]}),"\n",(0,s.jsxs)(i.li,{children:["\n",(0,s.jsxs)(i.p,{children:["Run ",(0,s.jsx)(i.code,{children:"npm install"})," in the project root (or ",(0,s.jsx)(i.code,{children:"yarn install"})," if ",(0,s.jsx)(i.strong,{children:"yarn.lock"})," exists)."]}),"\n"]}),"\n",(0,s.jsxs)(i.li,{children:["\n",(0,s.jsxs)(i.p,{children:["Run ",(0,s.jsx)(i.code,{children:"npx expo-doctor"})," to diagnose potential issues with your project configuration."]}),"\n"]}),"\n",(0,s.jsxs)(i.li,{children:["\n",(0,s.jsx)(i.p,{children:"Restore the credentials"}),"\n",(0,s.jsxs)(i.ul,{children:["\n",(0,s.jsx)(i.li,{children:"Create a new keychain."}),"\n",(0,s.jsx)(i.li,{children:"Import the Distribution Certificate into the keychain."}),"\n",(0,s.jsxs)(i.li,{children:["Write the Provisioning Profile to the ",(0,s.jsx)(i.strong,{children:"~/Library/MobileDevice/Provisioning Profiles"})," directory."]}),"\n",(0,s.jsx)(i.li,{children:"Verify that the Distribution Certificate and Provisioning Profile match (every Provisioning Profile is assigned to a particular Distribution Certificate and cannot be used for building the iOS with any other certificate)."}),"\n"]}),"\n"]}),"\n",(0,s.jsxs)(i.li,{children:["\n",(0,s.jsxs)(i.p,{children:["Additional step for ",(0,s.jsx)(i.strong,{children:"managed"})," projects: Run ",(0,s.jsx)(i.code,{children:"npx expo prebuild"})," to convert the project to a bare one. This step will use the versioned Expo CLI for projects that use Expo SDK 46+. In SDK 48 and lower, you can still choose to use the (deprecated) global Expo CLI installation by setting ",(0,s.jsx)(i.code,{children:"EXPO_USE_LOCAL_CLI=0"})," in the build profile."]}),"\n"]}),"\n",(0,s.jsxs)(i.li,{children:["\n",(0,s.jsxs)(i.p,{children:["Restore a previously saved cache identified by the ",(0,s.jsx)(i.code,{children:"cache.key"})," value in the ",(0,s.jsx)(i.a,{href:"/../../../../../../../build/eas-json",children:"build profile"}),"."]}),"\n"]}),"\n",(0,s.jsxs)(i.li,{children:["\n",(0,s.jsxs)(i.p,{children:["Run ",(0,s.jsx)(i.code,{children:"pod install"})," in the ",(0,s.jsx)(i.strong,{children:"ios"})," directory inside your project."]}),"\n"]}),"\n",(0,s.jsxs)(i.li,{children:["\n",(0,s.jsxs)(i.p,{children:["Run the ",(0,s.jsx)(i.code,{children:"eas-build-post-install"})," script from ",(0,s.jsx)(i.strong,{children:"package.json"})," if defined."]}),"\n"]}),"\n",(0,s.jsxs)(i.li,{children:["\n",(0,s.jsx)(i.p,{children:"Update the Xcode project with the ID of the Provisioning Profile."}),"\n"]}),"\n",(0,s.jsxs)(i.li,{children:["\n",(0,s.jsxs)(i.p,{children:["Create ",(0,s.jsx)(i.strong,{children:"Gymfile"})," in the ",(0,s.jsx)(i.strong,{children:"ios"})," directory if it does ",(0,s.jsx)(i.strong,{children:"not"})," already exist (check out the ",(0,s.jsx)(i.a,{href:"/build-reference/ios-builds/#default-gymfile",children:"Default Gymfile"})," section)."]}),"\n"]}),"\n",(0,s.jsxs)(i.li,{children:["\n",(0,s.jsxs)(i.p,{children:["Run ",(0,s.jsx)(i.code,{children:"fastlane gym"})," in the ",(0,s.jsx)(i.strong,{children:"ios"})," directory."]}),"\n"]}),"\n",(0,s.jsxs)(i.li,{children:["\n",(0,s.jsxs)(i.p,{children:[(0,s.jsx)(i.strong,{children:"Deprecated:"})," Run the ",(0,s.jsx)(i.code,{children:"eas-build-pre-upload-artifacts"})," script from ",(0,s.jsx)(i.strong,{children:"package.json"})," if defined."]}),"\n"]}),"\n",(0,s.jsxs)(i.li,{children:["\n",(0,s.jsxs)(i.p,{children:["Store a cache of files and directories defined in the ",(0,s.jsx)(i.a,{href:"/../../../../../../../build/eas-json",children:"build profile"}),". ",(0,s.jsx)(i.strong,{children:"Podfile.lock"})," is cached by default. Subsequent builds will restore this cache."]}),"\n"]}),"\n",(0,s.jsxs)(i.li,{children:["\n",(0,s.jsx)(i.p,{children:"Upload the application archive to a private AWS S3 bucket."}),"\n",(0,s.jsxs)(i.ul,{children:["\n",(0,s.jsxs)(i.li,{children:["The artifact path can be configured in ",(0,s.jsx)(i.strong,{children:"eas.json"})," at ",(0,s.jsx)(i.code,{children:"builds.ios.PROFILE_NAME.applicationArchivePath"}),". It defaults to ",(0,s.jsx)(i.strong,{children:"ios/build/App.ipa"}),". You can specify a glob-like pattern for ",(0,s.jsx)(i.code,{children:"applicationArchivePath"}),". We're using the ",(0,s.jsx)(i.a,{href:"https://github.com/mrmlnc/fast-glob#pattern-syntax",children:"fast-glob"})," package under the hood."]}),"\n"]}),"\n"]}),"\n",(0,s.jsxs)(i.li,{children:["\n",(0,s.jsxs)(i.p,{children:["If the build was successful: run the ",(0,s.jsx)(i.code,{children:"eas-build-on-success"})," script from ",(0,s.jsx)(i.strong,{children:"package.json"})," if defined."]}),"\n"]}),"\n",(0,s.jsxs)(i.li,{children:["\n",(0,s.jsxs)(i.p,{children:["If the build failed: run the ",(0,s.jsx)(i.code,{children:"eas-build-on-error"})," script from ",(0,s.jsx)(i.strong,{children:"package.json"})," if defined."]}),"\n"]}),"\n",(0,s.jsxs)(i.li,{children:["\n",(0,s.jsxs)(i.p,{children:["Run the ",(0,s.jsx)(i.code,{children:"eas-build-on-complete"})," script from ",(0,s.jsx)(i.strong,{children:"package.json"})," if defined. The ",(0,s.jsx)(i.code,{children:"EAS_BUILD_STATUS"})," env variable is set to either ",(0,s.jsx)(i.code,{children:"finished"})," or ",(0,s.jsx)(i.code,{children:"errored"}),"."]}),"\n"]}),"\n",(0,s.jsxs)(i.li,{children:["\n",(0,s.jsxs)(i.p,{children:["Upload the build artifacts archive to a private AWS S3 bucket if ",(0,s.jsx)(i.code,{children:"buildArtifactPaths"})," is specified in the build profile."]}),"\n"]}),"\n"]}),"\n",(0,s.jsx)(i.h2,{id:"building-ios-projects-with-fastlane",children:"Building iOS Projects With Fastlane"}),"\n",(0,s.jsxs)(i.p,{children:["We're using ",(0,s.jsx)(i.a,{href:"https://fastlane.tools/",children:"Fastlane"})," for building iOS projects. To be more precise, we're using the ",(0,s.jsx)(i.code,{children:"fastlane gym"})," command (",(0,s.jsx)(i.a,{href:"https://docs.fastlane.tools/actions/gym/",children:"see the Fastlane docs to learn more"}),"). This command allows you to declare the build configuration in ",(0,s.jsx)(i.strong,{children:"Gymfile"}),"."]}),"\n",(0,s.jsxs)(i.p,{children:["EAS Build can use your own ",(0,s.jsx)(i.strong,{children:"Gymfile"}),". All you need to do is to place this file in the ",(0,s.jsx)(i.strong,{children:"ios"})," directory."]}),"\n",(0,s.jsx)(i.h3,{id:"default-gymfile",children:"Default Gymfile"}),"\n",(0,s.jsxs)(i.p,{children:["If the ",(0,s.jsx)(i.strong,{children:"ios/Gymfile"})," file doesn't exist, the iOS builder creates a default one which looks similar to the following:"]}),"\n",(0,s.jsx)(i.pre,{children:(0,s.jsx)(i.code,{className:"language-rb",children:'suppress_xcode_output(true)\nclean(true)\n\nscheme("app")\n\nexport_options({\n  method: "app-store",\n  provisioningProfiles: {\n    "com.expo.eas.builds.test.application" => "dd83ed9c-4f89-462e-b901-60ae7fe6d737"\n  }\n})\n\nexport_xcargs "OTHER_CODE_SIGN_FLAGS=\\"--keychain /tmp/path/to/keychain\\""\n\ndisable_xcpretty(true)\n\noutput_directory("./build")\noutput_name("App")\n'})})]})}i.default=function(){let e=arguments.length>0&&void 0!==arguments[0]?arguments[0]:{},{wrapper:i}=Object.assign({},(0,t.ah)(),e.components);return i?(0,s.jsx)(i,Object.assign({},e,{children:(0,s.jsx)(c,e)})):c(e)}}},function(e){e.O(0,[49774,92888,40179],function(){return e(e.s=39660)}),_N_E=e.O()}]);