(self.webpackChunk_N_E=self.webpackChunk_N_E||[]).push([[24985],{91625:function(e,n,s){(window.__NEXT_P=window.__NEXT_P||[]).push(["/build-reference/npm-hooks",function(){return s(14227)}])},14227:function(e,n,s){"use strict";s.r(n),s.d(n,{__N_SSG:function(){return l},headings:function(){return d},meta:function(){return r}});var i=s(85893),o=s(11151),l=!0;let r={title:"Build lifecycle hooks",description:"Learn how to use the EAS Build lifecycle hooks with npm to customize your build process."},d=[{depth:2,type:"text",title:"Platform-specific hook behavior"},{depth:2,type:"text",title:"Examples"},{depth:3,type:"inlineCode",title:"package.json  and shell script"},{depth:3,type:"inlineCode",title:"package.json  and Node script"}];function c(e){let n=Object.assign({p:"p",strong:"strong",a:"a",ul:"ul",li:"li",code:"code",pre:"pre",h2:"h2",h3:"h3"},(0,o.ah)(),e.components);return(0,i.jsxs)(i.Fragment,{children:[(0,i.jsxs)(n.p,{children:["There are five EAS Build lifecycle npm hooks that you can set in your ",(0,i.jsx)(n.strong,{children:"package.json"}),". See the ",(0,i.jsx)(n.a,{href:"/build-reference/android-builds/",children:"Android build process"})," and ",(0,i.jsx)(n.a,{href:"/build-reference/ios-builds/",children:"iOS build process"})," docs to get a better understanding about the internals of the build process."]}),"\n",(0,i.jsxs)(n.ul,{children:["\n",(0,i.jsxs)(n.li,{children:[(0,i.jsx)(n.code,{children:"eas-build-pre-install"})," - executed before EAS Build runs ",(0,i.jsx)(n.code,{children:"npm install"}),"."]}),"\n",(0,i.jsxs)(n.li,{children:[(0,i.jsx)(n.code,{children:"eas-build-post-install"})," - the behavior depends on the platform and project type:","\n",(0,i.jsxs)(n.ul,{children:["\n",(0,i.jsxs)(n.li,{children:["Android - runs once after the following commands have all completed: ",(0,i.jsx)(n.code,{children:"npm install"})," and ",(0,i.jsx)(n.code,{children:"npx expo prebuild"})," (if needed)"]}),"\n",(0,i.jsxs)(n.li,{children:["iOS - runs once after the following commands have all completed: ",(0,i.jsx)(n.code,{children:"npm install"}),", ",(0,i.jsx)(n.code,{children:"npx expo prebuild"})," (if needed), and ",(0,i.jsx)(n.code,{children:"pod install"}),"."]}),"\n"]}),"\n"]}),"\n",(0,i.jsxs)(n.li,{children:[(0,i.jsx)(n.code,{children:"eas-build-on-success"})," - this hook is triggered at the end of the build process if the build was successful."]}),"\n",(0,i.jsxs)(n.li,{children:[(0,i.jsx)(n.code,{children:"eas-build-on-error"})," - this hook is triggered at the end of the build process if the build failed."]}),"\n",(0,i.jsxs)(n.li,{children:[(0,i.jsx)(n.code,{children:"eas-build-on-complete"})," - this hook is triggered at the end of the build process. You can check the build's status with the ",(0,i.jsx)(n.code,{children:"EAS_BUILD_STATUS"})," environment variable. It's either ",(0,i.jsx)(n.code,{children:"finished"})," or ",(0,i.jsx)(n.code,{children:"errored"}),"."]}),"\n"]}),"\n",(0,i.jsxs)(n.p,{children:["Below is an example of how your ",(0,i.jsx)(n.strong,{children:"package.json"})," can look with lifecycle hooks:"]}),"\n",(0,i.jsx)(n.pre,{children:(0,i.jsx)(n.code,{className:"language-json",children:'@@@package.json@@@{\n  "name": "my-app",\n  "scripts": {\n    "eas-build-pre-install": "echo 123",\n    "eas-build-post-install": "echo 456",\n    "eas-build-on-success": "echo 789",\n    "eas-build-on-error": "echo 012",\n    "start": "expo start",\n    "test": "jest"\n  },\n  "dependencies": {\n    "expo": "~46.0.0"\n    // ...\n  }\n}\n'})}),"\n",(0,i.jsx)(n.h2,{id:"platform-specific-hook-behavior",children:"Platform-specific hook behavior"}),"\n",(0,i.jsx)(n.p,{children:"If you would like to run a script (or some part of a script) only for iOS builds or only for Android builds, you can fork the behavior depending on the platform within the script. See examples for common ways to do this through a shell script or a Node script below."}),"\n",(0,i.jsx)(n.h2,{id:"examples",children:"Examples"}),"\n",(0,i.jsxs)(n.h3,{id:"packagejson-and-shell-script",children:[(0,i.jsx)(n.code,{children:"package.json"})," and shell script"]}),"\n",(0,i.jsx)(n.pre,{children:(0,i.jsx)(n.code,{className:"language-json",children:'@@@package.json@@@{\n  "name": "my-app",\n  "scripts": {\n    "eas-build-pre-install": "./pre-install",\n    "start": "expo start"\n    // ...\n  },\n  "dependencies": {\n    // ...\n  }\n}\n'})}),"\n",(0,i.jsx)(n.pre,{children:(0,i.jsx)(n.code,{className:"language-bash",children:'@@@pre-install@@@#!/bin/bash\n\n# This is a file called "pre-install" in the root of the project\n\nif [[ "$EAS_BUILD_PLATFORM" == "android" ]]; then\n  echo "Run commands for Android builds here"\nelif [[ "$EAS_BUILD_PLATFORM" == "ios" ]]; then\n  echo "Run commands for iOS builds here"\nfi\n'})}),"\n",(0,i.jsxs)(n.h3,{id:"packagejson-and-node-script",children:[(0,i.jsx)(n.code,{children:"package.json"})," and Node script"]}),"\n",(0,i.jsx)(n.pre,{children:(0,i.jsx)(n.code,{className:"language-json",children:'@@@package.json@@@{\n  "name": "my-app",\n  "scripts": {\n    "eas-build-pre-install": "node pre-install.js",\n    "start": "expo start"\n    // ...\n  },\n  "dependencies": {\n    // ...\n  }\n}\n'})}),"\n",(0,i.jsx)(n.pre,{children:(0,i.jsx)(n.code,{className:"language-js",children:"@@@pre-install.js@@@// This is a file called \"pre-install.js\" in the root of the project\n\nif (process.env.EAS_BUILD_PLATFORM === 'android') {\n  console.log('Run commands for Android builds here');\n} else if (process.env.EAS_BUILD_PLATFORM === 'ios') {\n  console.log('Run commands for iOS builds here');\n}\n"})})]})}n.default=function(){let e=arguments.length>0&&void 0!==arguments[0]?arguments[0]:{},{wrapper:n}=Object.assign({},(0,o.ah)(),e.components);return n?(0,i.jsx)(n,Object.assign({},e,{children:(0,i.jsx)(c,e)})):c(e)}}},function(e){e.O(0,[49774,92888,40179],function(){return e(e.s=91625)}),_N_E=e.O()}]);