(self.webpackChunk_N_E=self.webpackChunk_N_E||[]).push([[85715],{27980:function(e,n,i){(window.__NEXT_P=window.__NEXT_P||[]).push(["/build-reference/variants",function(){return i(72917)}])},55838:function(e,n,i){"use strict";i.d(n,{Z:function(){return t}});var o=i(35944),s=i(4903);function t(e){let{alt:n,src:i,style:t,containerStyle:r}=e;return(0,o.tZ)("div",{style:{textAlign:"center",backgroundColor:s.rS.background.subtle,paddingTop:10,paddingBottom:10,marginTop:20,marginBottom:20,...r},children:(0,o.tZ)("img",{src:i,alt:n,style:t,className:"inline"})})}},72917:function(e,n,i){"use strict";i.r(n),i.d(n,{__N_SSG:function(){return r},headings:function(){return d},meta:function(){return a}});var o=i(85893),s=i(11151),t=i(55838),r=!0;let a={title:"Installing app variants on the same device",maxHeadingDepth:4,description:"Learn how to install multiple instances of an app on the same device."},d=[{depth:2,type:"text",title:"Configuring development and production variants"},{depth:3,type:"text",title:"In managed project"},{depth:3,type:"text",title:"In bare project"},{depth:4,type:"text",title:"Android"},{depth:4,type:"text",title:"iOS"}];function l(e){let n=Object.assign({p:"p",a:"a",strong:"strong",code:"code",h2:"h2",h3:"h3",pre:"pre",blockquote:"blockquote",h4:"h4",ul:"ul",li:"li"},(0,s.ah)(),e.components);return(0,o.jsxs)(o.Fragment,{children:[(0,o.jsxs)(n.p,{children:["When creating ",(0,o.jsx)(n.a,{href:"/../../../../../../../build/eas-json/#common-use-cases",children:"development, preview, and production builds"}),", it's common to want to install one of each build on your device at the same time.\nThis allows you to do development work, preview the next version of your app, and run the production version all on the same device, without needing to uninstall and reinstall the app."]}),"\n",(0,o.jsx)(n.p,{children:"To be able to have multiple instances of an app installed on your device, each instance must have a unique Application ID (Android) or Bundle Identifier (iOS)."}),"\n",(0,o.jsxs)(n.p,{children:[(0,o.jsx)(n.strong,{children:"If you have a managed project"}),", this can be accomplished by using ",(0,o.jsx)(n.strong,{children:"app.config.js"})," and environment variables in ",(0,o.jsx)(n.strong,{children:"eas.json"}),"."]}),"\n",(0,o.jsxs)(n.p,{children:[(0,o.jsx)(n.strong,{children:"If you have a bare project"}),", you can accomplish this using flavors (Android) and targets (iOS). To configure which flavor is used, use the ",(0,o.jsx)(n.code,{children:"gradleCommand"})," field on your build profile. To configure which target is used, use the ",(0,o.jsx)(n.code,{children:"scheme"})," field for iOS."]}),"\n",(0,o.jsx)(n.h2,{id:"configuring-development-and-production-variants",children:"Configuring development and production variants"}),"\n",(0,o.jsx)(n.h3,{id:"in-managed-project",children:"In managed project"}),"\n",(0,o.jsxs)(n.p,{children:["Let's say we wanted a development build and production build of our managed Expo project. Your ",(0,o.jsx)(n.strong,{children:"eas.json"})," might look like this:"]}),"\n",(0,o.jsx)(n.pre,{children:(0,o.jsx)(n.code,{className:"language-json",children:'@@@eas.json@@@{\n  "build": {\n    "development": {\n      "developmentClient": true\n    },\n    "production": {}\n  }\n}\n'})}),"\n",(0,o.jsxs)(n.p,{children:["And your ",(0,o.jsx)(n.strong,{children:"app.json"})," might look like this:"]}),"\n",(0,o.jsx)(n.pre,{children:(0,o.jsx)(n.code,{className:"language-json",children:'@@@app.json@@@{\n  "expo": {\n    "name": "MyApp",\n    "slug": "my-app",\n    "ios": {\n      "bundleIdentifier": "com.myapp"\n    },\n    "android": {\n      "package": "com.myapp"\n    }\n  }\n}\n'})}),"\n",(0,o.jsxs)(n.p,{children:["Let's convert this to ",(0,o.jsx)(n.strong,{children:"app.config.js"})," so we can make it more dynamic:"]}),"\n",(0,o.jsx)(n.pre,{children:(0,o.jsx)(n.code,{className:"language-js",children:"@@@app.config.js@@@export default {\n  name: 'MyApp',\n  slug: 'my-app',\n  ios: {\n    bundleIdentifier: 'com.myapp',\n  },\n  android: {\n    package: 'com.myapp',\n  },\n};\n"})}),"\n",(0,o.jsxs)(n.p,{children:["Now let's switch out the iOS ",(0,o.jsx)(n.code,{children:"bundleIdentifier"})," and Android ",(0,o.jsx)(n.code,{children:"package"})," (which becomes the Application ID) based on the presence of an environment variable in ",(0,o.jsx)(n.strong,{children:"app.config.js"}),":"]}),"\n",(0,o.jsx)(n.pre,{children:(0,o.jsx)(n.code,{className:"language-js",children:"@@@app.config.js@@@const IS_DEV = process.env.APP_VARIANT === 'development';\n\nexport default {\n  // You can also switch out the app icon and other properties to further\n  // differentiate the app on your device.\n  name: IS_DEV ? 'MyApp (Dev)' : 'MyApp',\n  slug: 'my-app',\n  ios: {\n    bundleIdentifier: IS_DEV ? 'com.myapp.dev' : 'com.myapp',\n  },\n  android: {\n    package: IS_DEV ? 'com.myapp.dev' : 'com.myapp',\n  },\n};\n"})}),"\n",(0,o.jsxs)(n.blockquote,{children:["\n",(0,o.jsxs)(n.p,{children:[(0,o.jsx)(n.strong,{children:"Note"}),": if you are using any libraries that require you to register your application identifier with an external service to use the SDK, such as Google Maps, you will need to have a separate configuration for that API for the iOS Bundle Identifier and Android Package. You can also swap this configuration in using the same approach as above."]}),"\n"]}),"\n",(0,o.jsxs)(n.p,{children:["To automatically set the ",(0,o.jsx)(n.code,{children:"APP_VARIANT"}),' environment variable when running builds with the "development" profile, we can use ',(0,o.jsx)(n.code,{children:"env"})," in ",(0,o.jsx)(n.strong,{children:"eas.json"}),":"]}),"\n",(0,o.jsx)(n.pre,{children:(0,o.jsx)(n.code,{className:"language-json",children:'@@@eas.json@@@{\n  "build": {\n    "development": {\n      "developmentClient": true,\n      "env": {\n        "APP_VARIANT": "development"\n      }\n    },\n    "production": {}\n  }\n}\n'})}),"\n",(0,o.jsxs)(n.p,{children:["Now when you run ",(0,o.jsx)(n.code,{children:"eas build --profile development"}),", the environment variable ",(0,o.jsx)(n.code,{children:"APP_VARIANT"})," will be set to ",(0,o.jsx)(n.code,{children:'"development"'})," when evaluating ",(0,o.jsx)(n.strong,{children:"app.config.js"})," both locally and on the EAS Build worker. When you start your development server, you will need to run ",(0,o.jsx)(n.code,{children:"APP_VARIANT=development expo start"})," (or the platform equivalent if you use Windows); a shortcut for this could be to add a script to your ",(0,o.jsx)(n.strong,{children:"package.json"})," such as ",(0,o.jsx)(n.code,{children:'"dev": "APP_VARIANT=development expo start"'}),"."]}),"\n",(0,o.jsxs)(n.p,{children:["When you run ",(0,o.jsx)(n.code,{children:"eas build --profile production"})," the ",(0,o.jsx)(n.code,{children:"APP_VARIANT"})," variable environment will not be set, and the build will run as the production variant."]}),"\n",(0,o.jsxs)(n.blockquote,{children:["\n",(0,o.jsxs)(n.p,{children:[(0,o.jsx)(n.strong,{children:"Note"}),": if you use EAS Update to publish JavaScript updates of your app, you should be cautious to set the correct environment variables for the app variant that you are publishing for when you run the ",(0,o.jsx)(n.code,{children:"eas update"})," command. Refer to the EAS Build ",(0,o.jsx)(n.a,{href:"/../../../../../../../build/updates/",children:'"Environment variables and secrets" guide'})," for more information."]}),"\n"]}),"\n",(0,o.jsx)(n.h3,{id:"in-bare-project",children:"In bare project"}),"\n",(0,o.jsx)(n.h4,{id:"android",children:"Android"}),"\n",(0,o.jsxs)(n.p,{children:["In ",(0,o.jsx)(n.strong,{children:"android/app/build.gradle"}),", create a separate flavor for every build profile from ",(0,o.jsx)(n.strong,{children:"eas.json"})," that you want to build."]}),"\n",(0,o.jsx)(n.pre,{children:(0,o.jsx)(n.code,{className:"language-groovy",children:'@@@android/app/build.gradle@@@android {\n    /* @hide ... */ /* @end */\n    flavorDimensions "env"\n    productFlavors {\n        production {\n            dimension "env"\n            applicationId \'com.myapp\'\n        }\n        development {\n            dimension "env"\n            applicationId \'com.myapp.dev\'\n        }\n    }\n    /* @hide ... */ /* @end */\n}\n'})}),"\n",(0,o.jsxs)(n.blockquote,{children:["\n",(0,o.jsxs)(n.p,{children:[(0,o.jsx)(n.strong,{children:"Note"}),": Currently, EAS CLI supports only the ",(0,o.jsx)(n.code,{children:"applicationId"})," field. If you use ",(0,o.jsx)(n.code,{children:"applicationIdSuffix"})," inside ",(0,o.jsx)(n.code,{children:"productFlavors"})," or ",(0,o.jsx)(n.code,{children:"buildTypes"})," sections then this value will not be detected correctly."]}),"\n"]}),"\n",(0,o.jsxs)(n.p,{children:["Assign Android flavors to EAS build profiles by specifying a ",(0,o.jsx)(n.code,{children:"gradleCommand"})," in the ",(0,o.jsx)(n.strong,{children:"eas.json"}),":"]}),"\n",(0,o.jsx)(n.pre,{children:(0,o.jsx)(n.code,{className:"language-json",children:'@@@eas.json@@@{\n  "build": {\n    "development": {\n      "android": {\n        "gradleCommand": ":app:assembleDevelopmentDebug"\n      }\n    },\n    "production": {\n      "android": {\n        "gradleCommand": ":app:bundleProductionRelease"\n      }\n    }\n  }\n}\n'})}),"\n",(0,o.jsxs)(n.p,{children:["By default, every flavor can be built in either debug or release mode. If you want to restrict some flavor to a specific mode, see the snippet below, and modify ",(0,o.jsx)(n.strong,{children:"build.gradle"}),"."]}),"\n",(0,o.jsx)(n.pre,{children:(0,o.jsx)(n.code,{className:"language-groovy",children:'@@@android/app/build.gradle@@@android {\n    /* @hide ... */ /* @end */\n    variantFilter { variant ->\n        def validVariants = [\n                ["production", "release"],\n                ["development", "debug"],\n        ]\n        def buildTypeName = variant.buildType*.name\n        def flavorName = variant.flavors*.name\n\n        def isValid = validVariants.any { flavorName.contains(it[0]) && buildTypeName.contains(it[1]) }\n        if (!isValid) {\n            setIgnore(true)\n        }\n    }\n    /* @hide ... */ /* @end */\n}\n'})}),"\n",(0,o.jsx)(n.p,{children:"The rest of the configuration at this point is not specific to EAS, it's the same as it would be for any Android project with flavors. There are a few common configurations that you might want to apply to your project:"}),"\n",(0,o.jsxs)(n.ul,{children:["\n",(0,o.jsxs)(n.li,{children:["To change the name of the app built with the development profile, create a ",(0,o.jsx)(n.strong,{children:"android/app/src/development/res/value/strings.xml"})," file.","\n",(0,o.jsx)(n.pre,{children:(0,o.jsx)(n.code,{className:"language-xml",children:'<resources>\n    <string name="app_name">MyApp - Dev</string>\n</resources>\n'})}),"\n"]}),"\n",(0,o.jsxs)(n.li,{children:["To change the icon of the app built with the development profile, create ",(0,o.jsx)(n.code,{children:"android/app/src/development/res/mipmap-*"})," directories with appropriate assets (you can copy them from ",(0,o.jsx)(n.strong,{children:"android/app/src/main/res"})," and replace the icon files)."]}),"\n",(0,o.jsxs)(n.li,{children:["To specify ",(0,o.jsx)(n.strong,{children:"google-services.json"})," for a specific flavor put it in a ",(0,o.jsx)(n.strong,{children:"android/app/src/{flavor}/google-services.json"})," file."]}),"\n",(0,o.jsxs)(n.li,{children:["To configure sentry, add ",(0,o.jsx)(n.code,{children:"project.ext.sentryCli = [ flavorAware: true ]"})," to ",(0,o.jsx)(n.strong,{children:"android/app/build.gradle"})," and name your properties file ",(0,o.jsx)(n.code,{children:"android/sentry-{flavor}-{buildType}.properties"})," (for example: ",(0,o.jsx)(n.strong,{children:"android/sentry-production-release.properties"}),")"]}),"\n"]}),"\n",(0,o.jsx)(n.h4,{id:"ios",children:"iOS"}),"\n",(0,o.jsxs)(n.p,{children:["Assign a distinct scheme to every build profile in ",(0,o.jsx)(n.strong,{children:"eas.json"}),":"]}),"\n",(0,o.jsx)(n.pre,{children:(0,o.jsx)(n.code,{className:"language-json",children:'@@@eas.json@@@{\n  "build": {\n    "development": {\n      "ios": {\n        "buildConfiguration": "Debug",\n        "scheme": "myapp-dev"\n      }\n    },\n    "production": {\n      "ios": {\n        "buildConfiguration": "Release",\n        "scheme": "myapp"\n      }\n    }\n  }\n}\n'})}),"\n",(0,o.jsxs)(n.p,{children:[(0,o.jsx)(n.strong,{children:"Podfile"})," should have a target defined like this:"]}),"\n",(0,o.jsx)(n.pre,{children:(0,o.jsx)(n.code,{className:"language-ruby",children:"@@@Podfile@@@target 'myapp' do\n  # @hide ... #\n  # @end #\nend\n"})}),"\n",(0,o.jsx)(n.p,{children:"Replace it with an abstract target, where common configuration can be copied from the old target:"}),"\n",(0,o.jsx)(n.pre,{children:(0,o.jsx)(n.code,{className:"language-ruby",children:"@@@Podfile@@@abstract_target 'common' do\n  # put common target configuration here\n\n  target 'myapp' do\n  end\n\n  target 'myapp-dev' do\n  end\nend\n"})}),"\n",(0,o.jsx)(n.p,{children:'Open project in Xcode, click on the project name in the navigation panel, right click on the existing target, and click "Duplicate":'}),"\n",(0,o.jsx)(t.Z,{alt:"Duplicate Xcode target",src:"/static/images/eas-build/variants/1-ios-duplicate-target.png",style:{maxWidth:720}}),"\n",(0,o.jsxs)(n.p,{children:["Rename the target to something more meaningful, for example, ",(0,o.jsx)(n.code,{children:"myapp copy"})," -> ",(0,o.jsx)(n.code,{children:"myapp-dev"}),"."]}),"\n",(0,o.jsx)(n.p,{children:"Configure a scheme for the new target:"}),"\n",(0,o.jsxs)(n.ul,{children:["\n",(0,o.jsxs)(n.li,{children:["Go to ",(0,o.jsx)(n.code,{children:"Product"})," -> ",(0,o.jsx)(n.code,{children:"Scheme"})," -> ",(0,o.jsx)(n.code,{children:"Manage schemes"}),"."]}),"\n",(0,o.jsxs)(n.li,{children:["Find scheme ",(0,o.jsx)(n.code,{children:"myapp copy"})," on the list."]}),"\n",(0,o.jsxs)(n.li,{children:["Change scheme name ",(0,o.jsx)(n.code,{children:"myapp copy"})," -> ",(0,o.jsx)(n.code,{children:"myapp-dev"}),"."]}),"\n",(0,o.jsxs)(n.li,{children:["By default, the new scheme should be marked as shared, but Xcode does not create ",(0,o.jsx)(n.code,{children:".xcscheme"}),' files. To fix that, uncheck the "Shared" checkbox and check it again, after that new ',(0,o.jsx)(n.code,{children:".xcscheme"})," file should show up in the ",(0,o.jsx)(n.strong,{children:"ios/myapp.xcodeproj/xcshareddata/xcschemes"})," directory."]}),"\n"]}),"\n",(0,o.jsx)(t.Z,{alt:"Xcode scheme list",src:"/static/images/eas-build/variants/2-scheme-list.png",style:{maxWidth:720}}),"\n",(0,o.jsxs)(n.p,{children:["By default, the newly created target has separate ",(0,o.jsx)(n.strong,{children:"Info.plist"})," file (in our case it's ",(0,o.jsx)(n.strong,{children:"ios/myapp copy-Info.plist"}),"). To simplify your project we recommend using the same file for all targets:"]}),"\n",(0,o.jsxs)(n.ul,{children:["\n",(0,o.jsxs)(n.li,{children:["Delete ",(0,o.jsx)(n.strong,{children:"./ios/myapp copy-Info.plist"}),"."]}),"\n",(0,o.jsx)(n.li,{children:"Click on the new target."}),"\n",(0,o.jsxs)(n.li,{children:["Go to ",(0,o.jsx)(n.code,{children:"Build Settings"})," tab."]}),"\n",(0,o.jsxs)(n.li,{children:["Find ",(0,o.jsx)(n.code,{children:"Packaging"})," section."]}),"\n",(0,o.jsxs)(n.li,{children:["Change ",(0,o.jsx)(n.strong,{children:"Info.plist"})," value - ",(0,o.jsx)(n.strong,{children:"myapp copy-Info.plist"})," -> ",(0,o.jsx)(n.strong,{children:"myapp/Info.plist"}),"."]}),"\n",(0,o.jsxs)(n.li,{children:["Change ",(0,o.jsx)(n.code,{children:"Product Bundle Identifier"}),"."]}),"\n"]}),"\n",(0,o.jsx)(t.Z,{alt:"Xcode build settings",src:"/static/images/eas-build/variants/3-target-build-settings.png",style:{maxWidth:720}}),"\n",(0,o.jsx)(n.p,{children:"To change the display name:"}),"\n",(0,o.jsxs)(n.ul,{children:["\n",(0,o.jsxs)(n.li,{children:["Open ",(0,o.jsx)(n.strong,{children:"Info.plist"})," and add key ",(0,o.jsx)(n.code,{children:"Bundle display name"})," with value ",(0,o.jsx)(n.code,{children:"$(DISPLAY_NAME)"}),"."]}),"\n",(0,o.jsxs)(n.li,{children:["Open ",(0,o.jsx)(n.code,{children:"Build Settings"})," for both targets and find ",(0,o.jsx)(n.code,{children:"User-Defined"})," section."]}),"\n",(0,o.jsxs)(n.li,{children:["Add key ",(0,o.jsx)(n.code,{children:"DISPLAY_NAME"})," with the name you want to use for that target."]}),"\n"]}),"\n",(0,o.jsx)(n.p,{children:"To change the app icon:"}),"\n",(0,o.jsxs)(n.ul,{children:["\n",(0,o.jsxs)(n.li,{children:["Create a new image set (you can create it from the existing image set for the current icon, it's usually named ",(0,o.jsx)(n.code,{children:"AppIcon"}),")"]}),"\n",(0,o.jsxs)(n.li,{children:["Open ",(0,o.jsx)(n.code,{children:"Build Settings"})," for the target that you want to change icon."]}),"\n",(0,o.jsxs)(n.li,{children:["Find ",(0,o.jsx)(n.code,{children:"Asset Catalog Compiler - Options"})," section."]}),"\n",(0,o.jsxs)(n.li,{children:["Change ",(0,o.jsx)(n.code,{children:"Primary App Icon Set Name"})," to the name of the new image set."]}),"\n"]})]})}n.default=function(){let e=arguments.length>0&&void 0!==arguments[0]?arguments[0]:{},{wrapper:n}=Object.assign({},(0,s.ah)(),e.components);return n?(0,o.jsx)(n,Object.assign({},e,{children:(0,o.jsx)(l,e)})):l(e)}}},function(e){e.O(0,[49774,92888,40179],function(){return e(e.s=27980)}),_N_E=e.O()}]);