(self.webpackChunk_N_E=self.webpackChunk_N_E||[]).push([[91587],{96028:function(e,i,t){(window.__NEXT_P=window.__NEXT_P||[]).push(["/eas-update/code-signing",function(){return t(53914)}])},53914:function(e,i,t){"use strict";t.r(i),t.d(i,{__N_SSG:function(){return a},headings:function(){return d},meta:function(){return o}});var n=t(85893),s=t(11151),r=t(4049),a=!0;let o={title:"Code Signing",description:"Learn how code signing and key rotation work in EAS Update."},d=[{depth:2,type:"text",title:"Introduction"},{depth:2,type:"text",title:"Code Signing with EAS Update"},{depth:2,type:"text",title:"Key Rotation"},{depth:2,type:"text",title:"Removing Code Signing"}];function c(e){let i=Object.assign({blockquote:"blockquote",p:"p",a:"a",h2:"h2",code:"code",ol:"ol",li:"li",pre:"pre",ul:"ul",strong:"strong"},(0,s.ah)(),e.components);return(0,n.jsxs)(n.Fragment,{children:[(0,n.jsx)(r.Z,{title:"EAS Update Code Signing"}),"\n",(0,n.jsxs)(i.blockquote,{children:["\n",(0,n.jsxs)(i.p,{children:["EAS Update Code Signing is only available to accounts subscribed to the EAS Enterprise plan. ",(0,n.jsx)(i.a,{href:"https://expo.dev/pricing",children:"Sign up"}),"."]}),"\n"]}),"\n",(0,n.jsx)(i.h2,{id:"introduction",children:"Introduction"}),"\n",(0,n.jsxs)(i.p,{children:["The ",(0,n.jsx)(i.code,{children:"expo-updates"})," library supports end-to-end code signing. Code signing allows developers to cryptographically sign their updates with their own keys. The signatures are then verified on the client before the update is applied, which ensures ISPs, CDNs, cloud providers, and even EAS itself cannot tamper with updates run by apps."]}),"\n",(0,n.jsx)(i.h2,{id:"code-signing-with-eas-update",children:"Code Signing with EAS Update"}),"\n",(0,n.jsxs)(i.ol,{children:["\n",(0,n.jsxs)(i.li,{children:["\n",(0,n.jsx)(i.p,{children:"Generate a private key and corresponding code signing certificate for your app:"}),"\n",(0,n.jsx)(i.pre,{children:(0,n.jsx)(i.code,{className:"language-bash",children:'npx expo-updates codesigning:generate \\\n  --key-output-directory keys \\\n  --certificate-output-directory certs \\\n  --certificate-validity-duration-years 10 \\\n  --certificate-common-name "My App"\n'})}),"\n",(0,n.jsxs)(i.ul,{children:["\n",(0,n.jsx)(i.li,{children:"The generated private key must be kept private and secure."}),"\n",(0,n.jsxs)(i.li,{children:["The certificate validity duration is a setting that may vary based on the security needs of your app.","\n",(0,n.jsxs)(i.ul,{children:["\n",(0,n.jsxs)(i.li,{children:["A shorter validity duration will require ",(0,n.jsx)(i.a,{href:"/eas-update/code-signing/#key-rotation",children:"key rotation"})," more frequently but is considered better practice since a compromised private key will have a sooner expiration which limits exposure."]}),"\n",(0,n.jsx)(i.li,{children:"Shorter validity durations add overhead to your app's release process as the key must be rotated more frequently. Binaries with expired certificates won't apply new updates."}),"\n",(0,n.jsx)(i.li,{children:"For example, Expo sets this value to 20 years for the public Expo Go app, but only 1 year for internal apps with binaries that are distributed more frequently. We plan to rotate our keys every 10 years."}),"\n"]}),"\n"]}),"\n"]}),"\n"]}),"\n",(0,n.jsxs)(i.li,{children:["\n",(0,n.jsx)(i.p,{children:"Configure your app's builds to use code signing:"}),"\n",(0,n.jsx)(i.pre,{children:(0,n.jsx)(i.code,{className:"language-bash",children:"npx expo-updates codesigning:configure \\\n  --certificate-input-directory certs \\\n  --key-input-directory keys\n"})}),"\n",(0,n.jsx)(i.p,{children:"After this step, create a new build with a new runtime version. The code signing certificate will be embedded in this new build."}),"\n"]}),"\n",(0,n.jsxs)(i.li,{children:["\n",(0,n.jsx)(i.p,{children:"Publish a signed update for your app:"}),"\n",(0,n.jsx)(i.pre,{children:(0,n.jsx)(i.code,{className:"language-bash",children:"eas update --private-key-path keys/private-key.pem\n"})}),"\n",(0,n.jsxs)(i.p,{children:["During ",(0,n.jsx)(i.code,{children:"eas update"}),", the EAS CLI automatically detects that code signing is configured for your app. It then verifies the integrity of the update and creates a digital signature using your private key. This process is performed locally so that your private key never leaves your machine. The generated signature is automatically sent to EAS to store alongside the update."]}),"\n"]}),"\n",(0,n.jsxs)(i.li,{children:["\n",(0,n.jsx)(i.p,{children:"Download the update on the client (this step is done automatically by the library). The build from step (2) that is configured for code signing checks if there is a new update available. The server responds with the update published in step (3) and its generated signature. After being downloaded but before being applied, the update is verified against the embedded certificate and included signature. The update is applied if the certificate and signature are valid, and rejected otherwise."}),"\n"]}),"\n"]}),"\n",(0,n.jsx)(i.h2,{id:"key-rotation",children:"Key Rotation"}),"\n",(0,n.jsx)(i.p,{children:"Key rotation is the process by which the key pair used for signing updates is changed. This is most commonly done in a few cases:"}),"\n",(0,n.jsxs)(i.ul,{children:["\n",(0,n.jsxs)(i.li,{children:["Key expiration. In step (1) from the section above, we set ",(0,n.jsx)(i.code,{children:"certificate-validity-duration-years"})," to 10 years (though it can be configured to any value). This means that after 10 years, updates signed with the private key corresponding to the certificate will no longer be applied after being downloaded by the app. Updates downloaded prior to the expiration of their signing certificate will continue to function normally. Rotating keys well before the certificate expires helps to preempt any potential key expiration issues and helps to guarantee all users are using the new certificate before the old certificate expires."]}),"\n",(0,n.jsx)(i.li,{children:"Private key compromise. If the private key used to sign updates is accidentally exposed to the public, it can no longer be considered secure and therefore can no longer guarantee integrity of updates it signed. For example, a malicious actor could craft a malicious update and sign it with the leaked private key."}),"\n",(0,n.jsx)(i.li,{children:"Key rotation for security best practices. It is best practice to rotate keys periodically to ensure that a system is resilient to manual key rotation in response to one of the other reasons above."}),"\n"]}),"\n",(0,n.jsx)(i.p,{children:"In any of these cases, the procedure is similar:"}),"\n",(0,n.jsxs)(i.ol,{children:["\n",(0,n.jsx)(i.li,{children:"Backup the old key and certificate that were generated in step (1) above."}),"\n",(0,n.jsxs)(i.li,{children:["Generate a new key by following the steps above. To assist in debugging, you may wish to change the ",(0,n.jsx)(i.code,{children:"keyid"})," of the new key by modifying the ",(0,n.jsx)(i.code,{children:"updates.codeSigningMetadata.keyid"})," field in your app config (",(0,n.jsx)(i.strong,{children:"app.json"}),")."]}),"\n",(0,n.jsx)(i.li,{children:"The certificate is part of the app's runtime, so a new runtime version should be set for builds using this certificate to ensure that only updates signed with the new key run in the new build."}),"\n",(0,n.jsx)(i.li,{children:"Publish signed updates using the new key by following step (3) above."}),"\n"]}),"\n",(0,n.jsx)(i.h2,{id:"removing-code-signing",children:"Removing Code Signing"}),"\n",(0,n.jsxs)(i.p,{children:["The process of removing code signing from an app is similar to ",(0,n.jsx)(i.a,{href:"/eas-update/code-signing/#key-rotation",children:"key rotation"})," and can be thought of as a key rotation to a ",(0,n.jsx)(i.code,{children:"null"})," key."]}),"\n",(0,n.jsxs)(i.ol,{children:["\n",(0,n.jsx)(i.li,{children:"Backup the old key and certificate that were generated in step (1) above."}),"\n",(0,n.jsxs)(i.li,{children:["Remove the ",(0,n.jsx)(i.code,{children:"updates.codeSigningMetadata"})," field from your Expo config (",(0,n.jsx)(i.strong,{children:"app.json"}),")."]}),"\n",(0,n.jsx)(i.li,{children:"The new certificate-less app is a new distinct runtime, so a new runtime version should be set for builds to ensure that only unsigned updates run in the new build."}),"\n"]})]})}i.default=function(){let e=arguments.length>0&&void 0!==arguments[0]?arguments[0]:{},{wrapper:i}=Object.assign({},(0,s.ah)(),e.components);return i?(0,n.jsx)(i,Object.assign({},e,{children:(0,n.jsx)(c,e)})):c(e)}}},function(e){e.O(0,[49774,92888,40179],function(){return e(e.s=96028)}),_N_E=e.O()}]);