(self.webpackChunk_N_E=self.webpackChunk_N_E||[]).push([[96941],{76948:function(e,n,i){(window.__NEXT_P=window.__NEXT_P||[]).push(["/eas-update/runtime-versions",function(){return i(33707)}])},55838:function(e,n,i){"use strict";i.d(n,{Z:function(){return s}});var t=i(35944),o=i(4903);function s(e){let{alt:n,src:i,style:s,containerStyle:r}=e;return(0,t.tZ)("div",{style:{textAlign:"center",backgroundColor:o.rS.background.subtle,paddingTop:10,paddingBottom:10,marginTop:20,marginBottom:20,...r},children:(0,t.tZ)("img",{src:i,alt:n,style:s,className:"inline"})})}},33707:function(e,n,i){"use strict";i.r(n),i.d(n,{__N_SSG:function(){return r},headings:function(){return d},meta:function(){return a}});var t=i(85893),o=i(11151),s=i(55838),r=!0;let a={title:"Runtime versions and updates",description:"Learn about different runtime version policies and how they may suite your project."},d=[{depth:2,type:"inlineCode",title:'Setting  "runtimeVersion"'},{depth:3,type:"inlineCode",title:'"sdkVersion"  runtime version policy'},{depth:3,type:"inlineCode",title:'"appVersion"  runtime version policy (available in SDK 46 and higher)'},{depth:3,type:"inlineCode",title:'"nativeVersion"  runtime version policy'},{depth:3,type:"inlineCode",title:'Custom  "runtimeVersion"'},{depth:3,type:"inlineCode",title:'Platform specific  "runtimeVersion"'},{depth:2,type:"text",title:"Avoiding crashes with incompatible updates"}];function l(e){let n=Object.assign({p:"p",code:"code",h2:"h2",strong:"strong",h3:"h3",pre:"pre",a:"a",ul:"ul",li:"li"},(0,o.ah)(),e.components);return(0,t.jsxs)(t.Fragment,{children:[(0,t.jsx)(n.p,{children:"Runtime versions are a property that guarantees compatibility between a build's native code and an update. When a project is made into a build, the build will contain some native code that cannot be changed with an update. Therefore, an update must be compatible with a build's native code to run on the build."}),"\n",(0,t.jsx)(n.p,{children:"To illustrate how builds and updates interact, take a look at the following diagram:"}),"\n",(0,t.jsx)(s.Z,{alt:"Native and update layers diagram",src:"/static/images/eas-update/layers.png"}),"\n",(0,t.jsxs)(n.p,{children:["Builds can be thought of as two layers: a native layer that's built into the app's binary, and an update layer, that is swappable with other compatible updates. This separation allows us to ship bug fixes to builds as long as the update with the bug fix can run on the native layer inside the build. The ",(0,t.jsx)(n.code,{children:'"runtimeVersion"'})," property allows us to guarantee that an update is compatible with a specific build's native code."]}),"\n",(0,t.jsx)(n.p,{children:"Since updates must be compatible with a build's native code, any time native code is updated, we're required to make a new build before publishing an update. Some developers only update native code when upgrading to a new Expo SDK, while others may upgrade native code between builds or at other intervals. Below is an explanation of different situations and configurations that may suite your project."}),"\n",(0,t.jsxs)(n.h2,{id:"setting-runtimeversion",children:["Setting ",(0,t.jsx)(n.code,{children:'"runtimeVersion"'})]}),"\n",(0,t.jsxs)(n.p,{children:["To make managing the ",(0,t.jsx)(n.code,{children:'"runtimeVersion"'})," property easier between builds and updates, we've created runtime version policies that will update automatically based on other fields inside the app config (",(0,t.jsx)(n.strong,{children:"app.json"}),"/",(0,t.jsx)(n.strong,{children:"app.config.js"}),"). If these policies do not match the development flow of a project, there's also an option to set the ",(0,t.jsx)(n.code,{children:'"runtimeVersion"'})," manually."]}),"\n",(0,t.jsxs)(n.h3,{id:"sdkversion-runtime-version-policy",children:[(0,t.jsx)(n.code,{children:'"sdkVersion"'})," runtime version policy"]}),"\n",(0,t.jsxs)(n.p,{children:["By default, we provide the ",(0,t.jsx)(n.code,{children:'"sdkVersion"'})," runtime version policy after running ",(0,t.jsx)(n.code,{children:"eas update:configure"}),":"]}),"\n",(0,t.jsx)(n.pre,{children:(0,t.jsx)(n.code,{className:"language-json",children:'{\n  "expo": {\n    "runtimeVersion": {\n      "policy": "sdkVersion"\n    }\n  }\n}\n'})}),"\n",(0,t.jsxs)(n.p,{children:["The ",(0,t.jsx)(n.code,{children:'"sdkVersion"'})," policy will set the runtime version to the current SDK version of a project. For instance, if the project is on Expo SDK 1.0.0, the runtime version with this policy will be ",(0,t.jsx)(n.code,{children:'"exposdk:1.0.0"'}),". This runtime version will update any time we update the project's Expo SDK. So, if we ran ",(0,t.jsx)(n.code,{children:"expo upgrade"})," and installed Expo SDK 2.0.0, then the runtime version would become ",(0,t.jsx)(n.code,{children:'"exposdk:2.0.0"'}),"."]}),"\n",(0,t.jsx)(n.p,{children:"This runtime version policy is perfect if you are not including custom native code in your project and the only native changes you make are when upgrading Expo SDKs."}),"\n",(0,t.jsxs)(n.h3,{id:"appversion-runtime-version-policy-available-in-sdk-46-and-higher",children:[(0,t.jsx)(n.code,{children:'"appVersion"'})," runtime version policy (available in SDK 46 and higher)"]}),"\n",(0,t.jsxs)(n.p,{children:["We provide the ",(0,t.jsx)(n.code,{children:'"appVersion"'})," runtime version policy for projects that have custom native code that may change between builds:"]}),"\n",(0,t.jsx)(n.pre,{children:(0,t.jsx)(n.code,{className:"language-json",children:'{\n  "expo": {\n    "runtimeVersion": {\n      "policy": "appVersion"\n    }\n  }\n}\n'})}),"\n",(0,t.jsx)(n.p,{children:"For a project that has the following in its app config:"}),"\n",(0,t.jsx)(n.pre,{children:(0,t.jsx)(n.code,{className:"language-json",children:'{\n  "expo": {\n    "runtimeVersion": {\n      "policy": "appVersion"\n    },\n    "version": "1.0.0",\n    "ios": {\n      "buildNumber": "1"\n    },\n    "android": {\n      "versionCode": 1\n    }\n  }\n}\n'})}),"\n",(0,t.jsxs)(n.p,{children:["The ",(0,t.jsx)(n.code,{children:'"appVersion"'})," policy will set the runtime version to the projects current ",(0,t.jsx)(n.code,{children:'"version"'})," property. The runtime version for the iOS and Android builds and any updates would be in this case ",(0,t.jsx)(n.code,{children:'"1.0.0"'}),"."]}),"\n",(0,t.jsxs)(n.p,{children:["This policy is great for projects that contain custom native code and that update the ",(0,t.jsx)(n.code,{children:'"version"'})," field after every public release. To submit an app, the app stores require an updated native version number for each submitted build, which makes this policy convenient if you want to be sure that every version installed on user devices has a different runtime version."]}),"\n",(0,t.jsxs)(n.p,{children:["When using this policy, you need to manually update ",(0,t.jsx)(n.code,{children:'"version"'})," field in app config every time there is a public release, but for Play Store's Internal Test Track and the App Store's TestFlight uploads, you can rely on ",(0,t.jsx)(n.code,{children:'"autoIncrement"'})," option in ",(0,t.jsx)(n.strong,{children:"eas.json"})," to ",(0,t.jsx)(n.a,{href:"/build-reference/app-versions/#remote-version-source",children:"manage versions for you"}),"."]}),"\n",(0,t.jsxs)(n.h3,{id:"nativeversion-runtime-version-policy",children:[(0,t.jsx)(n.code,{children:'"nativeVersion"'})," runtime version policy"]}),"\n",(0,t.jsxs)(n.p,{children:["We provide the ",(0,t.jsx)(n.code,{children:'"nativeVersion"'})," runtime version policy for projects that have custom native code that may change between builds:"]}),"\n",(0,t.jsx)(n.pre,{children:(0,t.jsx)(n.code,{className:"language-json",children:'{\n  "expo": {\n    "runtimeVersion": {\n      "policy": "nativeVersion"\n    }\n  }\n}\n'})}),"\n",(0,t.jsxs)(n.p,{children:["The ",(0,t.jsx)(n.code,{children:'"nativeVersion"'})," policy will set the runtime version to the projects current ",(0,t.jsx)(n.code,{children:'"version"'})," and ",(0,t.jsx)(n.code,{children:'"buildNumber"'})," (iOS) or ",(0,t.jsx)(n.code,{children:'"versionCode"'})," (Android) properties. For a project that has the following in its app config:"]}),"\n",(0,t.jsx)(n.pre,{children:(0,t.jsx)(n.code,{className:"language-json",children:'{\n  "expo": {\n    "runtimeVersion": {\n      "policy": "nativeVersion"\n    },\n    "version": "1.0.0",\n    "ios": {\n      "buildNumber": "1"\n    },\n    "android": {\n      "versionCode": 1\n    }\n  }\n}\n'})}),"\n",(0,t.jsxs)(n.p,{children:["The runtime version for the iOS and Android builds and any updates would be the combination of ",(0,t.jsx)(n.code,{children:'"[version]([buildNumber|versionCode])"'}),", which in this case would be ",(0,t.jsx)(n.code,{children:'"1.0.0(1)"'}),"."]}),"\n",(0,t.jsxs)(n.p,{children:["This policy is great for projects that contain custom native code and that update the native version numbers (",(0,t.jsx)(n.code,{children:'"buildNumber"'})," for iOS and ",(0,t.jsx)(n.code,{children:'"versionCode"'})," for Android) for each build. To submit an app, the app stores require an updated native version number for each submitted build, which makes this policy convenient if you want to be sure that every app uploaded to Play Store's Internal Test Track and the App Store's TestFlight distribution tools has a different ",(0,t.jsx)(n.code,{children:"runtimeVersion"}),"."]}),"\n",(0,t.jsx)(n.p,{children:"It's important to know that this policy does require the developer to manage the native version numbers manually between each build."}),"\n",(0,t.jsx)(n.p,{children:"Also, if you select a different native version between iOS and Android, you'll end up with builds and updates with separate runtime versions. When you publish an update, EAS CLI will detect that two updates are needed, and it will create two updates with the required runtime versions and publish them separately."}),"\n",(0,t.jsxs)(n.h3,{id:"custom-runtimeversion",children:["Custom ",(0,t.jsx)(n.code,{children:'"runtimeVersion"'})]}),"\n",(0,t.jsxs)(n.p,{children:["You can also set a custom runtime version that meets the ",(0,t.jsx)(n.a,{href:"/../../../../../../../versions/latest/config/app/#runtimeversion",children:"runtime version formatting requirements"}),":"]}),"\n",(0,t.jsx)(n.pre,{children:(0,t.jsx)(n.code,{className:"language-json",children:'{\n  "expo": {\n    "runtimeVersion": "1.0.0"\n  }\n}\n'})}),"\n",(0,t.jsx)(n.p,{children:"This option is good for developers who want to manage the runtime version manually, separately from any other version numbers present in a project's app config. It gives the developer complete control over which updates are compatible with which builds."}),"\n",(0,t.jsxs)(n.h3,{id:"platform-specific-runtimeversion",children:["Platform specific ",(0,t.jsx)(n.code,{children:'"runtimeVersion"'})]}),"\n",(0,t.jsx)(n.p,{children:"You can also set a runtime version for a specific platform:"}),"\n",(0,t.jsx)(n.pre,{children:(0,t.jsx)(n.code,{className:"language-json",children:'{\n  "expo": {\n    "android": {\n      "runtimeVersion": "1.0.0"\n    }\n  }\n}\n'})}),"\n",(0,t.jsx)(n.p,{children:"When both a top level runtime and a platform specific runtime are set, the platform specific one takes precedence."}),"\n",(0,t.jsx)(n.h2,{id:"avoiding-crashes-with-incompatible-updates",children:"Avoiding crashes with incompatible updates"}),"\n",(0,t.jsxs)(n.p,{children:["The main issue that can arise when publishing updates is that the update could rely on native code that the build it's running on does not support. For instance, imagine we made a build with a runtime version of ",(0,t.jsx)(n.code,{children:'"1.0.0"'}),". Then, we submitted that build to the app stores and released it to the public."]}),"\n",(0,t.jsxs)(n.p,{children:["Later on, imagine that we developed an update that relied on a newly installed native library, like the ",(0,t.jsx)(n.code,{children:"expo-in-app-purchases"})," library, and we did not update the ",(0,t.jsx)(n.code,{children:'"runtimeVersion"'})," property, so that it is still ",(0,t.jsx)(n.code,{children:'"1.0.0"'}),". If we published an update, the builds with the ",(0,t.jsx)(n.code,{children:'"runtimeVersion"'})," of ",(0,t.jsx)(n.code,{children:'"1.0.0"'})," would think the incoming update with the same runtime version was compatible and it would attempt to load the update. Since the update would make calls to code that does not exist inside the build, the app would crash."]}),"\n",(0,t.jsx)(n.p,{children:"There are a few ways to avoid crashes like this:"}),"\n",(0,t.jsxs)(n.ul,{children:["\n",(0,t.jsxs)(n.li,{children:["Whenever we install or update native code, iterate the ",(0,t.jsx)(n.code,{children:'"runtimeVersion"'})," property in the project's app config (",(0,t.jsx)(n.strong,{children:"app.json"}),"/",(0,t.jsx)(n.strong,{children:"app.config.js"}),")."]}),"\n",(0,t.jsx)(n.li,{children:'Create a preview build of your app and load it on a test device. Then, publish the update to the "preview" branch to make sure it works as expected before publishing it to the project\'s production branch.'}),"\n"]}),"\n",(0,t.jsx)(n.p,{children:"If this error does occur, then you can republish a previous known-good update, then ask users to delete the app and reinstall it."}),"\n",(0,t.jsxs)(n.p,{children:["In the future, the ",(0,t.jsx)(n.code,{children:"expo-updates"})," library will prevent many instances of this from crashing the app. If we can detect this particular issue, we'll automatically roll back to a previous update instead of loading the bad update."]})]})}n.default=function(){let e=arguments.length>0&&void 0!==arguments[0]?arguments[0]:{},{wrapper:n}=Object.assign({},(0,o.ah)(),e.components);return n?(0,t.jsx)(n,Object.assign({},e,{children:(0,t.jsx)(l,e)})):l(e)}}},function(e){e.O(0,[49774,92888,40179],function(){return e(e.s=76948)}),_N_E=e.O()}]);