(self.webpackChunk_N_E=self.webpackChunk_N_E||[]).push([[68309],{87065:function(e,s,t){(window.__NEXT_P=window.__NEXT_P||[]).push(["/guides/assets",function(){return t(28887)}])},28887:function(e,s,t){"use strict";t.r(s),t.d(s,{__N_SSG:function(){return a},headings:function(){return r},meta:function(){return n}});var i=t(85893),o=t(11151),a=!0;let n={title:"Assets",description:"Learn about using local and remote assets."},r=[{depth:2,type:"text",title:"Local assets"},{depth:2,type:"text",title:"Remote assets"},{depth:2,type:"text",title:"Customizing supported asset extensions"},{depth:2,type:"text",title:"Optimization"},{depth:3,type:"text",title:"Images"},{depth:3,type:"text",title:"Fonts"}];function l(e){let s=Object.assign({p:"p",strong:"strong",h2:"h2",code:"code",pre:"pre",a:"a",h3:"h3"},(0,o.ah)(),e.components);return(0,i.jsxs)(i.Fragment,{children:[(0,i.jsxs)(s.p,{children:["Images, fonts, videos, sounds, and any other file that your app depends on that is not JavaScript are considered to be an ",(0,i.jsx)(s.strong,{children:"asset"}),"."]}),"\n",(0,i.jsx)(s.h2,{id:"local-assets",children:"Local assets"}),"\n",(0,i.jsxs)(s.p,{children:["Assets stored on your file system can be imported like JavaScript modules, using ",(0,i.jsx)(s.code,{children:"require"})," or ",(0,i.jsx)(s.code,{children:"import"}),". For example, from ",(0,i.jsx)(s.strong,{children:"App.js"}),", to render an image called ",(0,i.jsx)(s.strong,{children:"example.png"})," that is stored within the project's ",(0,i.jsx)(s.strong,{children:"assets/images"})," directory you can use ",(0,i.jsx)(s.code,{children:"require"})," to import the image and then pass it to the ",(0,i.jsx)(s.code,{children:"Image"})," component:"]}),"\n",(0,i.jsx)(s.pre,{children:(0,i.jsx)(s.code,{className:"language-jsx",children:"@@@App.js@@@<Image source={require('./assets/images/example.png')} />\n"})}),"\n",(0,i.jsxs)(s.p,{children:["The bundler will automatically provide a width and height for images imported this way. For more information, see ",(0,i.jsx)(s.a,{href:"https://reactnative.dev/docs/images#static-image-resources",children:"Static Image Resources"}),"."]}),"\n",(0,i.jsxs)(s.p,{children:["Libraries like ",(0,i.jsx)(s.a,{href:"/../../../../../../../versions/latest/sdk/video",children:(0,i.jsx)(s.code,{children:"expo-av"})})," and ",(0,i.jsx)(s.a,{href:"/../../../../../../../versions/latest/sdk/filesystem",children:(0,i.jsx)(s.code,{children:"expo-file-system"})})," work similar to ",(0,i.jsx)(s.code,{children:"Image"})," with local assets."]}),"\n",(0,i.jsx)(s.p,{children:"Local assets this way will be served over HTTP in development, and they will be automatically bundled into your app binary at build time."}),"\n",(0,i.jsxs)(s.p,{children:["When you publish an update to your app with ",(0,i.jsx)(s.a,{href:"/../../../../../../../eas-update/introduction",children:"EAS Update"}),", your assets will be uploaded and served from a CDN. Any asset that is not already included in the build that receives the update will be downloaded before launching the update. When testing an app in Expo Go, assets will be downloaded as the project is running. You can load these before your app starts with the ",(0,i.jsx)(s.a,{href:"/../../../../../../../versions/latest/sdk/asset",children:(0,i.jsx)(s.code,{children:"useAssets"})})," hook."]}),"\n",(0,i.jsx)(s.h2,{id:"remote-assets",children:"Remote assets"}),"\n",(0,i.jsxs)(s.p,{children:["To render a remote image, pass the URL to the image to the ",(0,i.jsx)(s.code,{children:"Image"})," component:"]}),"\n",(0,i.jsx)(s.pre,{children:(0,i.jsx)(s.code,{className:"language-jsx",children:"@@@App.js@@@<Image source={{ uri: 'https://example.com/logo.png' }} />\n"})}),"\n",(0,i.jsx)(s.p,{children:"No guarantee can be made about the availability of the images that you refer to with a web URL because an internet connection may not be available or the asset may have been removed. Additionally, we don't have the same amount of information about arbitrary web URLs: when your assets are available on the local filesystem, the bundler can read some metadata (for example, width and height) and pass that through to your app, so you don't need to specify a width and height. When specifying a remote web URL, you will need to explicitly specify a width and height, or it will default to 0x0. Lastly, as you will see later, caching behavior is different in both cases."}),"\n",(0,i.jsxs)(s.p,{children:["Libraries like ",(0,i.jsx)(s.a,{href:"/../../../../../../../versions/latest/sdk/video",children:(0,i.jsx)(s.code,{children:"expo-av"})})," and ",(0,i.jsx)(s.a,{href:"/../../../../../../../versions/latest/sdk/filesystem",children:(0,i.jsx)(s.code,{children:"expo-file-system"})})," work similar to ",(0,i.jsx)(s.code,{children:"Image"})," with local assets."]}),"\n",(0,i.jsxs)(s.p,{children:["Remote assets are not bundled into binaries at build time. They are also not considered part of an ",(0,i.jsx)(s.a,{href:"/../../../../../../../eas-update/introduction",children:"EAS Update"})," bundle."]}),"\n",(0,i.jsx)(s.h2,{id:"customizing-supported-asset-extensions",children:"Customizing supported asset extensions"}),"\n",(0,i.jsxs)(s.p,{children:["If you need to import a file type that is not recognized by Metro by default, you can modify the Metro configuration. For example, you may want to use the ",(0,i.jsx)(s.code,{children:".db"})," to import a database into your app. Read more about how to customize the asset extensions supported by Metro for iOS and Android in ",(0,i.jsx)(s.a,{href:"/../../../../../../../guides/customizing-metro",children:"Customizing Metro"})," and learn about how you can customize webpack for Web in ",(0,i.jsx)(s.a,{href:"/../../../../../../../guides/customizing-webpack",children:"Customizing webpack"}),"."]}),"\n",(0,i.jsx)(s.h2,{id:"optimization",children:"Optimization"}),"\n",(0,i.jsx)(s.h3,{id:"images",children:"Images"}),"\n",(0,i.jsxs)(s.p,{children:["You can compress images using tools such as ",(0,i.jsx)(s.a,{href:"https://github.com/google/guetzli",children:"guetzli"}),", ",(0,i.jsx)(s.a,{href:"https://pmt.sourceforge.io/pngcrush/",children:"pngcrush"}),", or ",(0,i.jsx)(s.a,{href:"http://optipng.sourceforge.net/",children:"optipng"}),". ",(0,i.jsx)(s.a,{href:"https://github.com/imagemin/imagemin",children:"imagemin"})," is another program and JS library that supports plugins for various optimizers. Many online services can optimize your images for you."]}),"\n",(0,i.jsx)(s.p,{children:"Some image optimizers are lossless. This means they re-encode your image to be smaller without any change, or loss, in the pixels that are displayed. When you need each pixel to be untouched from the original image, a lossless optimizer and a lossless image format like PNG is a good choices."}),"\n",(0,i.jsxs)(s.p,{children:["Other image optimizers are lossy, which means the optimized image is different than the original image. Often, lossy optimizers are more efficient because they discard visual information that reduces file size while making the image look nearly the same to humans. Tools like ",(0,i.jsx)(s.code,{children:"imagemagick"})," can use comparison algorithms like ",(0,i.jsx)(s.a,{href:"https://en.wikipedia.org/wiki/Structural_similarity",children:"SSIM"})," to give a sense of how similar two images look. It's quite common for an optimized image that is over 95% similar to the original image to be far less than 95% of the original file size!"]}),"\n",(0,i.jsx)(s.h3,{id:"fonts",children:"Fonts"}),"\n",(0,i.jsxs)(s.p,{children:["As explained above, in production builds, your local assets will all be bundled and loaded from disk rather than over the network as expected for native apps, but they must be loaded over the network when previewing in development builds. On the web, the font loading problem is known by: ",(0,i.jsx)(s.a,{href:"https://css-tricks.com/fout-foit-foft/",children:"Flash of Unstyled Text (FOUT), Flash of Invisible Text (FOIT), and Flash of Faux Text (FOFT)"}),"."]}),"\n",(0,i.jsxs)(s.p,{children:["The default behavior with ",(0,i.jsx)(s.a,{href:"/guides/icons/#icons",children:(0,i.jsx)(s.code,{children:"@expo/vector-icons"})})," icons is a FOIT on the first load, and on subsequent loads, the font will be automatically cached. You may want to preload fonts during the initial loading screen with ",(0,i.jsx)(s.a,{href:"/../../../../../../../versions/latest/sdk/font/#usefontsmap",children:(0,i.jsx)(s.code,{children:"useFonts"})}),". For example:"]}),"\n",(0,i.jsx)(s.pre,{children:(0,i.jsx)(s.code,{className:"language-jsx",children:"@@@App.js@@@useFonts([require('./assets/fonts/ComicSans.ttf', FontAwesome.font)]);\n"})})]})}s.default=function(){let e=arguments.length>0&&void 0!==arguments[0]?arguments[0]:{},{wrapper:s}=Object.assign({},(0,o.ah)(),e.components);return s?(0,i.jsx)(s,Object.assign({},e,{children:(0,i.jsx)(l,e)})):l(e)}}},function(e){e.O(0,[49774,92888,40179],function(){return e(e.s=87065)}),_N_E=e.O()}]);