(self.webpackChunk_N_E=self.webpackChunk_N_E||[]).push([[26369],{58365:function(e,t,r){(window.__NEXT_P=window.__NEXT_P||[]).push(["/guides/using-graphql",function(){return r(64050)}])},64050:function(e,t,r){"use strict";r.r(t),r.d(t,{__N_SSG:function(){return s},headings:function(){return h},meta:function(){return i}});var n=r(85893),a=r(11151),s=!0;let i={title:"Using GraphQL",description:"An overview of using GraphQL in an Expo project."},h=[{depth:2,type:"text",title:"Overview"},{depth:2,type:"text",title:"Communicating with a GraphQL API"},{depth:3,type:"text",title:"Fetching data with GraphQL queries"},{depth:3,type:"text",title:"Creating, updating and deleting data with GraphQL mutations"},{depth:2,type:"text",title:"The GraphQL schema"},{depth:3,type:"text",title:"The Schema Definition Language (SDL)"},{depth:3,type:"text",title:"Root types are the entry points for the API"},{depth:2,type:"text",title:"Getting started with GraphQL"},{depth:2,type:"text",title:"Next steps and resources"}];function o(e){let t=Object.assign({h2:"h2",p:"p",a:"a",em:"em",ul:"ul",li:"li",h3:"h3",pre:"pre",code:"code",blockquote:"blockquote",strong:"strong"},(0,a.ah)(),e.components);return(0,n.jsxs)(n.Fragment,{children:[(0,n.jsx)(t.h2,{id:"overview",children:"Overview"}),"\n",(0,n.jsxs)(t.p,{children:[(0,n.jsx)(t.a,{href:"http://graphql.org/",children:"GraphQL"})," is a ",(0,n.jsx)(t.em,{children:"query language"})," for APIs. It enables declarative data fetching and thus ties in perfectly with React/React Native as a declarative framework for building user interfaces. GraphQL can either complement or entirely replace the usage of REST APIs."]}),"\n",(0,n.jsxs)(t.p,{children:["The main difference between REST and GraphQL is that RESTful APIs have ",(0,n.jsx)(t.em,{children:"multiple endpoints"})," that return ",(0,n.jsx)(t.em,{children:"fixed data structures"})," whereas a GraphQL server only exposes a ",(0,n.jsx)(t.em,{children:"single endpoint"})," and returns ",(0,n.jsx)(t.em,{children:"flexible data structures"}),". This works because a client that needs data from the server also submits its precise data requirements in each request which allows the server to tailor the response exactly according to the client’s needs."]}),"\n",(0,n.jsxs)(t.p,{children:["You can learn more about the differences between GraphQL and REST ",(0,n.jsx)(t.a,{href:"https://www.howtographql.com/basics/1-graphql-is-the-better-rest/",children:"here"}),". To get a high-level overview and understand more about the architectural use cases of GraphQL, take a look at ",(0,n.jsx)(t.a,{href:"https://www.howtographql.com/basics/3-big-picture/",children:"this"})," article."]}),"\n",(0,n.jsx)(t.p,{children:"GraphQL has a rapidly growing community. To stay up-to-date about everything that’s happening in the GraphQL ecosystem, check out these resources:"}),"\n",(0,n.jsxs)(t.ul,{children:["\n",(0,n.jsxs)(t.li,{children:[(0,n.jsx)(t.a,{href:"https://www.graphqlweekly.com/",children:"GraphQL Weekly"}),": Weekly newsletter about GraphQL"]}),"\n",(0,n.jsxs)(t.li,{children:[(0,n.jsx)(t.a,{href:"https://www.graphql-europe.org/",children:"GraphQL Conf"}),": One of the world's biggest GraphQL conferences"]}),"\n"]}),"\n",(0,n.jsxs)(t.p,{children:["For an in-depth learning experience, visit the ",(0,n.jsx)(t.a,{href:"https://www.howtographql.com/",children:"How to GraphQL"})," fullstack tutorial website."]}),"\n",(0,n.jsx)(t.h2,{id:"communicating-with-a-graphql-api",children:"Communicating with a GraphQL API"}),"\n",(0,n.jsx)(t.p,{children:"In this section, we'll explain the core concepts you need to know when working with a GraphQL API."}),"\n",(0,n.jsx)(t.h3,{id:"fetching-data-with-graphql-queries",children:"Fetching data with GraphQL queries"}),"\n",(0,n.jsxs)(t.p,{children:["When an application needs to retrieve data from a GraphQL API, it has to send a ",(0,n.jsx)(t.em,{children:"query"})," to the server in which it specifies the data requirements. Most GraphQL servers accept only HTTP POST requests where the query is put into the ",(0,n.jsx)(t.em,{children:"body"})," of the request. Note however that GraphQL itself is actually ",(0,n.jsx)(t.em,{children:"transport layer agnostic"}),", meaning that the client-server communication could also happen using other networking protocols than HTTP."]}),"\n",(0,n.jsx)(t.p,{children:"Here’s an example query that a client might send in an Instagram-like application:"}),"\n",(0,n.jsx)(t.pre,{children:(0,n.jsx)(t.code,{className:"language-graphql",children:"query {\n  feed {\n    id\n    imageUrl\n    description\n  }\n}\n"})}),"\n",(0,n.jsxs)(t.p,{children:["The keyword ",(0,n.jsx)(t.code,{children:"query"})," in the beginning expresses the ",(0,n.jsx)(t.em,{children:"operation type"}),". Besides ",(0,n.jsx)(t.code,{children:"query"}),", there are two more operation types called ",(0,n.jsx)(t.code,{children:"mutation"})," and ",(0,n.jsx)(t.code,{children:"subscription"}),". Note that the default operation type of a request is in fact ",(0,n.jsx)(t.code,{children:"query"}),", so you might as well remove it from the above request. ",(0,n.jsx)(t.code,{children:"feed"})," is the ",(0,n.jsx)(t.em,{children:"root field"})," of the query and everything that follows is called the ",(0,n.jsx)(t.em,{children:"selection set"})," of the query."]}),"\n",(0,n.jsxs)(t.p,{children:["When a server receives the above query, it will ",(0,n.jsx)(t.a,{href:"https://blog.graph.cool/graphql-server-basics-the-schema-ac5e2950214e#1880",children:"resolve"})," it, i.e. collect the required data, and package up the response in the same format of the query. Here’s what a potential response could look like:"]}),"\n",(0,n.jsx)(t.pre,{children:(0,n.jsx)(t.code,{className:"language-json",children:'{\n  "data": {\n    "feed": [\n      {\n        "id": "1",\n        "description": "Nice Sunset",\n        "imageUrl": "http://example.org/sunset.png"\n      },\n      {\n        "id": "2",\n        "description": "Cute Cats",\n        "imageUrl": "http://example.org/cats.png"\n      }\n    ]\n  }\n}\n'})}),"\n",(0,n.jsxs)(t.p,{children:["The root of the returned JSON object is a field called ",(0,n.jsx)(t.code,{children:"data"})," as defined in the official ",(0,n.jsx)(t.a,{href:"http://spec.graphql.org/draft/#sec-Data",children:"GraphQL specification"}),". The rest of the JSON object then contains exactly the information that the client asked for in the query. If the client for example hadn’t included the ",(0,n.jsx)(t.code,{children:"imageUrl"})," in the query’s selection set, the server wouldn’t have included it in its response either."]}),"\n",(0,n.jsxs)(t.p,{children:["In case the GraphQL request fails for some reason, e.g. because the query was malformed, the server will not return the ",(0,n.jsx)(t.code,{children:"data"})," field but instead return an array called ",(0,n.jsx)(t.code,{children:"errors"})," with information about the failure. Notice that it can happen that the server returns both, ",(0,n.jsx)(t.code,{children:"data"})," ",(0,n.jsx)(t.em,{children:"and"})," ",(0,n.jsx)(t.code,{children:"errors"})," . This can occur when the server can only partially resolve a query, e.g. because the user requesting the data only had the access rights for specific parts of the query's payload."]}),"\n",(0,n.jsx)(t.h3,{id:"creating-updating-and-deleting-data-with-graphql-mutations",children:"Creating, updating and deleting data with GraphQL mutations"}),"\n",(0,n.jsxs)(t.p,{children:["Most of the time when working with an API, you’ll also want to make changes to the data that’s currently stored in the backend. In GraphQL, this is done using so-called ",(0,n.jsx)(t.em,{children:"mutations"}),". A mutation follows the exact same syntactical structure as a query. In fact, it actually also ",(0,n.jsx)(t.em,{children:"is"})," a query in that it combines a write operation with a directly following read operation. Essentially, the idea of a mutation corresponds to the PUT, POST and DELETE calls that you would run against a REST API but additionally allows you to fetch data in a single request."]}),"\n",(0,n.jsx)(t.p,{children:"Let’s consider an example mutation to create a new post in our sample Instagram app:"}),"\n",(0,n.jsx)(t.pre,{children:(0,n.jsx)(t.code,{className:"language-graphql",children:'mutation {\n  createPost(description: "Funny Birds", imageUrl: "http://example.org/birds.png") {\n    id\n  }\n}\n'})}),"\n",(0,n.jsxs)(t.p,{children:["Instead of the ",(0,n.jsx)(t.code,{children:"query"})," operation type, this time we’re using ",(0,n.jsx)(t.code,{children:"mutation"}),". Then follows the ",(0,n.jsx)(t.em,{children:"root field"}),", which in this case is called ",(0,n.jsx)(t.code,{children:"createPost"}),". Notice that all fields can also take arguments, here we provide the post’s ",(0,n.jsx)(t.code,{children:"description"})," and ",(0,n.jsx)(t.code,{children:"imageUrl"})," so the server knows what it should write into the database. In the payload of the mutation we simply specify the ",(0,n.jsx)(t.code,{children:"id"})," of the new post that will be generated on the server-side."]}),"\n",(0,n.jsx)(t.p,{children:"After the server created the new post in the database, it will return the following sample response to the client:"}),"\n",(0,n.jsx)(t.pre,{children:(0,n.jsx)(t.code,{className:"language-json",children:'{\n  "data": {\n    "createPost": {\n      "id": "1"\n    }\n  }\n}\n'})}),"\n",(0,n.jsx)(t.h2,{id:"the-graphql-schema",children:"The GraphQL schema"}),"\n",(0,n.jsx)(t.p,{children:"In this section, we'll discuss the backbone of every GraphQL server: The GraphQL schema."}),"\n",(0,n.jsxs)(t.blockquote,{children:["\n",(0,n.jsxs)(t.p,{children:["For a technical deep dive all around the GraphQL schema, be sure to check out ",(0,n.jsx)(t.a,{href:"https://blog.graph.cool/graphql-server-basics-the-schema-ac5e2950214e",children:"this"})," article."]}),"\n"]}),"\n",(0,n.jsx)(t.h3,{id:"the-schema-definition-language-sdl",children:"The Schema Definition Language (SDL)"}),"\n",(0,n.jsxs)(t.p,{children:["GraphQL has a ",(0,n.jsx)(t.a,{href:"http://graphql.org/learn/schema/#type-system",children:"type system"})," that’s used to define the capabilities of an API. These capabilities are written down in the GraphQL ",(0,n.jsx)(t.em,{children:"schema"})," using the syntax of the GraphQL ",(0,n.jsx)(t.a,{href:"https://www.apollographql.com/tutorials/lift-off-part1/03-schema-definition-language-sdl",children:"Schema Definition Language"})," (SDL). Here’s what the ",(0,n.jsx)(t.code,{children:"Post"})," type from our previous examples looks like:"]}),"\n",(0,n.jsx)(t.pre,{children:(0,n.jsx)(t.code,{className:"language-graphql",children:"type Post {\n  id: ID!\n  description: String!\n  imageUrl: String!\n}\n"})}),"\n",(0,n.jsxs)(t.p,{children:["The syntax is pretty straightforward. We’re defining a type called ",(0,n.jsx)(t.code,{children:"Post"})," that has three properties, in GraphQL terminology these properties are called ",(0,n.jsx)(t.em,{children:"fields"}),". Each field has a ",(0,n.jsx)(t.em,{children:"name"})," and a ",(0,n.jsx)(t.em,{children:"type"}),". The exclamation point following a type means that this field cannot be ",(0,n.jsx)(t.code,{children:"null"}),"."]}),"\n",(0,n.jsx)(t.h3,{id:"root-types-are-the-entry-points-for-the-api",children:"Root types are the entry points for the API"}),"\n",(0,n.jsxs)(t.p,{children:["Each schema has so-called ",(0,n.jsx)(t.a,{href:"http://graphql.org/learn/schema/#the-query-and-mutation-types",children:"root types"})," that define the ",(0,n.jsx)(t.em,{children:"entry points"})," into the API. These are the root types that you can define in your schema:"]}),"\n",(0,n.jsxs)(t.ul,{children:["\n",(0,n.jsxs)(t.li,{children:[(0,n.jsx)(t.code,{children:"Query"}),": Specifies all the queries a GraphQL server accepts"]}),"\n",(0,n.jsxs)(t.li,{children:[(0,n.jsx)(t.code,{children:"Mutation"}),": Specifies all the mutations a GraphQL server accepts"]}),"\n",(0,n.jsxs)(t.li,{children:[(0,n.jsx)(t.code,{children:"Subscription"}),": Specifies all the subscriptions a GraphQL server accepts (subscriptions are used for realtime functionality, learn more ",(0,n.jsx)(t.a,{href:"http://graphql.org/blog/subscriptions-in-graphql-and-relay/",children:"here"}),")"]}),"\n"]}),"\n",(0,n.jsxs)(t.p,{children:["To enable the ",(0,n.jsx)(t.code,{children:"feed"})," query and ",(0,n.jsx)(t.code,{children:"createPost"})," mutation that we saw in the previous examples, you’d have to write the root types as follows:"]}),"\n",(0,n.jsx)(t.pre,{children:(0,n.jsx)(t.code,{className:"language-graphql",children:"type Query {\n  feed: [Post!]!\n}\n\ntype Mutation {\n  createPost(description: String!, imageUrl: String!): Post\n}\n"})}),"\n",(0,n.jsxs)(t.p,{children:["You can read more about the core GraphQL constructs ",(0,n.jsx)(t.a,{href:"https://www.howtographql.com/basics/2-core-concepts/",children:"here"}),"."]}),"\n",(0,n.jsx)(t.h2,{id:"getting-started-with-graphql",children:"Getting started with GraphQL"}),"\n",(0,n.jsxs)(t.p,{children:["Learn how to build a GraphQL server, check out this ",(0,n.jsx)(t.a,{href:"https://www.howtographql.com/graphql-js/0-introduction/",children:"tutorial"}),"."]}),"\n",(0,n.jsx)(t.h2,{id:"next-steps-and-resources",children:"Next steps and resources"}),"\n",(0,n.jsxs)(t.p,{children:[(0,n.jsx)(t.strong,{children:"GraphQL server basics"})," — check out this tutorial series about GraphQL servers:"]}),"\n",(0,n.jsxs)(t.ul,{children:["\n",(0,n.jsx)(t.li,{children:(0,n.jsx)(t.a,{href:"https://www.prisma.io/blog/graphql-server-basics-the-schema-ac5e2950214e",children:"GraphQL Server Basics (Part 1): The Schema"})}),"\n",(0,n.jsx)(t.li,{children:(0,n.jsx)(t.a,{href:"https://www.prisma.io/blog/graphql-server-basics-the-network-layer-51d97d21861",children:"GraphQL Server Basics (Part 2): The Network Layer"})}),"\n",(0,n.jsx)(t.li,{children:(0,n.jsx)(t.a,{href:"https://www.prisma.io/blog/graphql-server-basics-demystifying-the-info-argument-in-graphql-resolvers-6f26249f613a",children:"GraphQL Server Basics (Part 3): Demystifying the info Argument in GraphQL Resolvers"})}),"\n"]})]})}t.default=function(){let e=arguments.length>0&&void 0!==arguments[0]?arguments[0]:{},{wrapper:t}=Object.assign({},(0,a.ah)(),e.components);return t?(0,n.jsx)(t,Object.assign({},e,{children:(0,n.jsx)(o,e)})):o(e)}}},function(e){e.O(0,[49774,92888,40179],function(){return e(e.s=58365)}),_N_E=e.O()}]);