(self.webpackChunk_N_E=self.webpackChunk_N_E||[]).push([[88252],{94317:function(e,n,t){(window.__NEXT_P=window.__NEXT_P||[]).push(["/push-notifications/sending-notifications-custom",function(){return t(40861)}])},40861:function(e,n,t){"use strict";t.r(n),t.d(n,{__N_SSG:function(){return s},headings:function(){return r},meta:function(){return a}});var o=t(85893),i=t(11151),s=!0;let a={title:"Send notifications with FCM & APNs",hideFromSearch:!0,description:"Learn how to send notifications with FCM and APNs."},r=[{depth:2,type:"text",title:"How to write FCM and APNs servers"},{depth:2,type:"text",title:"FCM server"},{depth:3,type:"text",title:"How to find FCM server key"},{depth:2,type:"text",title:"APNs server"},{depth:3,type:"text",title:"Authorization"},{depth:3,type:"text",title:"HTTP/2 connection"},{depth:2,type:"text",title:"Payload formats"},{depth:3,type:"text",title:"Android"},{depth:3,type:"text",title:"iOS"},{depth:3,type:"text",title:"Firebase notification types"}];function c(e){let n=Object.assign({p:"p",code:"code",h2:"h2",a:"a",pre:"pre",blockquote:"blockquote",strong:"strong",h3:"h3",ul:"ul",li:"li",ol:"ol"},(0,i.ah)(),e.components);return(0,o.jsxs)(o.Fragment,{children:[(0,o.jsxs)(n.p,{children:["You may need finer-grained control over your notifications, so communicating directly with FCM and APNs may be necessary. The Expo platform does not lock you into using Expo's application services, and the ",(0,o.jsx)(n.code,{children:"expo-notifications"})," API is push-service agnostic."]}),"\n",(0,o.jsx)(n.h2,{id:"how-to-write-fcm-and-apns-servers",children:"How to write FCM and APNs servers"}),"\n",(0,o.jsxs)(n.p,{children:["Before communicating directly with FCM & APNs, there is one client-side change you'll need to make in your app. When using Expo's notification service, you collect the ",(0,o.jsx)(n.code,{children:"ExponentPushToken"})," with ",(0,o.jsx)(n.a,{href:"/../../../../../../../versions/latest/sdk/notifications/#getexpopushtokenasyncoptions-expotokenoptions-expopushtoken",children:(0,o.jsx)(n.code,{children:"getExpoPushTokenAsync"})}),". Now that you're not using Expo's notification service, you'll need to collect the native device token instead with ",(0,o.jsx)(n.a,{href:"/../../../../../../../versions/latest/sdk/notifications/#getdevicepushtokenasync-devicepushtoken",children:(0,o.jsx)(n.code,{children:"getDevicePushTokenAsync"})}),"."]}),"\n",(0,o.jsx)(n.pre,{children:(0,o.jsx)(n.code,{className:"language-diff",children:"import * as Notifications from 'expo-notifications';\n...\n- const token = (await Notifications.getExpoPushTokenAsync()).data;\n+ const token = (await Notifications.getDevicePushTokenAsync()).data;\n// send token to your server\n"})}),"\n",(0,o.jsx)(n.p,{children:"After getting the native device token, you can start implementing the servers. Below are some minimal examples of communicating with FCM and APNs:"}),"\n",(0,o.jsx)(n.h2,{id:"fcm-server",children:"FCM server"}),"\n",(0,o.jsxs)(n.blockquote,{children:["\n",(0,o.jsxs)(n.p,{children:["This documentation is based on ",(0,o.jsx)(n.a,{href:"https://firebase.google.com/docs/cloud-messaging/http-server-ref",children:"Google's documentation"}),", and this section covers the basics to get you started."]}),"\n"]}),"\n",(0,o.jsxs)(n.p,{children:["Communicating with FCM is done by sending a POST request. However, before sending or receiving any notifications, you'll need to follow the steps to ",(0,o.jsx)(n.a,{href:"/../../../../../../../push-notifications/push-notifications-setup/#android",children:"configure FCM"})," to configure FCM and get your ",(0,o.jsx)(n.code,{children:"FCM-SERVER-KEY"}),"."]}),"\n",(0,o.jsxs)(n.blockquote,{children:["\n",(0,o.jsxs)(n.p,{children:["The following example uses FCM's legacy HTTP API, since the credentials setup for that is the same as it is for the Expo notifications service, so there's no additional work needed on your part. If you'd rather use FCM's HTTP v1 API, see ",(0,o.jsx)(n.a,{href:"https://firebase.google.com/docs/cloud-messaging/migrate-v1",children:"Firebase official documentation"}),"."]}),"\n"]}),"\n",(0,o.jsx)(n.pre,{children:(0,o.jsx)(n.code,{className:"language-js",children:"await fetch('https://fcm.googleapis.com/fcm/send', {\n  method: 'POST',\n  headers: {\n    'Content-Type': 'application/json',\n    Authorization: `key=<FCM-SERVER-KEY>`,\n  },\n  body: JSON.stringify({\n    to: '<NATIVE-DEVICE-PUSH-TOKEN>',\n    priority: 'normal',\n    data: {\n      experienceId: '@yourExpoUsername/yourProjectSlug',\n      scopeKey: '@yourExpoUsername/yourProjectSlug',\n      title: \"\uD83D\uDCE7 You've got mail\",\n      message: 'Hello world! \uD83C\uDF10',\n    },\n  }),\n});\n"})}),"\n",(0,o.jsxs)(n.p,{children:[(0,o.jsxs)(n.strong,{children:["The ",(0,o.jsx)(n.code,{children:"experienceId"})," and ",(0,o.jsx)(n.code,{children:"scopeKey"})," fields are required"]}),". Otherwise, your notifications will not go through to your app. FCM has a list of supported fields in the ",(0,o.jsx)(n.a,{href:"https://firebase.google.com/docs/cloud-messaging/http-server-ref#notification-payload-support",children:"notification payload"}),", and you can see which ones are supported by ",(0,o.jsx)(n.code,{children:"expo-notifications"})," on Android by looking at the ",(0,o.jsx)(n.a,{href:"/../../../../../../../versions/latest/sdk/notifications/#firebaseremotemessage",children:"FirebaseRemoteMessage"}),"."]}),"\n",(0,o.jsxs)(n.p,{children:["FCM also provides some ",(0,o.jsx)(n.a,{href:"https://firebase.google.com/docs/cloud-messaging/send-message#node.js",children:"server-side libraries in a few different languages"})," you can use instead of raw ",(0,o.jsx)(n.code,{children:"fetch"})," requests."]}),"\n",(0,o.jsx)(n.h3,{id:"how-to-find-fcm-server-key",children:"How to find FCM server key"}),"\n",(0,o.jsxs)(n.p,{children:["Your FCM server key can be found by making sure you've followed the ",(0,o.jsx)(n.a,{href:"/../../../../../../../push-notifications/push-notifications-setup/#android",children:"configuration steps"}),", and instead of uploading your FCM key to Expo, you would use that key directly in your server (as the ",(0,o.jsx)(n.code,{children:"FCM-SERVER-KEY"})," in the previous example)."]}),"\n",(0,o.jsx)(n.h2,{id:"apns-server",children:"APNs server"}),"\n",(0,o.jsxs)(n.blockquote,{children:["\n",(0,o.jsxs)(n.p,{children:["This documentation is based on ",(0,o.jsx)(n.a,{href:"https://developer.apple.com/library/archive/documentation/NetworkingInternet/Conceptual/RemoteNotificationsPG/APNSOverview.html",children:"Apple's documentation"}),", and this section covers the basics to get you started."]}),"\n"]}),"\n",(0,o.jsxs)(n.p,{children:["Communicating with APNs is a little more complicated than with FCM. Some libraries wrap all of this functionality into one or two function calls such as ",(0,o.jsx)(n.a,{href:"https://github.com/node-apn/node-apn",children:(0,o.jsx)(n.code,{children:"node-apn"})}),". However, in the examples below, a minimum set of libraries are used."]}),"\n",(0,o.jsx)(n.h3,{id:"authorization",children:"Authorization"}),"\n",(0,o.jsx)(n.p,{children:"Initially, before sending requests to APNS, you need permission to send notifications to your app. This is granted via a JSON web token which is generated using iOS developer credentials:"}),"\n",(0,o.jsxs)(n.ul,{children:["\n",(0,o.jsxs)(n.li,{children:["APN key (",(0,o.jsx)(n.code,{children:".p8"})," file) associated with your app"]}),"\n",(0,o.jsxs)(n.li,{children:["Key ID of the above ",(0,o.jsx)(n.code,{children:".p8"})," file"]}),"\n",(0,o.jsx)(n.li,{children:"Your Apple Team ID"}),"\n"]}),"\n",(0,o.jsx)(n.pre,{children:(0,o.jsx)(n.code,{className:"language-js",children:'const jwt = require("jsonwebtoken");\nconst authorizationToken = jwt.sign(\n  {\n    iss: "YOUR-APPLE-TEAM-ID"\n    iat: Math.round(new Date().getTime() / 1000),\n  },\n  fs.readFileSync("./path/to/appName_apns_key.p8", "utf8"),\n  {\n    header: {\n      alg: "ES256",\n      kid: "YOUR-P8-KEY-ID",\n    },\n  }\n);\n'})}),"\n",(0,o.jsx)(n.h3,{id:"http2-connection",children:"HTTP/2 connection"}),"\n",(0,o.jsxs)(n.p,{children:["After getting the ",(0,o.jsx)(n.code,{children:"authorizationToken"}),", you can open up an HTTP/2 connection to Apple's servers. In development, send requests to ",(0,o.jsx)(n.code,{children:"api.development.push.apple.com"}),". In production, send requests to ",(0,o.jsx)(n.code,{children:"api.push.apple.com"}),"."]}),"\n",(0,o.jsx)(n.p,{children:"Here's how to construct the request:"}),"\n",(0,o.jsx)(n.pre,{children:(0,o.jsx)(n.code,{className:"language-js",children:"const http2 = require('http2');\n\nconst client = http2.connect(\n  IS_PRODUCTION ? 'https://api.push.apple.com' : 'https://api.sandbox.push.apple.com'\n);\n\nconst request = client.request({\n  ':method': 'POST',\n  ':scheme': 'https',\n  'apns-topic': 'YOUR-BUNDLE-IDENTIFIER',\n  ':path': '/3/device/' + nativeDeviceToken, // This is the native device token you grabbed client-side\n  authorization: `bearer ${authorizationToken}`, // This is the JSON web token generated in the \"Authorization\" step\n});\nrequest.setEncoding('utf8');\n\nrequest.write(\n  JSON.stringify({\n    aps: {\n      alert: {\n        title: \"\uD83D\uDCE7 You've got mail!\",\n        body: 'Hello world! \uD83C\uDF10',\n      },\n    },\n    experienceId: '@yourExpoUsername/yourProjectSlug', // Required when testing in the Expo Go app\n    scopeKey: '@yourExpoUsername/yourProjectSlug', // Required when testing in the Expo Go app\n  })\n);\nrequest.end();\n"})}),"\n",(0,o.jsxs)(n.blockquote,{children:["\n",(0,o.jsxs)(n.p,{children:["This example is minimal and includes no error handling and connection pooling. For testing purposes, you can refer to ",(0,o.jsx)(n.a,{href:"https://github.com/expo/expo/blob/main/docs/public/static/code/sendNotificationToAPNS.js",children:(0,o.jsx)(n.code,{children:"sentNotificationToAPNS"})})," code."]}),"\n"]}),"\n",(0,o.jsxs)(n.p,{children:["APNs provide their full list of supported fields in the ",(0,o.jsx)(n.a,{href:"https://developer.apple.com/library/archive/documentation/NetworkingInternet/Conceptual/RemoteNotificationsPG/PayloadKeyReference.html",children:"notification payload"}),"."]}),"\n",(0,o.jsx)(n.h2,{id:"payload-formats",children:"Payload formats"}),"\n",(0,o.jsxs)(n.p,{children:["The examples in the previous section provide the bare minimum notification requests. You may have to send category identifiers, custom sounds, icons, custom key-value pairs, and so on. ",(0,o.jsxs)(n.a,{href:"/../../../../../../../versions/latest/sdk/notifications/#managing-notification-categories-interactive-notifications",children:[(0,o.jsx)(n.code,{children:"expo-notifications"})," documents"]})," all the fields it supports, and below are the example payloads Expo sends in its notifications service:"]}),"\n",(0,o.jsx)(n.h3,{id:"android",children:"Android"}),"\n",(0,o.jsx)(n.pre,{children:(0,o.jsx)(n.code,{className:"language-json",children:'{\n  "token": native device token string,\n  "collapse_key": string that identifies notification as collapsable,\n  "priority": "normal" || "high",\n  "data": {\n    "experienceId": "@yourExpoUsername/yourProjectSlug",\n    "scopeKey": "@yourExpoUsername/yourProjectSlug",\n    "title": title of your message,\n    "message": body of your message,\n    "channelId": the android channel ID associated with this notification,\n    "categoryId": the category associated with this notification,\n    "icon": the icon to show with this notification,\n    "link": the link this notification should open,\n    "sound": boolean or the custom sound file you\'d like to play,\n    "vibrate": "true" | "false" | number[],\n    "priority": AndroidNotificationPriority, // https://docs.expo.dev/versions/latest/sdk/notifications/#androidnotificationpriority\n    "badge": the number to set the icon badge to,\n    "body": { object of key-value pairs }\n  }\n}\n'})}),"\n",(0,o.jsx)(n.h3,{id:"ios",children:"iOS"}),"\n",(0,o.jsx)(n.pre,{children:(0,o.jsx)(n.code,{className:"language-json",children:'{\n  "aps": {\n    "alert": {\n      "title": title of your message,\n      "subtitle": subtitle of your message (shown below title, above body),\n      "body": body of your message,\n      "launch-image": the name of the launch image file to display,\n    },\n    "category": the category associated with this notification,\n    "badge": number to set badge count to upon notification\'s arrival,\n    "sound": the sound to play when the notification is received,\n    "thread-id": app-specific identifier for grouping related notifications\n  },\n  "body": { object of key-value pairs },\n  "experienceId": "@yourExpoUsername/yourProjectSlug",\n  "scopeKey": "@yourExpoUsername/yourProjectSlug",\n}\n'})}),"\n",(0,o.jsx)(n.h3,{id:"firebase-notification-types",children:"Firebase notification types"}),"\n",(0,o.jsxs)(n.p,{children:["There are two types of Firebase Cloud Messaging messages: ",(0,o.jsx)(n.a,{href:"https://firebase.google.com/docs/cloud-messaging/concept-options#notifications_and_data_messages",children:"notification and data messages"}),"."]}),"\n",(0,o.jsxs)(n.ol,{children:["\n",(0,o.jsxs)(n.li,{children:["\n",(0,o.jsxs)(n.p,{children:[(0,o.jsx)(n.strong,{children:"Notification"})," messages are only handled (and displayed) by the Firebase library. They don't necessarily wake the app, and ",(0,o.jsx)(n.code,{children:"expo-notifications"})," will not be made aware that your app has received any notification."]}),"\n"]}),"\n",(0,o.jsxs)(n.li,{children:["\n",(0,o.jsxs)(n.p,{children:[(0,o.jsx)(n.strong,{children:"Data"})," messages are not handled by the Firebase library. They are immediately handed off to your app for processing. That's where ",(0,o.jsx)(n.code,{children:"expo-notifications"})," interprets the data payload and takes action based on that data. ",(0,o.jsx)(n.strong,{children:"In almost all cases, this is the type of notification you have to send."})]}),"\n"]}),"\n"]}),"\n",(0,o.jsxs)(n.p,{children:["If you send a message of type ",(0,o.jsx)(n.strong,{children:"notification"})," instead of ",(0,o.jsx)(n.strong,{children:"data"})," directly through Firebase, you won't know if a user interacted with the notification (no ",(0,o.jsx)(n.code,{children:"onNotificationResponse"})," event available), and you won't be able to parse the notification payload for any data in your notification event-related listeners."]}),"\n",(0,o.jsxs)(n.blockquote,{children:["\n",(0,o.jsxs)(n.p,{children:["Using notification-type messages may have upsides when you need a configuration option that has not been exposed by ",(0,o.jsx)(n.code,{children:"expo-notifications"})," yet. In general, it may lead to less predictable situations than using only data-type messages and it's not our responsibility that you'll have to go to Google to report issues."]}),"\n"]}),"\n",(0,o.jsx)(n.p,{children:"Below is an example of each type using Node.js Firebase Admin SDK to send data-type messages instead of notification-type:"}),"\n",(0,o.jsx)(n.pre,{children:(0,o.jsx)(n.code,{className:"language-js",children:'const devicePushToken = /* ... */;\nconst options = /* ... */;\n\n// ❌ The following payload has a root-level notification object and\n// it will not trigger expo-notifications and may not work as expected.\nadmin.messaging().sendToDevice(\n  devicePushToken,\n  {\n    notification: {\n      title: "This is a notification-type message",\n      body: "`expo-notifications` will never see this \uD83D\uDE22",\n    },\n    data: {\n      photoId: 42,\n    },\n  },\n  options\n);\n\n// ✅ There is no "notification" key in the root level of the payload\n// so the message is a "data" message, thus triggering expo-notifications.\nadmin.messaging().sendToDevice(\n  devicePushToken,\n  {\n    data: {\n      title: "This is a data-type message",\n      message: "`expo-notifications` events will be triggered \uD83E\uDD17",\n      // ⚠️ Notice the schema of this payload is different\n      // than that of Firebase SDK. What is there called "body"\n      // here is a "message". For more info see:\n      // https://docs.expo.dev/versions/latest/sdk/notifications/#android-push-notification-payload-specification\n\n      body:                              // As per Android payload format specified above, the\n        JSON.stringify({ photoId: 42 }), // additional "data" should be placed under "body" key.\n    },\n  },\n  options\n);\n'})})]})}n.default=function(){let e=arguments.length>0&&void 0!==arguments[0]?arguments[0]:{},{wrapper:n}=Object.assign({},(0,i.ah)(),e.components);return n?(0,o.jsx)(n,Object.assign({},e,{children:(0,o.jsx)(c,e)})):c(e)}}},function(e){e.O(0,[49774,92888,40179],function(){return e(e.s=94317)}),_N_E=e.O()}]);