(self.webpackChunk_N_E=self.webpackChunk_N_E||[]).push([[2773],{26802:function(e,n,t){(window.__NEXT_P=window.__NEXT_P||[]).push(["/troubleshooting/application-has-not-been-registered",function(){return t(54282)}])},54282:function(e,n,t){"use strict";t.r(n),t.d(n,{__N_SSG:function(){return o},headings:function(){return a},meta:function(){return s}});var i=t(85893),r=t(11151),o=!0;let s={title:'"Application has not been registered" error'},a=[{depth:2,type:"text",title:"What this error means"},{depth:3,type:"text",title:"An exception may be preventing your app from registering itself"},{depth:3,type:"text",title:"Your app root component may not be registered"},{depth:2,type:"text",title:"Other considerations"}];function h(e){let n=Object.assign({p:"p",pre:"pre",code:"code",h2:"h2",h3:"h3",ol:"ol",li:"li",a:"a",strong:"strong",ul:"ul"},(0,r.ah)(),e.components);return(0,i.jsxs)(i.Fragment,{children:[(0,i.jsx)(n.p,{children:"When developing an Expo or React Native app, it's not uncommon to run into an error that looks like:"}),"\n",(0,i.jsx)(n.pre,{children:(0,i.jsx)(n.code,{children:'Application "main" has not been registered.\n'})}),"\n",(0,i.jsx)(n.p,{children:"or"}),"\n",(0,i.jsx)(n.pre,{children:(0,i.jsx)(n.code,{children:'Invariant Violation: "main" has not been registered.\n'})}),"\n",(0,i.jsx)(n.p,{children:'Where "main" can be any string.'}),"\n",(0,i.jsx)(n.h2,{id:"what-this-error-means",children:"What this error means"}),"\n",(0,i.jsx)(n.h3,{id:"an-exception-may-be-preventing-your-app-from-registering-itself",children:"An exception may be preventing your app from registering itself"}),"\n",(0,i.jsx)(n.p,{children:"The most common cause of this error is that there is an exception thrown in your application before it's able to register itself. When a React Native application loads, there are two steps:"}),"\n",(0,i.jsxs)(n.ol,{children:["\n",(0,i.jsx)(n.li,{children:"Load the JavaScript code, and if everything is successful, then your application will be registered. If there is any exception when loading the bundle then execution will be aborted and it will never reach the part where your application is registered."}),"\n",(0,i.jsx)(n.li,{children:"Run the registered application. If loading the code failed, then the application won't be registered and you will see the error that is the subject of this page."}),"\n"]}),"\n",(0,i.jsxs)(n.p,{children:["If you're in this situation, the error message you're seeing is a ",(0,i.jsx)(n.a,{href:"https://en.wikipedia.org/wiki/Red_herring",children:"red herring"}),", it's distracting you from the real error that led to the application not being registered."]}),"\n",(0,i.jsxs)(n.p,{children:["Look at your logs prior to this error message to see what may have caused it. A frequent cause is multiple versions of a native module dependency that registers itself as a view — for example ",(0,i.jsx)(n.a,{href:"https://stackoverflow.com/questions/67543844/invariant-violation-main-has-not-been-registered-while-running-react-native-a/67550379",children:"this Stack Overflow thread"})," where the poster has multiple versions of ",(0,i.jsx)(n.code,{children:"react-native-safe-area-context"})," in their dependencies."]}),"\n",(0,i.jsx)(n.h3,{id:"your-app-root-component-may-not-be-registered",children:"Your app root component may not be registered"}),"\n",(0,i.jsxs)(n.p,{children:["Another possibility is that there is a mismatch between the ",(0,i.jsx)(n.code,{children:"AppKey"})," being provided to ",(0,i.jsx)(n.a,{href:"https://reactnative.dev/docs/appregistry#registercomponent",children:(0,i.jsx)(n.code,{children:"AppRegistry.registerComponent"})}),", and the ",(0,i.jsx)(n.code,{children:"AppKey"})," being registered on the native iOS or Android side."]}),"\n",(0,i.jsxs)(n.p,{children:['In managed projects, the default behavior is to use "main" as the ',(0,i.jsx)(n.code,{children:"AppKey"}),". This is handled for your automatically, and as long as you don't change the ",(0,i.jsx)(n.code,{children:'"main"'})," field in your ",(0,i.jsx)(n.strong,{children:"package.json"})," from the default value then this will just work. If you want to customize the app entry point, please refer to the ",(0,i.jsx)(n.a,{href:"/../../../../../../../versions/latest/sdk/register-root-component/",children:"registerRootComponent"})," API reference."]}),"\n",(0,i.jsxs)(n.p,{children:["In projects with native code, you will see something like this in your ",(0,i.jsx)(n.strong,{children:"index.js"})," by default:"]}),"\n",(0,i.jsx)(n.pre,{children:(0,i.jsx)(n.code,{className:"language-js",children:"import { registerRootComponent } from 'expo';\nimport App from './App';\nregisterRootComponent(App);\n"})}),"\n",(0,i.jsxs)(n.p,{children:["where ",(0,i.jsx)(n.code,{children:"registerRootComponent"})," is implemented as:"]}),"\n",(0,i.jsx)(n.pre,{children:(0,i.jsx)(n.code,{className:"language-js",children:"function registerRootComponent(component) {\n  AppRegistry.registerComponent('main', () => component);\n}\n"})}),"\n",(0,i.jsxs)(n.p,{children:["And on the native side, in ",(0,i.jsx)(n.strong,{children:"AppDelegate.m"})," you should see:"]}),"\n",(0,i.jsx)(n.pre,{children:(0,i.jsx)(n.code,{className:"language-objectivec",children:'RCTRootView *rootView = [[RCTRootView alloc] initWithBridge:bridge moduleName:@"main" initialProperties:nil];\n'})}),"\n",(0,i.jsxs)(n.p,{children:["and in ",(0,i.jsx)(n.strong,{children:"MainActivity.java"}),":"]}),"\n",(0,i.jsx)(n.pre,{children:(0,i.jsx)(n.code,{className:"language-java",children:'@Override\nprotected String getMainComponentName() {\n  return "main";\n}\n'})}),"\n",(0,i.jsxs)(n.p,{children:["By default, \"main\" is consistently used throughout the project. If you're running into this error, it's likely that something has been changed and these values no longer coincide. Ensure that the names you are registering on the JavaScript side are the ones expected on the native side (if you're using Expo's ",(0,i.jsx)(n.code,{children:"registerRootComponent"}),' function, that would be "main").']}),"\n",(0,i.jsx)(n.h2,{id:"other-considerations",children:"Other considerations"}),"\n",(0,i.jsx)(n.p,{children:"This error can also occur in a few other scenarios, but it's less predictable and the fixes would be more specific to your project. For example, some other cases are:"}),"\n",(0,i.jsxs)(n.ul,{children:["\n",(0,i.jsxs)(n.li,{children:["You're connecting to the wrong project's local development server. Try closing out other Expo CLI or React Native community CLI processes (find them with ",(0,i.jsx)(n.code,{children:'ps -A | grep "expo\\|react-native"'}),")."]}),"\n",(0,i.jsxs)(n.li,{children:["If this error is only occurring in your production app, then try running the app locally in production mode with ",(0,i.jsx)(n.code,{children:"npx expo start --no-dev --minify"})," to find the source of the error."]}),"\n"]})]})}n.default=function(){let e=arguments.length>0&&void 0!==arguments[0]?arguments[0]:{},{wrapper:n}=Object.assign({},(0,r.ah)(),e.components);return n?(0,i.jsx)(n,Object.assign({},e,{children:(0,i.jsx)(h,e)})):h(e)}}},function(e){e.O(0,[49774,92888,40179],function(){return e(e.s=26802)}),_N_E=e.O()}]);