(self.webpackChunk_N_E=self.webpackChunk_N_E||[]).push([[31867],{98024:function(e,n,t){(window.__NEXT_P=window.__NEXT_P||[]).push(["/versions/latest/sdk/gl-view",function(){return t(84959)}])},84959:function(e,n,t){"use strict";t.r(n),t.d(n,{__N_SSG:function(){return a},headings:function(){return h},meta:function(){return d}});var r=t(85893),i=t(11151),s=t(60308),o=t(70111),l=t(51066),c=t(52892),a=!0;let d={title:"GLView",sourceCodeUrl:"https://github.com/expo/expo/tree/sdk-48/packages/expo-gl",packageName:"expo-gl",iconUrl:"/static/images/packages/expo-gl.png"},h=[{depth:2,type:"text",title:"Installation"},{depth:2,type:"text",title:"Usage"},{depth:2,type:"text",title:"High-level APIs"},{depth:2,type:"text",title:"Integration with Reanimated worklets"},{depth:3,type:"text",title:"Limitations"},{depth:2,type:"text",title:"Remote Debugging & GLView"},{depth:2,type:"text",title:"API"},{depth:2,type:"text",title:"WebGL API"}];function p(e){let n=Object.assign({p:"p",strong:"strong",code:"code",h2:"h2",pre:"pre",ul:"ul",li:"li",a:"a",h3:"h3"},(0,i.ah)(),e.components);return(0,r.jsxs)(r.Fragment,{children:[(0,r.jsxs)(n.p,{children:[(0,r.jsx)(n.strong,{children:(0,r.jsx)(n.code,{children:"expo-gl"})})," provides a ",(0,r.jsx)(n.code,{children:"View"})," that acts as an OpenGL ES render target, useful for rendering 2D and 3D graphics. On mounting, an OpenGL ES context is created. Its drawing buffer is presented as the contents of the ",(0,r.jsx)(n.code,{children:"View"})," every frame."]}),"\n",(0,r.jsx)(l.Z,{android:!0,emulator:!0,ios:!0,simulator:!0,web:!0}),"\n",(0,r.jsx)(n.h2,{id:"installation",children:"Installation"}),"\n",(0,r.jsx)(o.F,{}),"\n",(0,r.jsx)(n.h2,{id:"usage",children:"Usage"}),"\n",(0,r.jsx)(c.EA,{label:"Basic GL usage",dependencies:["expo-gl"],children:(0,r.jsx)(n.pre,{children:(0,r.jsx)(n.code,{className:"language-js",children:"import React from 'react';\nimport { View } from 'react-native';\nimport { GLView } from 'expo-gl';\n\nexport default function App() {\n  return (\n    <View style={{ flex: 1, justifyContent: 'center', alignItems: 'center' }}>\n      <GLView style={{ width: 300, height: 300 }} onContextCreate={onContextCreate} />\n    </View>\n  );\n}\n\nfunction onContextCreate(gl) {\n  gl.viewport(0, 0, gl.drawingBufferWidth, gl.drawingBufferHeight);\n  gl.clearColor(0, 1, 1, 1);\n\n  // Create vertex shader (shape & position)\n  const vert = gl.createShader(gl.VERTEX_SHADER);\n  gl.shaderSource(\n    vert,\n    `\n    void main(void) {\n      gl_Position = vec4(0.0, 0.0, 0.0, 1.0);\n      gl_PointSize = 150.0;\n    }\n  `\n  );\n  gl.compileShader(vert);\n\n  // Create fragment shader (color)\n  const frag = gl.createShader(gl.FRAGMENT_SHADER);\n  gl.shaderSource(\n    frag,\n    `\n    void main(void) {\n      gl_FragColor = vec4(0.0, 0.0, 0.0, 1.0);\n    }\n  `\n  );\n  gl.compileShader(frag);\n\n  // Link together into a program\n  const program = gl.createProgram();\n  gl.attachShader(program, vert);\n  gl.attachShader(program, frag);\n  gl.linkProgram(program);\n  gl.useProgram(program);\n\n  gl.clear(gl.COLOR_BUFFER_BIT);\n  gl.drawArrays(gl.POINTS, 0, 1);\n\n  gl.flush();\n  gl.endFrameEXP();\n}\n"})})}),"\n",(0,r.jsx)(n.h2,{id:"high-level-apis",children:"High-level APIs"}),"\n",(0,r.jsxs)(n.p,{children:["Since the WebGL API is quite low-level, it can be helpful to use higher-level graphics APIs rendering through a ",(0,r.jsx)(n.code,{children:"GLView"})," underneath. The following libraries integrate popular graphics APIs:"]}),"\n",(0,r.jsxs)(n.ul,{children:["\n",(0,r.jsxs)(n.li,{children:[(0,r.jsx)(n.a,{href:"https://github.com/expo/expo-three",children:"expo-three"})," for ",(0,r.jsx)(n.a,{href:"https://threejs.org",children:"three.js"})]}),"\n",(0,r.jsxs)(n.li,{children:[(0,r.jsx)(n.a,{href:"https://github.com/expo/expo-processing",children:"expo-processing"})," for ",(0,r.jsx)(n.a,{href:"http://processingjs.org",children:"processing.js"})]}),"\n"]}),"\n",(0,r.jsxs)(n.p,{children:["Any WebGL-supporting library that expects a ",(0,r.jsx)(n.a,{href:"https://www.khronos.org/registry/webgl/specs/latest/1.0/#5.14",children:"WebGLRenderingContext"})," could be used. Some times such libraries assume a web JavaScript context (such as assuming ",(0,r.jsx)(n.code,{children:"document"}),"). Usually this is for resource loading or event handling, with the main rendering logic still only using pure WebGL. So these libraries can usually still be used with a couple workarounds. The Expo-specific integrations above include workarounds for some popular libraries."]}),"\n",(0,r.jsx)(n.h2,{id:"integration-with-reanimated-worklets",children:"Integration with Reanimated worklets"}),"\n",(0,r.jsx)(n.p,{children:"To use this API inside Reanimated worklet, you need to pass the GL context ID to the worklet and recreate the GL object like in the example below."}),"\n",(0,r.jsx)(c.EA,{label:"GL usage in reanimated worklet",dependencies:["expo-gl","react-native-reanimated"],children:(0,r.jsx)(n.pre,{children:(0,r.jsx)(n.code,{className:"language-js",children:"import React from 'react';\nimport { View } from 'react-native';\nimport { runOnUI } from 'react-native-reanimated';\nimport { GLView } from 'expo-gl';\n\nfunction render(gl) {\n  'worklet';\n  // add your WebGL code here\n}\n\nfunction onContextCreate(gl) {\n  runOnUI((contextId: number) => {\n    'worklet';\n    const gl = GLView.getWorkletContext(contextId);\n    render(gl);\n  })(gl.contextId);\n}\n\nexport default function App() {\n  return (\n    <View style={{ flex: 1, justifyContent: 'center', alignItems: 'center' }}>\n      <GLView style={{ width: 300, height: 300 }} onContextCreate={onContextCreate} />\n    </View>\n  );\n}\n"})})}),"\n",(0,r.jsxs)(n.p,{children:["For more in-depth example on how to use ",(0,r.jsx)(n.code,{children:"expo-gl"})," with Reanimated and Gesture Handler you can check ",(0,r.jsx)(n.a,{href:"https://github.com/expo/expo/tree/main/apps/native-component-list/src/screens/GL/GLReanimatedExample.tsx",children:"this example"}),"."]}),"\n",(0,r.jsx)(n.h3,{id:"limitations",children:"Limitations"}),"\n",(0,r.jsx)(n.p,{children:"Worklet runtime is imposing some limitations on the code that runs inside it, so if you have existing WebGL code, it'll likely require some modifications to run inside a worklet thread."}),"\n",(0,r.jsxs)(n.ul,{children:["\n",(0,r.jsxs)(n.li,{children:["Third-party libraries like Pixi.js or Three.js won't work inside the worklet, you can only use functions that have ",(0,r.jsx)(n.code,{children:"'worklet'"})," added at the start."]}),"\n",(0,r.jsxs)(n.li,{children:["If you need to load some assets to pass to the WebGL code, it needs to be done on the main thread and passed via some reference to the worklet. If you are using ",(0,r.jsx)(n.code,{children:"expo-assets"})," you can just pass asset object returned by ",(0,r.jsx)(n.code,{children:"Asset.fromModule"})," or from hook ",(0,r.jsx)(n.code,{children:"useAssets"})," to the ",(0,r.jsx)(n.code,{children:"runOnUI"})," function."]}),"\n",(0,r.jsxs)(n.li,{children:["To implement a rendering loop you need to use ",(0,r.jsx)(n.code,{children:"requestAnimationFrame"}),", APIs like ",(0,r.jsx)(n.code,{children:"setTimeout"})," are not supported."]}),"\n",(0,r.jsx)(n.li,{children:"It's supported only on Android and iOS, it doesn't work on Web."}),"\n"]}),"\n",(0,r.jsxs)(n.p,{children:["Check ",(0,r.jsx)(n.a,{href:"https://docs.swmansion.com/react-native-reanimated/docs/fundamentals/worklets",children:"Reanimated documentation"})," to learn more."]}),"\n",(0,r.jsx)(n.h2,{id:"remote-debugging--glview",children:"Remote Debugging & GLView"}),"\n",(0,r.jsx)(n.p,{children:"This API does not function as intended with remote debugging enabled. The React Native debugger runs JavaScript on your computer, not the mobile device. GLView requires synchronous native calls that are not supported in Chrome."}),"\n",(0,r.jsx)(n.h2,{id:"api",children:"API"}),"\n",(0,r.jsx)(n.pre,{children:(0,r.jsx)(n.code,{className:"language-js",children:"import { GLView } from 'expo-gl';\n"})}),"\n",(0,r.jsx)(s.Z,{packageName:"expo-gl",apiName:"GLView"}),"\n",(0,r.jsx)(n.h2,{id:"webgl-api",children:"WebGL API"}),"\n",(0,r.jsxs)(n.p,{children:["Once the component is mounted and the OpenGL ES context has been created, the ",(0,r.jsx)(n.code,{children:"gl"})," object received through the ",(0,r.jsx)(n.code,{children:"onContextCreate"})," prop becomes the interface to the OpenGL ES context, providing a WebGL API. It resembles a ",(0,r.jsx)(n.a,{href:"https://www.khronos.org/registry/webgl/specs/latest/2.0/#3.7",children:"WebGL2RenderingContext"})," in the WebGL 2 spec."]}),"\n",(0,r.jsxs)(n.p,{children:["Some older Android devices may not support WebGL2 features. To check whether the device supports WebGL2 it's recommended to use ",(0,r.jsx)(n.code,{children:"gl instanceof WebGL2RenderingContext"}),"."]}),"\n",(0,r.jsxs)(n.p,{children:["An additional method ",(0,r.jsx)(n.code,{children:"gl.endFrameEXP()"})," is present, which notifies the context that the current frame is ready to present. This is similar to a 'swap buffers' API call in other OpenGL platforms."]}),"\n",(0,r.jsx)(n.p,{children:"The following WebGL2RenderingContext methods are currently unimplemented:"}),"\n",(0,r.jsxs)(n.ul,{children:["\n",(0,r.jsx)(n.li,{children:(0,r.jsx)(n.code,{children:"getFramebufferAttachmentParameter()"})}),"\n",(0,r.jsx)(n.li,{children:(0,r.jsx)(n.code,{children:"getRenderbufferParameter()"})}),"\n",(0,r.jsx)(n.li,{children:(0,r.jsx)(n.code,{children:"compressedTexImage2D()"})}),"\n",(0,r.jsx)(n.li,{children:(0,r.jsx)(n.code,{children:"compressedTexSubImage2D()"})}),"\n",(0,r.jsx)(n.li,{children:(0,r.jsx)(n.code,{children:"getTexParameter()"})}),"\n",(0,r.jsx)(n.li,{children:(0,r.jsx)(n.code,{children:"getUniform()"})}),"\n",(0,r.jsx)(n.li,{children:(0,r.jsx)(n.code,{children:"getVertexAttrib()"})}),"\n",(0,r.jsx)(n.li,{children:(0,r.jsx)(n.code,{children:"getVertexAttribOffset()"})}),"\n",(0,r.jsx)(n.li,{children:(0,r.jsx)(n.code,{children:"getBufferSubData()"})}),"\n",(0,r.jsx)(n.li,{children:(0,r.jsx)(n.code,{children:"getInternalformatParameter()"})}),"\n",(0,r.jsx)(n.li,{children:(0,r.jsx)(n.code,{children:"renderbufferStorageMultisample()"})}),"\n",(0,r.jsx)(n.li,{children:(0,r.jsx)(n.code,{children:"compressedTexImage3D()"})}),"\n",(0,r.jsx)(n.li,{children:(0,r.jsx)(n.code,{children:"compressedTexSubImage3D()"})}),"\n",(0,r.jsx)(n.li,{children:(0,r.jsx)(n.code,{children:"fenceSync()"})}),"\n",(0,r.jsx)(n.li,{children:(0,r.jsx)(n.code,{children:"isSync()"})}),"\n",(0,r.jsx)(n.li,{children:(0,r.jsx)(n.code,{children:"deleteSync()"})}),"\n",(0,r.jsx)(n.li,{children:(0,r.jsx)(n.code,{children:"clientWaitSync()"})}),"\n",(0,r.jsx)(n.li,{children:(0,r.jsx)(n.code,{children:"waitSync()"})}),"\n",(0,r.jsx)(n.li,{children:(0,r.jsx)(n.code,{children:"getSyncParameter()"})}),"\n",(0,r.jsx)(n.li,{children:(0,r.jsx)(n.code,{children:"getActiveUniformBlockParameter()"})}),"\n"]}),"\n",(0,r.jsxs)(n.p,{children:["The ",(0,r.jsx)(n.code,{children:"pixels"})," argument of ",(0,r.jsx)(n.a,{href:"https://developer.mozilla.org/en-US/docs/Web/API/WebGLRenderingContext/texImage2D",children:(0,r.jsx)(n.code,{children:"texImage2D()"})})," must be ",(0,r.jsx)(n.code,{children:"null"}),", an ",(0,r.jsx)(n.code,{children:"ArrayBuffer"})," with pixel data, or an object of the form ",(0,r.jsx)(n.code,{children:"{ localUri }"})," where ",(0,r.jsx)(n.code,{children:"localUri"})," is the ",(0,r.jsx)(n.code,{children:"file://"})," URI of an image in the device's file system. Thus, an ",(0,r.jsx)(n.code,{children:"Asset"})," object is used once ",(0,r.jsx)(n.code,{children:".downloadAsync()"})," has been called on it (and completed) to fetch the resource."]}),"\n",(0,r.jsx)(n.p,{children:"For efficiency reasons, the current implementations of the methods don't perform type or bounds checking on their arguments. So, passing invalid arguments may cause a native crash. There are plans to update the API to perform argument checking in upcoming SDK versions."}),"\n",(0,r.jsx)(n.p,{children:"Currently, the priority for error checking is low since engines generally don't rely on the OpenGL API to perform argument checking; otherwise, checks performed by the underlying OpenGL ES implementation are often sufficient."})]})}n.default=function(){let e=arguments.length>0&&void 0!==arguments[0]?arguments[0]:{},{wrapper:n}=Object.assign({},(0,i.ah)(),e.components);return n?(0,r.jsx)(n,Object.assign({},e,{children:(0,r.jsx)(p,e)})):p(e)}}},function(e){e.O(0,[67328,9218,49774,92888,40179],function(){return e(e.s=98024)}),_N_E=e.O()}]);