(self.webpackChunk_N_E=self.webpackChunk_N_E||[]).push([[79028],{91373:function(e,n,t){(window.__NEXT_P=window.__NEXT_P||[]).push(["/versions/v48.0.0/sdk/securestore",function(){return t(91208)}])},91208:function(e,n,t){"use strict";t.r(n),t.d(n,{__N_SSG:function(){return l},headings:function(){return h},meta:function(){return p}});var r=t(85893),s=t(11151),o=t(60308),a=t(70111),i=t(51066),c=t(52892),l=!0;let p={title:"SecureStore",sourceCodeUrl:"https://github.com/expo/expo/tree/sdk-48/packages/expo-secure-store",packageName:"expo-secure-store",iconUrl:"/static/images/packages/expo-secure-store.png"},h=[{depth:2,type:"text",title:"Installation"},{depth:2,type:"text",title:"Platform value storage"},{depth:3,type:"text",title:"Android"},{depth:3,type:"text",title:"iOS"},{depth:4,type:"text",title:"Exempting encryption prompt"},{depth:2,type:"text",title:"Usage"},{depth:2,type:"text",title:"API"}];function d(e){let n=Object.assign({p:"p",code:"code",strong:"strong",blockquote:"blockquote",h2:"h2",h3:"h3",a:"a",h4:"h4",pre:"pre"},(0,s.ah)(),e.components);return(0,r.jsxs)(r.Fragment,{children:[(0,r.jsxs)(n.p,{children:[(0,r.jsx)(n.code,{children:"expo-secure-store"})," provides a way to encrypt and securely store key–value pairs locally on the device. Each Expo project has a separate storage system and has no access to the storage of other Expo projects."]}),"\n",(0,r.jsx)(n.p,{children:(0,r.jsx)(n.strong,{children:"Size limit for a value is 2048 bytes. An attempt to store larger values may fail. Currently, we print a warning when the limit is reached, however, in a future SDK version an error might be thrown."})}),"\n",(0,r.jsx)(i.Z,{android:!0,emulator:!0,ios:!0,simulator:!0}),"\n",(0,r.jsxs)(n.blockquote,{children:["\n",(0,r.jsx)(n.p,{children:"This API is not compatible with devices running Android 5 or lower."}),"\n"]}),"\n",(0,r.jsx)(n.h2,{id:"installation",children:"Installation"}),"\n",(0,r.jsx)(a.F,{}),"\n",(0,r.jsx)(n.h2,{id:"platform-value-storage",children:"Platform value storage"}),"\n",(0,r.jsx)(n.h3,{id:"android",children:"Android"}),"\n",(0,r.jsxs)(n.p,{children:["On Android, values are stored in ",(0,r.jsx)(n.a,{href:"https://developer.android.com/training/data-storage/shared-preferences",children:(0,r.jsx)(n.code,{children:"SharedPreferences"})}),", encrypted with ",(0,r.jsx)(n.a,{href:"https://developer.android.com/training/articles/keystore.html",children:"Android's Keystore system"}),"."]}),"\n",(0,r.jsx)(n.h3,{id:"ios",children:"iOS"}),"\n",(0,r.jsxs)(n.blockquote,{children:["\n",(0,r.jsxs)(n.p,{children:["For iOS standalone apps, data stored with ",(0,r.jsx)(n.code,{children:"expo-secure-store"})," can persist across app installs."]}),"\n"]}),"\n",(0,r.jsxs)(n.p,{children:["On iOS, values are stored using the ",(0,r.jsx)(n.a,{href:"https://developer.apple.com/documentation/security/keychain_services",children:"keychain services"})," as ",(0,r.jsx)(n.code,{children:"kSecClassGenericPassword"}),". iOS has the additional option of being able to set the value's ",(0,r.jsx)(n.code,{children:"kSecAttrAccessible"})," attribute, which controls when the value is available to be fetched."]}),"\n",(0,r.jsx)(n.h4,{id:"exempting-encryption-prompt",children:"Exempting encryption prompt"}),"\n",(0,r.jsxs)(n.p,{children:["Apple App Store Connect prompts you to select the type of encryption algorithm your app implements. This is known as ",(0,r.jsx)(n.strong,{children:"Export Compliance Information"}),". It is asked when publishing the app or submitting for TestFlight."]}),"\n",(0,r.jsxs)(n.p,{children:["When using ",(0,r.jsx)(n.code,{children:"expo-secure-store"}),", you can set the ",(0,r.jsx)(n.a,{href:"/../../../../../../../versions/latest/config/app/#usesnonexemptencryption",children:(0,r.jsx)(n.code,{children:"ios.config.usesNonExemptEncryption"})})," property to ",(0,r.jsx)(n.code,{children:"false"})," in the Expo config:"]}),"\n","\n",(0,r.jsx)(n.pre,{children:(0,r.jsx)(n.code,{className:"language-json",children:'@@@app.json@@@{\n  "expo": {\n    "ios": {\n      "config": {\n        "usesNonExemptEncryption": false\n      }\n      /* @hide ... */ /* @end */\n    }\n  }\n}\n'})}),"\n",(0,r.jsx)(n.p,{children:"Setting this property automatically handles the compliance information prompt."}),"\n",(0,r.jsx)(n.h2,{id:"usage",children:"Usage"}),"\n",(0,r.jsx)(c.EA,{label:"SecureStore",dependencies:["expo-secure-store"],platforms:["ios","android"],children:(0,r.jsx)(n.pre,{children:(0,r.jsx)(n.code,{className:"language-jsx",children:"import * as React from 'react';\nimport { Text, View, StyleSheet, TextInput, Button } from 'react-native';\nimport * as SecureStore from 'expo-secure-store';\n\nasync function save(key, value) {\n  await SecureStore.setItemAsync(key, value);\n}\n\nasync function getValueFor(key) {\n  let result = await SecureStore.getItemAsync(key);\n  if (result) {\n    alert(\"\uD83D\uDD10 Here's your value \uD83D\uDD10 \\n\" + result);\n  } else {\n    alert('No values stored under that key.');\n  }\n}\n\nexport default function App() {\n  const [key, onChangeKey] = React.useState('Your key here');\n  const [value, onChangeValue] = React.useState('Your value here');\n\n  return (\n    <View style={styles.container}>\n      <Text style={styles.paragraph}>Save an item, and grab it later!</Text>\n      {/* @hide Add some TextInput components... */}\n\n      <TextInput\n        style={styles.textInput}\n        clearTextOnFocus\n        onChangeText={text => onChangeKey(text)}\n        value={key}\n      />\n      <TextInput\n        style={styles.textInput}\n        clearTextOnFocus\n        onChangeText={text => onChangeValue(text)}\n        value={value}\n      />\n      {/* @end */}\n      <Button\n        title=\"Save this key/value pair\"\n        onPress={() => {\n          save(key, value);\n          onChangeKey('Your key here');\n          onChangeValue('Your value here');\n        }}\n      />\n      <Text style={styles.paragraph}>\uD83D\uDD10 Enter your key \uD83D\uDD10</Text>\n      <TextInput\n        style={styles.textInput}\n        onSubmitEditing={event => {\n          getValueFor(event.nativeEvent.text);\n        }}\n        placeholder=\"Enter the key for the value you want to get\"\n      />\n    </View>\n  );\n}\n\n/* @hide const styles = StyleSheet.create({ ... }); */\nconst styles = StyleSheet.create({\n  container: {\n    flex: 1,\n    justifyContent: 'center',\n    paddingTop: 10,\n    backgroundColor: '#ecf0f1',\n    padding: 8,\n  },\n  paragraph: {\n    marginTop: 34,\n    margin: 24,\n    fontSize: 18,\n    fontWeight: 'bold',\n    textAlign: 'center',\n  },\n  textInput: {\n    height: 35,\n    borderColor: 'gray',\n    borderWidth: 0.5,\n    padding: 4,\n  },\n});\n/* @end */\n"})})}),"\n",(0,r.jsx)(n.h2,{id:"api",children:"API"}),"\n",(0,r.jsx)(n.pre,{children:(0,r.jsx)(n.code,{className:"language-js",children:"import * as SecureStore from 'expo-secure-store';\n"})}),"\n",(0,r.jsx)(o.Z,{packageName:"expo-secure-store",apiName:"SecureStore"})]})}n.default=function(){let e=arguments.length>0&&void 0!==arguments[0]?arguments[0]:{},{wrapper:n}=Object.assign({},(0,s.ah)(),e.components);return n?(0,r.jsx)(n,Object.assign({},e,{children:(0,r.jsx)(d,e)})):d(e)}}},function(e){e.O(0,[67328,9218,49774,92888,40179],function(){return e(e.s=91373)}),_N_E=e.O()}]);