(self.webpackChunk_N_E=self.webpackChunk_N_E||[]).push([[78226],{37204:function(e,n,t){(window.__NEXT_P=window.__NEXT_P||[]).push(["/versions/v48.0.0/sdk/video",function(){return t(13152)}])},13152:function(e,n,t){"use strict";t.r(n),t.d(n,{__N_SSG:function(){return c},headings:function(){return h},meta:function(){return l}});var s=t(85893),o=t(11151),i=t(60308),a=t(70111),r=t(51066),d=t(52892),c=!0;let l={title:"Video",sourceCodeUrl:"https://github.com/expo/expo/tree/sdk-48/packages/expo-av",packageName:"expo-av",iconUrl:"/static/images/packages/expo-av.png"},h=[{depth:2,type:"text",title:"Installation"},{depth:2,type:"text",title:"Usage"},{depth:2,type:"text",title:"API"},{depth:2,type:"text",title:"Unified API"}];function p(e){let n=Object.assign({p:"p",code:"code",strong:"strong",a:"a",h2:"h2",pre:"pre"},(0,o.ah)(),e.components);return(0,s.jsxs)(s.Fragment,{children:[(0,s.jsxs)(n.p,{children:["The ",(0,s.jsx)(n.code,{children:"Video"})," component from ",(0,s.jsx)(n.strong,{children:(0,s.jsx)(n.code,{children:"expo-av"})})," displays a video inline with the other UI elements in your app."]}),"\n",(0,s.jsxs)(n.p,{children:["Much of Video and Audio have common APIs that are documented in ",(0,s.jsx)(n.a,{href:"/versions/v48.0.0/sdk/av/",children:"AV documentation"}),". This page covers video-specific props and APIs. We encourage you to skim through this document to get basic video working, and then move on to ",(0,s.jsx)(n.a,{href:"/versions/v48.0.0/sdk/av/",children:"AV documentation"})," for more advanced functionality. The audio experience of video (such as whether to interrupt music already playing in another app, or whether to play sound while the phone is on silent mode) can be customized using the ",(0,s.jsx)(n.a,{href:"/versions/v48.0.0/sdk/audio/",children:"Audio API"}),"."]}),"\n",(0,s.jsx)(r.Z,{android:!0,emulator:!0,ios:!0,simulator:!0,web:!0}),"\n",(0,s.jsx)(n.h2,{id:"installation",children:"Installation"}),"\n",(0,s.jsx)(a.F,{}),"\n",(0,s.jsx)(n.h2,{id:"usage",children:"Usage"}),"\n",(0,s.jsx)(n.p,{children:"Here's a simple example of a video with a play/pause button."}),"\n",(0,s.jsx)(d.EA,{label:"Video",dependencies:["expo-av","expo-asset"],children:(0,s.jsx)(n.pre,{children:(0,s.jsx)(n.code,{className:"language-jsx",children:"import * as React from 'react';\nimport { View, StyleSheet, Button } from 'react-native';\nimport { Video, ResizeMode } from 'expo-av';\n\nexport default function App() {\n  const video = React.useRef(null);\n  const [status, setStatus] = React.useState({});\n  return (\n    <View style={styles.container}>\n      <Video\n        ref={video}\n        style={styles.video}\n        source={{\n          uri: 'https://d23dyxeqlo5psv.cloudfront.net/big_buck_bunny.mp4',\n        }}\n        useNativeControls\n        resizeMode={ResizeMode.CONTAIN}\n        isLooping\n        onPlaybackStatusUpdate={status => setStatus(() => status)}\n      />\n      <View style={styles.buttons}>\n        <Button\n          title={status.isPlaying ? 'Pause' : 'Play'}\n          onPress={() =>\n            status.isPlaying ? video.current.pauseAsync() : video.current.playAsync()\n          }\n        />\n      </View>\n    </View>\n  );\n}\n\n/* @hide const styles = StyleSheet.create({ ... }); */\nconst styles = StyleSheet.create({\n  container: {\n    flex: 1,\n    justifyContent: 'center',\n    backgroundColor: '#ecf0f1',\n  },\n  video: {\n    alignSelf: 'center',\n    width: 320,\n    height: 200,\n  },\n  buttons: {\n    flexDirection: 'row',\n    justifyContent: 'center',\n    alignItems: 'center',\n  },\n});\n/* @end */\n"})})}),"\n",(0,s.jsxs)(n.p,{children:["For more advanced examples, check out the ",(0,s.jsx)(n.a,{href:"https://github.com/expo/playlist-example/blob/master/App.js",children:"Playlist example"}),", and the ",(0,s.jsxs)(n.a,{href:"https://github.com/ihmpavel/expo-video-player/blob/master/lib/index.tsx",children:["custom ",(0,s.jsx)(n.code,{children:"VideoPlayer"})," controls component"]})," that wraps ",(0,s.jsx)(n.code,{children:"<Video>"}),", adds custom controls and use the ",(0,s.jsx)(n.code,{children:"<Video>"})," API extensively. The ",(0,s.jsx)(n.code,{children:"VideoPlayer"})," controls is used in ",(0,s.jsx)(n.a,{href:"https://github.com/expo/harvard-cs50-app",children:"this app"}),"."]}),"\n",(0,s.jsx)(n.h2,{id:"api",children:"API"}),"\n",(0,s.jsx)(n.pre,{children:(0,s.jsx)(n.code,{className:"language-js",children:"import { Video } from 'expo-av';\n"})}),"\n",(0,s.jsx)(i.Z,{packageName:"expo-video",apiName:"Video",strictTypes:!0}),"\n",(0,s.jsx)(n.h2,{id:"unified-api",children:"Unified API"}),"\n",(0,s.jsxs)(n.p,{children:["The rest of the API on the ",(0,s.jsx)(n.code,{children:"Video"})," component ",(0,s.jsx)(n.code,{children:"ref"})," is the same as the API for ",(0,s.jsx)(n.code,{children:"Audio.Sound"})," - see the ",(0,s.jsx)(n.a,{href:"/versions/v48.0.0/sdk/av/#playback",children:"AV documentation"})," for further information."]})]})}n.default=function(){let e=arguments.length>0&&void 0!==arguments[0]?arguments[0]:{},{wrapper:n}=Object.assign({},(0,o.ah)(),e.components);return n?(0,s.jsx)(n,Object.assign({},e,{children:(0,s.jsx)(p,e)})):p(e)}}},function(e){e.O(0,[67328,9218,49774,92888,40179],function(){return e(e.s=37204)}),_N_E=e.O()}]);